Imports MySql.Data

Public Class camarero_bd

    Public Structure camarero_reg
        Dim id As Integer
        Dim nombre As String
        Dim apellido1 As String
        Dim apellido2 As String
        Dim foto As String
    End Structure

    Public Structure camarero_clave
        Dim id As String
    End Structure

    Public Shared Function get_camarero(ByVal tmp_camarero_clave As camarero_clave, ByVal cadena_conexion As String) As camarero_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_camarero_reg As New camarero_reg

        Try
            strSQL = " SELECT * FROM camarero WHERE id = " & tmp_camarero_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_camarero_reg.id = lector("id")
                            tmp_camarero_reg.nombre = lector("nombre")
                            tmp_camarero_reg.apellido1 = lector("apellido1")
                            tmp_camarero_reg.apellido2 = lector("apellido2")
                            tmp_camarero_reg.foto = lector("foto")
                        Else
                            tmp_camarero_reg = error_camarero()
                        End If
                    Else
                        tmp_camarero_reg = error_camarero()
                    End If
                End With

            Catch ex As Exception
                tmp_camarero_reg = error_camarero()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_camarero_reg = error_camarero()
        End Try

        Return tmp_camarero_reg

    End Function

    Public Shared Function get_camareros_prefijo(ByVal prefijo As String, ByVal cadena_conexion As String) As String()
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_camarero_reg As New camarero_reg
        Dim lista As New ArrayList
        Dim camareros_array As String() = Nothing
        Dim i As Integer = 0

        Try
            strSQL = " SELECT DISTINCT id, nombre, apellido1, apellido2 FROM camarero WHERE (nombre LIKE '%" & prefijo & "%') or (apellido1 LIKE '%" & prefijo & "%') or (apellido2 LIKE '%" & prefijo & "%') ORDER BY apellido1, apellido2, nombre ASC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    While .Read()
                        If Not (lector Is Nothing) Then
                            tmp_camarero_reg.id = lector("id")
                            tmp_camarero_reg.nombre = lector("nombre")
                            tmp_camarero_reg.apellido1 = lector("apellido1")
                            tmp_camarero_reg.apellido2 = lector("apellido2")
                        Else
                            tmp_camarero_reg = error_camarero()
                        End If
                        lista.Add(tmp_camarero_reg)
                    End While
                End With

            Catch ex As Exception
                tmp_camarero_reg = error_camarero()
                lista.Add(tmp_camarero_reg)
            End Try

            'Cierro la conexion
            conexion.Close()

            ' Reservo memoria para el array
            ReDim camareros_array(lista.Count - 1)

            ' Copio el arraylist al array
            For Each camarero In lista
                camareros_array(i) = CType(camarero, camarero_reg).nombre & " " & CType(camarero, camarero_reg).apellido1 & " " & CType(camarero, camarero_reg).apellido2 & " (" & CType(camarero, camarero_reg).id & ")"
                i = i + 1
            Next

        Catch e As Exception
            tmp_camarero_reg = error_camarero()
            lista.Add(tmp_camarero_reg)
        End Try

        Return camareros_array

    End Function

    Public Shared Function get_todos_camareros_strsql(ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim strSQL As String

        Try
            strSQL = " SELECT * FROM camarero ORDER BY id "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            comando = Nothing
        End Try

        Return comando

    End Function

    Public Shared Function insertar_camarero(ByVal tmp_camarero_reg As camarero_reg, ByVal cadena_conexion As String) As camarero_clave
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String
        Dim tmp_camarero_clave As camarero_clave

        Try
            strSQL = " INSERT INTO camarero(id,nombre,apellido1,apellido2,foto) VALUES (" & tmp_camarero_reg.id & ",'" & tmp_camarero_reg.nombre & "','" & tmp_camarero_reg.apellido1 & "','" & tmp_camarero_reg.apellido2 & "','" & tmp_camarero_reg.foto & "') "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()
            Try
                tmp_camarero_clave.id = comando.LastInsertedId
            Catch ex As Exception
                tmp_camarero_clave.id = -1
            End Try

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                tmp_camarero_clave.id = -1
            End If

        Catch ex As Exception
            tmp_camarero_clave.id = -1
        End Try

        Return tmp_camarero_clave

    End Function

    Public Shared Function actualizar_camarero(ByVal tmp_camarero_reg As camarero_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " UPDATE camarero SET nombre = '" & tmp_camarero_reg.nombre & "',apellido1 = '" & tmp_camarero_reg.apellido1 & "',apellido2 = '" & tmp_camarero_reg.apellido2 & "',foto = '" & tmp_camarero_reg.foto & "' WHERE id = " & tmp_camarero_reg.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_varios_camareros(ByVal camareros As List(Of Integer), ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String
        Dim lista_str As String = ""

        Try
            For Each item In camareros
                If item = camareros.Last Then
                    lista_str += item.ToString
                Else
                    lista_str += item.ToString & ", "
                End If
            Next

            strSQL = " DELETE FROM camarero WHERE id IN (" & lista_str & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function existe_camarero(ByVal tmp_camarero_clave As camarero_clave, ByVal cadena_conexion As String) As Boolean

        If es_error_camarero(get_camarero(tmp_camarero_clave, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_camarero() As camarero_reg
        Dim tmp_camarero_reg As camarero_reg

        tmp_camarero_reg.id = -1
        tmp_camarero_reg.nombre = ""
        tmp_camarero_reg.apellido1 = ""
        tmp_camarero_reg.apellido2 = ""
        tmp_camarero_reg.foto = ""

        Return tmp_camarero_reg
    End Function

    Public Shared Function es_error_camarero(ByVal tmp_camarero_reg As camarero_reg) As Boolean
        If tmp_camarero_reg.id = -1 Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
