Imports MySql.Data
Imports accesoBDeRestaurante.usuario_bd

Public Class cliente_bd

    Public Structure cliente_reg
        Dim id As Integer
        Dim nombre As String
        Dim apellido1 As String
        Dim apellido2 As String
        Dim telefono As String
        Dim email As String
        Dim FK_usuario As Integer
    End Structure

    Public Structure cliente_clave
        Dim id As String
    End Structure

    Public Shared Function get_cliente(ByVal tmp_cliente_clave As cliente_clave, ByVal cadena_conexion As String) As cliente_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_cliente_reg As New cliente_reg

        Try
            strSQL = " SELECT * FROM cliente WHERE id = " & tmp_cliente_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_cliente_reg.id = lector("id")
                            tmp_cliente_reg.nombre = lector("nombre")
                            tmp_cliente_reg.apellido1 = lector("apellido1")
                            tmp_cliente_reg.apellido2 = lector("apellido2")
                            tmp_cliente_reg.telefono = lector("telefono")
                            tmp_cliente_reg.email = lector("email")
                            tmp_cliente_reg.FK_usuario = lector("FK_usuario")
                        Else
                            tmp_cliente_reg = error_cliente()
                        End If
                    Else
                        tmp_cliente_reg = error_cliente()
                    End If
                End With

            Catch ex As Exception
                tmp_cliente_reg = error_cliente()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_cliente_reg = error_cliente()
        End Try

        Return tmp_cliente_reg

    End Function

    Public Shared Function get_cliente_FKUsuario(ByVal tmp_usuario_clave As usuario_clave, ByVal cadena_conexion As String) As cliente_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_cliente_reg As New cliente_reg

        Try
            strSQL = " SELECT * FROM cliente WHERE FK_Usuario = " & tmp_usuario_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_cliente_reg.id = lector("id")
                            tmp_cliente_reg.nombre = lector("nombre")
                            tmp_cliente_reg.apellido1 = lector("apellido1")
                            tmp_cliente_reg.apellido2 = lector("apellido2")
                            tmp_cliente_reg.telefono = lector("telefono")
                            tmp_cliente_reg.email = lector("email")
                            tmp_cliente_reg.FK_usuario = lector("FK_usuario")
                        Else
                            tmp_cliente_reg = error_cliente()
                        End If
                    Else
                        tmp_cliente_reg = error_cliente()
                    End If
                End With

            Catch ex As Exception
                tmp_cliente_reg = error_cliente()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_cliente_reg = error_cliente()
        End Try

        Return tmp_cliente_reg

    End Function

    Public Shared Function get_clientes_prefijo(ByVal prefijo As String, ByVal cadena_conexion As String) As String()
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_cliente_reg As New cliente_reg
        Dim lista As New ArrayList
        Dim clientes_array As String() = Nothing
        Dim i As Integer = 0

        Try
            strSQL = " SELECT DISTINCT id, nombre, apellido1, apellido2 FROM cliente WHERE (nombre LIKE '%" & prefijo & "%') or (apellido1 LIKE '%" & prefijo & "%') or (apellido2 LIKE '%" & prefijo & "%') ORDER BY apellido1, apellido2, nombre ASC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    While .Read()
                        If Not (lector Is Nothing) Then
                            tmp_cliente_reg.id = lector("id")
                            tmp_cliente_reg.nombre = lector("nombre")
                            tmp_cliente_reg.apellido1 = lector("apellido1")
                            tmp_cliente_reg.apellido2 = lector("apellido2")
                        Else
                            tmp_cliente_reg = error_cliente()
                        End If
                        lista.Add(tmp_cliente_reg)
                    End While
                End With

            Catch ex As Exception
                tmp_cliente_reg = error_cliente()
                lista.Add(tmp_cliente_reg)
            End Try

            'Cierro la conexion
            conexion.Close()

            ' Reservo memoria para el array
            ReDim clientes_array(lista.Count - 1)

            ' Copio el arraylist al array
            For Each cliente In lista
                clientes_array(i) = CType(cliente, cliente_reg).nombre & " " & CType(cliente, cliente_reg).apellido1 & " " & CType(cliente, cliente_reg).apellido2 & " (" & CType(cliente, cliente_reg).id & ")"
                i = i + 1
            Next

        Catch e As Exception
            tmp_cliente_reg = error_cliente()
            lista.Add(tmp_cliente_reg)
        End Try

        Return clientes_array

    End Function

    Public Shared Function get_todos_clientes_str(ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim strSQL As String

        Try
            strSQL = " SELECT DISTINCT C.* "
            strSQL += "FROM cliente C "
            strSQL += " ORDER BY C.apellido1 "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            comando = Nothing
        End Try

        Return comando

    End Function

    Public Shared Function insertar_cliente(ByVal tmp_cliente_reg As cliente_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " INSERT INTO cliente(id,nombre,telefono,apellido1,apellido2,email,FK_usuario) VALUES (" & tmp_cliente_reg.id & ",'" & tmp_cliente_reg.nombre & "','" & tmp_cliente_reg.telefono & "','" & tmp_cliente_reg.apellido1 & "','" & tmp_cliente_reg.apellido2 & "','" & tmp_cliente_reg.email & "'," & tmp_cliente_reg.FK_usuario & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function actualizar_cliente(ByVal tmp_cliente_reg As cliente_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " UPDATE cliente SET nombre = '" & tmp_cliente_reg.nombre & "',telefono = '" & tmp_cliente_reg.telefono & "',apellido1 = '" & tmp_cliente_reg.apellido1 & "',apellido2 = '" & tmp_cliente_reg.apellido2 & "',email = '" & tmp_cliente_reg.email & "',FK_usuario = " & tmp_cliente_reg.FK_usuario & " WHERE id = " & tmp_cliente_reg.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function existe_cliente(ByVal tmp_cliente_clave As cliente_clave, ByVal cadena_conexion As String) As Boolean

        If es_error_cliente(get_cliente(tmp_cliente_clave, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_cliente() As cliente_reg
        Dim tmp_cliente_reg As cliente_reg

        tmp_cliente_reg.id = -1
        tmp_cliente_reg.nombre = ""
        tmp_cliente_reg.apellido1 = ""
        tmp_cliente_reg.apellido2 = ""
        tmp_cliente_reg.telefono = ""
        tmp_cliente_reg.email = ""
        tmp_cliente_reg.FK_usuario = -1

        Return tmp_cliente_reg
    End Function

    Public Shared Function es_error_cliente(ByVal tmp_cliente_reg As cliente_reg) As Boolean
        If tmp_cliente_reg.id = -1 Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
