Imports MySql.Data

Public Class comentario_bd

    Public Structure comentario_reg
        Dim id As Integer
        Dim desde As String
        Dim asunto As String
        Dim comentario As String
        Dim fecha As DateTime
    End Structure

    Public Structure comentario_clave
        Dim id As String
    End Structure

    Public Shared Function get_comentario(ByVal tmp_comentario_clave As comentario_clave, ByVal cadena_conexion As String) As comentario_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_comentario_reg As New comentario_reg

        Try
            strSQL = " SELECT * FROM comentario WHERE id = " & tmp_comentario_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_comentario_reg.id = lector("id")
                            tmp_comentario_reg.desde = lector("desde")
                            tmp_comentario_reg.asunto = lector("asunto")
                            tmp_comentario_reg.comentario = lector("comentario")
                            tmp_comentario_reg.fecha = lector("fecha")
                        Else
                            tmp_comentario_reg = error_comentario()
                        End If
                    Else
                        tmp_comentario_reg = error_comentario()
                    End If
                End With

            Catch ex As Exception
                tmp_comentario_reg = error_comentario()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_comentario_reg = error_comentario()
        End Try

        Return tmp_comentario_reg

    End Function

    Public Shared Function get_todos_comentarios_str(ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim strSQL As String

        Try
            strSQL = " SELECT DISTINCT C.* "
            strSQL += "FROM comentario C "
            strSQL += " ORDER BY C.fecha DESC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            comando = Nothing
        End Try

        Return comando

    End Function

    Public Shared Function insertar_comentario(ByVal tmp_comentario_reg As comentario_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " INSERT INTO comentario(id,desde,asunto,comentario,fecha) VALUES (" & tmp_comentario_reg.id & ",'" & tmp_comentario_reg.desde & "','" & tmp_comentario_reg.asunto & "','" & tmp_comentario_reg.comentario & "', '" & Ayudador.ToFechaYYMMDDHHMMSS(tmp_comentario_reg.fecha) & "') "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function actualizar_comentario(ByVal tmp_comentario_reg As comentario_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " UPDATE comentario SET desde = '" & tmp_comentario_reg.desde & "',asunto = '" & tmp_comentario_reg.asunto & "',comentario = '" & tmp_comentario_reg.comentario & "',fecha= '" & Ayudador.ToFechaYYMMDDHHMMSS(tmp_comentario_reg.fecha) & "' WHERE id = " & tmp_comentario_reg.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_comentario(ByVal comentario As comentario_clave, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try

            strSQL = " DELETE FROM comentario WHERE id = " & comentario.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_varios_comentarios(ByVal comentarios As List(Of Integer), ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String
        Dim lista_str As String = ""

        Try
            For Each item In comentarios
                If item = comentarios.Last Then
                    lista_str += item.ToString
                Else
                    lista_str += item.ToString & ", "
                End If
            Next

            strSQL = " DELETE FROM comentario WHERE id IN (" & lista_str & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function existe_comentario(ByVal tmp_comentario_clave As comentario_clave, ByVal cadena_conexion As String) As Boolean

        If es_error_comentario(get_comentario(tmp_comentario_clave, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_comentario() As comentario_reg
        Dim tmp_comentario_reg As comentario_reg

        tmp_comentario_reg.id = -1
        tmp_comentario_reg.desde = ""
        tmp_comentario_reg.asunto = ""
        tmp_comentario_reg.comentario = ""
        tmp_comentario_reg.fecha = New Date(1990, 1, 1)

        Return tmp_comentario_reg
    End Function

    Public Shared Function es_error_comentario(ByVal tmp_comentario_reg As comentario_reg) As Boolean
        If (tmp_comentario_reg.id) = -1 Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
