Imports MySql.Data
Imports accesoBDeRestaurante.pedido_bd

Public Class consumicion_bd

    Public Structure consumicion_reg
        Dim id As Integer
        Dim cantidad As Integer
        Dim precio As Decimal
        Dim servida As Integer
        Dim FK_pedido As Integer
        Dim FK_itemconsumicion As Integer
    End Structure

    Public Structure consumicion_clave
        Dim id As String
    End Structure

    Public Shared Function get_consumicion(ByVal tmp_consumicion_clave As consumicion_clave, ByVal cadena_conexion As String) As consumicion_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_consumicion_reg As New consumicion_reg

        Try
            strSQL = " SELECT * FROM consumicion WHERE id = " & tmp_consumicion_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_consumicion_reg.id = lector("id")
                            Try
                                tmp_consumicion_reg.cantidad = lector("cantidad")
                            Catch ex As Exception
                                tmp_consumicion_reg.cantidad = 0
                            End Try
                            Try
                                tmp_consumicion_reg.precio = lector("precio")
                            Catch ex As Exception
                                tmp_consumicion_reg.precio = 0.0
                            End Try
                            Try
                                tmp_consumicion_reg.servida = lector("servida")
                            Catch ex As Exception
                                tmp_consumicion_reg.servida = 0
                            End Try
                            Try
                                tmp_consumicion_reg.FK_pedido = lector("FK_pedido")
                            Catch ex As Exception
                                tmp_consumicion_reg.FK_pedido = -1
                            End Try
                            Try
                                tmp_consumicion_reg.FK_itemconsumicion = lector("FK_itemconsumicion")
                            Catch ex As Exception
                                tmp_consumicion_reg.FK_itemconsumicion = -1
                            End Try
                        Else
                            tmp_consumicion_reg = error_consumicion()
                        End If
                    Else
                        tmp_consumicion_reg = error_consumicion()
                    End If
                End With

            Catch ex As Exception
                tmp_consumicion_reg = error_consumicion()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_consumicion_reg = error_consumicion()
        End Try

        Return tmp_consumicion_reg

    End Function

    Public Shared Function get_consumiciones_pedido_str(ByVal tmp_pedido_clave As pedido_clave, ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand       
        Dim strSQL As String
        Dim tmp_consumicion_reg As New consumicion_reg
        Try
            strSQL = " SELECT C.id, I.tipo, I.nombre, C.cantidad, C.precio, C.servida, C.FK_itemconsumicion "
            strSQL += " FROM pedido P, consumicion C, itemconsumicion I "
            strSQL += "WHERE P.id = C.FK_Pedido AND I.id = C.FK_ItemConsumicion AND "
            strSQL += " P.id = " & tmp_pedido_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            comando = Nothing
        End Try

        Return comando

    End Function

    Public Shared Function get_num_consumiciones_sin_servir_pedido(ByVal tmp_pedido_clave As pedido_clave, ByVal cadena_conexion As String) As Integer
        Dim comando As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim ret As Integer = 0
        Dim strSQL As String = ""

        Try
            strSQL = " SELECT DISTINCT count(C.id) as num "
            strSQL += " FROM pedido P, consumicion C, itemconsumicion I "
            strSQL += "WHERE P.id = C.FK_Pedido AND I.id = C.FK_ItemConsumicion AND C.servida < C.cantidad AND "
            strSQL += " P.id = " & tmp_pedido_clave.id & " "

            conexion.Open()
            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader

            With lector
                If .Read() Then
                    If Not (lector Is Nothing) Then
                        ret = CInt(lector("num"))
                    End If
                End If
            End With

            'Cierro la conexion
            conexion.Close()

            If ret = -1 Then
                ret = 0
            End If
        Catch ex As Exception
            ret = -1
        End Try

        Return ret
    End Function

    Public Shared Function get_consumicion_FKPedido_FKItemConsumicion(ByVal tmp_consumicion_reg As consumicion_reg, ByVal cadena_conexion As String) As consumicion_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String

        Try
            strSQL = " SELECT * FROM consumicion WHERE FK_Pedido = " & tmp_consumicion_reg.FK_pedido & " AND FK_ItemConsumicion = " & tmp_consumicion_reg.FK_itemconsumicion & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_consumicion_reg.id = lector("id")
                            Try
                                tmp_consumicion_reg.cantidad = lector("cantidad")
                            Catch ex As Exception
                                tmp_consumicion_reg.cantidad = 0
                            End Try
                            Try
                                tmp_consumicion_reg.precio = lector("precio")
                            Catch ex As Exception
                                tmp_consumicion_reg.precio = 0.0
                            End Try
                            Try
                                tmp_consumicion_reg.servida = lector("servida")
                            Catch ex As Exception
                                tmp_consumicion_reg.servida = 0
                            End Try
                            Try
                                tmp_consumicion_reg.FK_pedido = lector("FK_pedido")
                            Catch ex As Exception
                                tmp_consumicion_reg.FK_pedido = -1
                            End Try
                            Try
                                tmp_consumicion_reg.FK_itemconsumicion = lector("FK_itemconsumicion")
                            Catch ex As Exception
                                tmp_consumicion_reg.FK_itemconsumicion = -1
                            End Try
                        Else
                            tmp_consumicion_reg = error_consumicion()
                        End If
                    Else
                        tmp_consumicion_reg = error_consumicion()
                    End If
                End With

            Catch ex As Exception
                tmp_consumicion_reg = error_consumicion()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_consumicion_reg = error_consumicion()
        End Try

        Return tmp_consumicion_reg

    End Function

    Public Shared Function insertar_consumicion(ByVal tmp_consumicion_reg As consumicion_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " INSERT INTO consumicion(id,cantidad,FK_pedido,precio,servida,FK_itemconsumicion) VALUES (" & tmp_consumicion_reg.id & "," & tmp_consumicion_reg.cantidad & "," & tmp_consumicion_reg.FK_pedido & ",'" & Ayudador.ToCurrencyDecimal(tmp_consumicion_reg.precio) & "'," & tmp_consumicion_reg.servida & "," & tmp_consumicion_reg.FK_itemconsumicion & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function actualizar_consumicion(ByVal tmp_consumicion_reg As consumicion_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " UPDATE consumicion SET cantidad = " & tmp_consumicion_reg.cantidad & ",FK_pedido = " & tmp_consumicion_reg.FK_pedido & ",precio = '" & Ayudador.ToCurrencyDecimal(tmp_consumicion_reg.precio) & "',servida = " & tmp_consumicion_reg.servida & ",FK_itemconsumicion = " & tmp_consumicion_reg.FK_itemconsumicion & " WHERE id = " & tmp_consumicion_reg.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_consumicion(ByVal tmp_consumicion_clave As consumicion_clave, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String
        Dim lista_str As String = ""

        Try
            strSQL = " DELETE FROM consumicion WHERE id = " & tmp_consumicion_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Public Shared Function existe_consumicion(ByVal tmp_consumicion_clave As consumicion_clave, ByVal cadena_conexion As String) As Boolean

        If es_error_consumicion(get_consumicion(tmp_consumicion_clave, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Public Shared Function existe_consumicion_FKPedido_FKItemConsumicion(ByVal tmp_consumicion_reg As consumicion_reg, ByVal cadena_conexion As String) As Boolean

        If es_error_consumicion(get_consumicion_FKPedido_FKItemConsumicion(tmp_consumicion_reg, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_consumicion() As consumicion_reg
        Dim tmp_consumicion_reg As consumicion_reg

        tmp_consumicion_reg.id = -1
        tmp_consumicion_reg.cantidad = 0
        tmp_consumicion_reg.precio = 0.0
        tmp_consumicion_reg.servida = 0
        tmp_consumicion_reg.FK_pedido = -1
        tmp_consumicion_reg.FK_itemconsumicion = -1

        Return tmp_consumicion_reg
    End Function

    Public Shared Function es_error_consumicion(ByVal tmp_consumicion_reg As consumicion_reg) As Boolean
        If (tmp_consumicion_reg.id) = -1 Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
