Imports MySql.Data
Imports accesoBDeRestaurante.tipoproducto_bd

Public Class itemconsumicion_bd

    Public Structure itemconsumicion_reg
        Dim id As Integer
        Dim tipo As String
        Dim nombre As String
        Dim descripcion As String
        Dim precio As Decimal
    End Structure

    Public Structure itemconsumicion_clave
        Dim id As String
    End Structure

    Public Shared Function get_itemconsumicion(ByVal tmp_itemconsumicion_clave As itemconsumicion_clave, ByVal cadena_conexion As String) As itemconsumicion_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_itemconsumicion_reg As New itemconsumicion_reg

        Try
            strSQL = " SELECT * FROM itemconsumicion WHERE id = " & tmp_itemconsumicion_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_itemconsumicion_reg.id = lector("id")
                            tmp_itemconsumicion_reg.tipo = lector("tipo")
                            tmp_itemconsumicion_reg.nombre = lector("nombre")
                            tmp_itemconsumicion_reg.descripcion = lector("descripcion")
                            Try
                                tmp_itemconsumicion_reg.precio = lector("precio")
                            Catch ex As Exception
                                tmp_itemconsumicion_reg.precio = 0.0
                            End Try
                        Else
                            tmp_itemconsumicion_reg = error_itemconsumicion()
                        End If
                    Else
                        tmp_itemconsumicion_reg = error_itemconsumicion()
                    End If
                End With

            Catch ex As Exception
                tmp_itemconsumicion_reg = error_itemconsumicion()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_itemconsumicion_reg = error_itemconsumicion()
        End Try

        Return tmp_itemconsumicion_reg

    End Function

    Public Shared Function get_itemconsumiciones_tipo_strsql(ByVal tmp_tipoproducto_clave As tipoproducto_clave, ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim strSQL As String = ""

        Try
            If tmp_tipoproducto_clave.id <> -1 Then
                ' Si la clave del tipo de producto es diferente de -1
                strSQL = " SELECT I.* "
                strSQL = strSQL & "FROM producto P, itemconsumicion I, tipoproducto T "
                strSQL = strSQL & "WHERE P.FK_TipoProducto = T.id "
                strSQL = strSQL & "AND P.FK_ItemConsumicion = I.id "
                strSQL = strSQL & "AND T.id = " & tmp_tipoproducto_clave.id & " "
                strSQL = strSQL & "ORDER BY P.id ASC"
            Else
                'Si la clave del tipo de producto es -1 significa que el tipo de producto es NULL
                strSQL = " SELECT I.* "
                strSQL = strSQL & "FROM producto P, itemconsumicion I "
                strSQL = strSQL & "WHERE P.FK_TipoProducto IS NULL "
                strSQL = strSQL & "AND P.FK_ItemConsumicion = I.id "
                strSQL = strSQL & "ORDER BY P.id ASC"
            End If

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            comando = Nothing
        End Try

        Return comando
    End Function

    Public Shared Function get_itemconsumiciones_menu_strsql(ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim strSQL As String = ""

        Try
            strSQL = " SELECT I.* "
            strSQL = strSQL & "FROM menu M, itemconsumicion I, tipoproducto T "
            strSQL = strSQL & "WHERE M.FK_ItemConsumicion = I.id "
            strSQL = strSQL & "GROUP BY I.id "
            strSQL = strSQL & "ORDER BY M.id ASC"

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            comando = Nothing
        End Try

        Return comando
    End Function

    Public Shared Function get_itemconsumiciones_tipo(ByVal tmp_tipoproducto_clave As tipoproducto_clave, ByVal sin_tipo As Boolean, ByVal cadena_conexion As String) As List(Of itemconsumicion_reg)
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_itemconsumicion_reg As New itemconsumicion_reg
        Dim productos_list As New List(Of itemconsumicion_reg)

        Try
            strSQL = " SELECT I.* "
            If Not sin_tipo Then
                strSQL = strSQL & "FROM producto P, itemconsumicion I, tipoproducto T "
            Else
                strSQL = strSQL & "FROM producto P, itemconsumicion I "
            End If

            strSQL = strSQL & "WHERE "

            If Not sin_tipo Then
                strSQL = strSQL & "P.FK_TipoProducto = T.id AND"
            End If
            strSQL = strSQL & " P.FK_ItemConsumicion = I.id "
            If Not sin_tipo Then
                strSQL = strSQL & "AND T.id = " & tmp_tipoproducto_clave.id & " "
            Else
                strSQL = strSQL & "AND P.FK_TipoProducto IS NULL "
            End If
            strSQL = strSQL & "AND I.tipo = 'P' "

            strSQL = strSQL & "ORDER BY P.id ASC"

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .HasRows Then
                        While .Read()
                            If Not (lector Is Nothing) Then
                                tmp_itemconsumicion_reg.id = lector("id")
                                tmp_itemconsumicion_reg.tipo = lector("tipo")
                                tmp_itemconsumicion_reg.nombre = lector("nombre")
                                tmp_itemconsumicion_reg.descripcion = lector("descripcion")
                                productos_list.Add(tmp_itemconsumicion_reg)
                            End If
                        End While
                    End If
                End With

            Catch ex As Exception

            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception

        End Try

        Return productos_list

    End Function

    Public Shared Function get_itemconsumiciones_dif_tipo(ByVal tmp_tipoproducto_clave As tipoproducto_clave, ByVal cadena_conexion As String) As List(Of itemconsumicion_reg)
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_itemconsumicion_reg As New itemconsumicion_reg
        Dim productos_list As New List(Of itemconsumicion_reg)

        Try
            strSQL = "SELECT I.* "
            strSQL = strSQL & "FROM (itemconsumicion I LEFT OUTER JOIN producto P ON P.FK_itemconsumicion = I.id) "
            strSQL = strSQL & "LEFT OUTER JOIN tipoproducto T ON P.FK_tipoproducto = T.id "
            strSQL = strSQL & " WHERE I.tipo = 'P' And (P.FK_tipoproducto <> " & tmp_tipoproducto_clave.id & " Or P.FK_tipoproducto Is NULL) "
            strSQL = strSQL & "GROUP BY I.id "
            strSQL = strSQL & "ORDER BY P.id ASC"

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .HasRows Then
                        While .Read()
                            If Not (lector Is Nothing) Then
                                tmp_itemconsumicion_reg.id = lector("id")
                                tmp_itemconsumicion_reg.tipo = lector("tipo")
                                tmp_itemconsumicion_reg.nombre = lector("nombre")
                                tmp_itemconsumicion_reg.descripcion = lector("descripcion")
                                productos_list.Add(tmp_itemconsumicion_reg)
                            End If
                        End While
                    End If
                End With

            Catch ex As Exception

            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception

        End Try

        Return productos_list

    End Function

    Public Shared Function insertar_itemconsumicion(ByVal tmp_itemconsumicion_reg As itemconsumicion_reg, ByVal cadena_conexion As String) As itemconsumicion_clave
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String
        Dim tmp_itemconsumicion_clave As itemconsumicion_clave

        Try
            strSQL = " INSERT INTO itemconsumicion(id,tipo,nombre,descripcion,precio) VALUES (" & tmp_itemconsumicion_reg.id & ",'" & tmp_itemconsumicion_reg.tipo & "','" & tmp_itemconsumicion_reg.nombre & "','" & tmp_itemconsumicion_reg.descripcion & "'," & Ayudador.ToCurrencyDecimal(tmp_itemconsumicion_reg.precio) & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()
            Try
                tmp_itemconsumicion_clave.id = comando.LastInsertedId
            Catch ex As Exception
                tmp_itemconsumicion_clave.id = -1
            End Try

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                tmp_itemconsumicion_clave.id = -1
            End If

        Catch ex As Exception
            tmp_itemconsumicion_clave.id = -1
        End Try

        Return tmp_itemconsumicion_clave

    End Function

    Public Shared Function actualizar_itemconsumicion(ByVal tmp_itemconsumicion_reg As itemconsumicion_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " UPDATE itemconsumicion SET tipo = '" & tmp_itemconsumicion_reg.tipo & "',nombre = '" & tmp_itemconsumicion_reg.nombre & "',descripcion = '" & tmp_itemconsumicion_reg.descripcion & "',precio = " & Ayudador.ToCurrencyDecimal(tmp_itemconsumicion_reg.precio) & " WHERE id = " & tmp_itemconsumicion_reg.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_itemconsumicion(ByVal itemconsumicion As itemconsumicion_clave, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try

            strSQL = " DELETE FROM itemconsumicion WHERE id = " & itemconsumicion.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_varios_itemsconsumicion(ByVal itemconsumicion As List(Of Integer), ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String
        Dim lista_str As String = ""

        Try
            For Each item In itemconsumicion
                If item = itemconsumicion.Last Then
                    lista_str += item.ToString
                Else
                    lista_str += item.ToString & ", "
                End If
            Next

            strSQL = " DELETE FROM itemconsumicion WHERE id IN (" & lista_str & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function existe_itemconsumicion(ByVal tmp_itemconsumicion_clave As itemconsumicion_clave, ByVal cadena_conexion As String) As Boolean

        If es_error_itemconsumicion(get_itemconsumicion(tmp_itemconsumicion_clave, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_itemconsumicion() As itemconsumicion_reg
        Dim tmp_itemconsumicion_reg As itemconsumicion_reg

        tmp_itemconsumicion_reg.id = -1
        tmp_itemconsumicion_reg.tipo = ""
        tmp_itemconsumicion_reg.nombre = ""
        tmp_itemconsumicion_reg.descripcion = ""
        tmp_itemconsumicion_reg.precio = 0.0

        Return tmp_itemconsumicion_reg
    End Function

    Public Shared Function es_error_itemconsumicion(ByVal tmp_itemconsumicion_reg As itemconsumicion_reg) As Boolean
        If (tmp_itemconsumicion_reg.id) = -1 Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
