Imports MySql.Data
Imports accesoBDeRestaurante.itemconsumicion_bd

Public Class menu_bd

    Public Structure menu_reg
        Dim id As Integer
        Dim FK_itemconsumicion As Integer
    End Structure

    Public Structure menu_clave
        Dim id As String
    End Structure

    Public Shared Function get_menu(ByVal tmp_menu_clave As menu_clave, ByVal cadena_conexion As String) As menu_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_menu_reg As New menu_reg

        Try
            strSQL = " SELECT * FROM menu WHERE id = " & tmp_menu_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_menu_reg.id = lector("id")
                            Try
                                tmp_menu_reg.FK_itemconsumicion = lector("FK_itemconsumicion")
                            Catch ex As Exception
                                tmp_menu_reg.FK_itemconsumicion = -1
                            End Try

                        Else
                            tmp_menu_reg = error_menu()
                        End If
                    Else
                        tmp_menu_reg = error_menu()
                    End If
                End With

            Catch ex As Exception
                tmp_menu_reg = error_menu()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_menu_reg = error_menu()
        End Try

        Return tmp_menu_reg

    End Function

    Public Shared Function get_todos_menu(ByVal cadena_conexion As String) As List(Of menu_reg)
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_menu_reg As New List(Of menu_reg)
        Dim tmp As menu_reg

        Try
            strSQL = " SELECT * FROM menu ORDER BY id ASC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()
            'Leo el registro 
            Try
                With lector
                    If .HasRows Then
                        While .Read()
                            If Not (lector Is Nothing) Then
                                tmp.id = lector("id")
                                Try
                                    tmp.FK_itemconsumicion = lector("FK_itemconsumicion")
                                Catch ex As Exception
                                    tmp.FK_itemconsumicion = -1
                                End Try
                                tmp_menu_reg.Add(tmp)
                            End If
                        End While
                    End If
                End With

            Catch ex As Exception

            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception

        End Try

        Return tmp_menu_reg

    End Function

    Public Shared Function get_menu_FKItemConsumicion(ByVal tmp_itemconsumicion_clave As itemconsumicion_clave, ByVal cadena_conexion As String) As menu_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_menu_reg As New menu_reg

        Try
            strSQL = " SELECT M.* "
            strSQL = strSQL & "FROM menu M, itemconsumicion I "
            strSQL = strSQL & "WHERE M.FK_ItemConsumicion = I.id  "
            strSQL = strSQL & "AND M.FK_ItemConsumicion = " & tmp_itemconsumicion_clave.id & " "
            strSQL = strSQL & "AND I.tipo = 'M' "
            strSQL = strSQL & "ORDER BY M.id ASC"

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .HasRows Then
                        If .Read() Then
                            If Not (lector Is Nothing) Then
                                tmp_menu_reg.id = lector("id")
                                tmp_menu_reg.FK_itemconsumicion = lector("FK_ItemConsumicion")
                            Else
                                tmp_menu_reg = error_menu()
                            End If
                        Else
                            tmp_menu_reg = error_menu()
                        End If
                    Else
                        tmp_menu_reg = error_menu()
                    End If
                End With

            Catch ex As Exception
                tmp_menu_reg = error_menu()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_menu_reg = error_menu()
        End Try

        Return tmp_menu_reg

    End Function

    Public Shared Function insertar_menu(ByVal tmp_menu_reg As menu_reg, ByVal cadena_conexion As String) As menu_clave
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String
        Dim tmp_menu_clave As menu_clave

        Try
            strSQL = " INSERT INTO menu(id,FK_itemconsumicion) VALUES (" & tmp_menu_reg.id & "," & tmp_menu_reg.FK_itemconsumicion & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()
            tmp_menu_clave.id = comando.LastInsertedId

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                tmp_menu_clave.id = -1
            End If

        Catch ex As Exception
            tmp_menu_clave.id = -1
        End Try

        Return tmp_menu_clave

    End Function

    Public Shared Function actualizar_menu(ByVal tmp_menu_reg As menu_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " UPDATE menu SET FK_itemconsumicion = " & tmp_menu_reg.FK_itemconsumicion & " WHERE id = " & tmp_menu_reg.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_menu(ByVal menu As menu_clave, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try

            strSQL = " DELETE FROM menu WHERE id = " & menu.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_varios_menu(ByVal menus As List(Of Integer), ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String
        Dim lista_str As String = ""

        Try
            For Each item In menus
                If item = menus.Last Then
                    lista_str += item.ToString
                Else
                    lista_str += item.ToString & ", "
                End If
            Next

            strSQL = " DELETE FROM menu WHERE id IN (" & lista_str & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function existe_menu(ByVal tmp_menu_clave As menu_clave, ByVal cadena_conexion As String) As Boolean

        If es_error_menu(get_menu(tmp_menu_clave, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_menu() As menu_reg
        Dim tmp_menu_reg As menu_reg

        tmp_menu_reg.id = -1
        tmp_menu_reg.FK_itemconsumicion = -1

        Return tmp_menu_reg
    End Function

    Public Shared Function es_error_menu(ByVal tmp_menu_reg As menu_reg) As Boolean
        If (tmp_menu_reg.id) = -1 Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
