Imports MySql.Data
Imports accesoBDeRestaurante.pedido_bd

Public Class mesa_bd

    Public Structure mesa_reg
        Dim id As Integer
        Dim numero As Integer
        Dim libre As Integer
        Dim max_personas As Integer
        Dim comensales As Integer
        Dim num_mesas As Integer
    End Structure

    Public Structure mesa_clave
        Dim id As String
    End Structure

    Public Shared Function get_mesa(ByVal tmp_mesa_clave As mesa_clave, ByVal cadena_conexion As String) As mesa_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_mesa_reg As New mesa_reg

        Try
            strSQL = " SELECT * FROM mesa WHERE id = " & tmp_mesa_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_mesa_reg.id = lector("id")
                            Try
                                tmp_mesa_reg.numero = lector("numero")
                            Catch ex As Exception
                                tmp_mesa_reg.numero = 0
                            End Try
                            Try
                                tmp_mesa_reg.libre = lector("libre")
                            Catch ex As Exception
                                tmp_mesa_reg.libre = 0
                            End Try
                            Try
                                tmp_mesa_reg.max_personas = lector("max_personas")
                            Catch ex As Exception
                                tmp_mesa_reg.max_personas = 0
                            End Try
                            Try
                                tmp_mesa_reg.comensales = lector("comensales")
                            Catch ex As Exception
                                tmp_mesa_reg.comensales = 0
                            End Try
                            Try
                                tmp_mesa_reg.num_mesas = lector("num_mesas")
                            Catch ex As Exception
                                tmp_mesa_reg.num_mesas = 0
                            End Try
                        Else
                            tmp_mesa_reg = error_mesa()
                        End If
                    Else
                        tmp_mesa_reg = error_mesa()
                    End If
                End With

            Catch ex As Exception
                tmp_mesa_reg = error_mesa()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_mesa_reg = error_mesa()
        End Try

        Return tmp_mesa_reg

    End Function

    Public Shared Function get_todas_mesas_str(ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim strSQL As String

        Try
            strSQL = " SELECT DISTINCT M.* "
            strSQL += "FROM mesa M "
            strSQL += " ORDER BY M.numero DESC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            comando = Nothing
        End Try

        Return comando

    End Function

    Public Shared Function insertar_mesa(ByVal tmp_mesa_reg As mesa_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " INSERT INTO mesa(id,numero,max_personas,libre,comensales,num_mesas) VALUES (" & tmp_mesa_reg.id & "," & tmp_mesa_reg.numero & "," & tmp_mesa_reg.max_personas & "," & tmp_mesa_reg.libre & "," & tmp_mesa_reg.comensales & "," & tmp_mesa_reg.num_mesas & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function actualizar_mesa(ByVal tmp_mesa_reg As mesa_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " UPDATE mesa SET numero = " & tmp_mesa_reg.numero & ",max_personas = " & tmp_mesa_reg.max_personas & ",libre = " & tmp_mesa_reg.libre & ",comensales = " & tmp_mesa_reg.comensales & ",num_mesas = " & tmp_mesa_reg.num_mesas & " WHERE id = " & tmp_mesa_reg.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_mesa(ByVal mesa As mesa_clave, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As New MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String
        Dim lista_pedidos As List(Of pedido_reg)

        Try

            strSQL = " DELETE FROM mesa WHERE id = " & mesa.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception

            Try
                ' Si tiene pedidos asignados no activos, desreferencio la mesa en los pedidos y la elimino
                If existen_pedidos_historico_FKMesa(mesa, cadena_conexion) Then
                    lista_pedidos = get_pedidos_historico_FKMesa(mesa, cadena_conexion)

                    For Each pedido In lista_pedidos
                        pedido.FK_mesa = Nothing
                        If Not actualizar_pedido(pedido, cadena_conexion) Then
                            Throw New Exception
                        End If
                    Next

                    'Ejecuto la consulta y guardo el num de filas devueltas
                    filas = comando.ExecuteNonQuery()

                    'Cierro la conexion
                    conexion.Close()

                    If filas <= 0 Then
                        ret_ok = False
                    End If

                End If
            Catch ex2 As Exception
                ret_ok = False
            End Try

        End Try

        Return ret_ok

    End Function

    Public Shared Function existe_mesa(ByVal tmp_mesa_clave As mesa_clave, ByVal cadena_conexion As String) As Boolean

        If es_error_mesa(get_mesa(tmp_mesa_clave, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_mesa() As mesa_reg
        Dim tmp_mesa_reg As mesa_reg

        tmp_mesa_reg.id = -1
        tmp_mesa_reg.numero = 0
        tmp_mesa_reg.libre = 0
        tmp_mesa_reg.max_personas = 0
        tmp_mesa_reg.comensales = 0
        tmp_mesa_reg.num_mesas = 0

        Return tmp_mesa_reg
    End Function

    Public Shared Function es_error_mesa(ByVal tmp_mesa_reg As mesa_reg) As Boolean
        If (tmp_mesa_reg.id) = -1 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Function esta_ocupada(ByVal tmp_mesa_clave As mesa_clave, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = False

        Try
            If existe_mesa(tmp_mesa_clave, cadena_conexion) Then
                If get_mesa(tmp_mesa_clave, cadena_conexion).libre = 0 Then
                    ret_ok = True
                End If
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function
End Class
