Imports MySql.Data
Imports accesoBDeRestaurante.cliente_bd
Imports accesoBDeRestaurante.mesa_bd
Imports accesoBDeRestaurante.camarero_bd

Public Class pedido_bd

    Public Structure pedido_reg
        Dim id As Integer
        Dim fecha As DateTime
        Dim precio As Decimal
        Dim pagado As Integer
        Dim confirmado As Integer
        Dim servido As Integer
        Dim activo As Integer
        Dim FK_cliente As Integer
        Dim FK_mesa As String
        Dim FK_camarero As String
    End Structure

    Public Structure pedido_clave
        Dim id As String
    End Structure

    Public Shared Function get_pedido(ByVal tmp_pedido_clave As pedido_clave, ByVal cadena_conexion As String) As pedido_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_pedido_reg As New pedido_reg

        Try
            strSQL = " SELECT * FROM pedido WHERE id = " & tmp_pedido_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_pedido_reg.id = lector("id")
                            Try
                                tmp_pedido_reg.fecha = lector("fecha")
                            Catch ex As Exception
                                tmp_pedido_reg.fecha = "01/01/1900"
                            End Try
                            Try
                                tmp_pedido_reg.precio = lector("precio")
                            Catch ex As Exception
                                tmp_pedido_reg.precio = 0.0
                            End Try
                            Try
                                tmp_pedido_reg.pagado = lector("pagado")
                            Catch ex As Exception
                                tmp_pedido_reg.pagado = 0
                            End Try
                            Try
                                tmp_pedido_reg.confirmado = lector("confirmado")
                            Catch ex As Exception
                                tmp_pedido_reg.confirmado = 0
                            End Try
                            Try
                                tmp_pedido_reg.servido = lector("servido")
                            Catch ex As Exception
                                tmp_pedido_reg.servido = 0
                            End Try
                            Try
                                tmp_pedido_reg.activo = lector("activo")
                            Catch ex As Exception
                                tmp_pedido_reg.activo = 0
                            End Try
                            Try
                                tmp_pedido_reg.FK_cliente = lector("FK_cliente")
                            Catch ex As Exception
                                tmp_pedido_reg.FK_cliente = -1
                            End Try
                            Try
                                tmp_pedido_reg.FK_mesa = lector("FK_mesa")
                            Catch ex As Exception
                                tmp_pedido_reg.FK_mesa = -1
                            End Try
                            Try
                                tmp_pedido_reg.FK_camarero = lector("FK_camarero")
                            Catch ex As Exception
                                tmp_pedido_reg.FK_camarero = -1
                            End Try
                        Else
                            tmp_pedido_reg = error_pedido()
                        End If
                    Else
                        tmp_pedido_reg = error_pedido()
                    End If
                End With

            Catch ex As Exception
                tmp_pedido_reg = error_pedido()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_pedido_reg = error_pedido()
        End Try

        Return tmp_pedido_reg

    End Function

    Public Shared Function get_pedido_actual(ByVal tmp_cliente_clave As cliente_clave, ByVal cadena_conexion As String) As pedido_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_pedido_reg As New pedido_reg

        Try
            strSQL = " SELECT * FROM pedido WHERE FK_Cliente = " & tmp_cliente_clave.id & " AND activo = 1 "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_pedido_reg.id = lector("id")
                            Try
                                tmp_pedido_reg.fecha = lector("fecha")
                            Catch ex As Exception
                                tmp_pedido_reg.fecha = "01/01/1900"
                            End Try
                            Try
                                tmp_pedido_reg.precio = lector("precio")
                            Catch ex As Exception
                                tmp_pedido_reg.precio = 0.0
                            End Try
                            Try
                                tmp_pedido_reg.pagado = lector("pagado")
                            Catch ex As Exception
                                tmp_pedido_reg.pagado = 0
                            End Try
                            Try
                                tmp_pedido_reg.confirmado = lector("confirmado")
                            Catch ex As Exception
                                tmp_pedido_reg.confirmado = 0
                            End Try
                            Try
                                tmp_pedido_reg.servido = lector("servido")
                            Catch ex As Exception
                                tmp_pedido_reg.servido = 0
                            End Try
                            Try
                                tmp_pedido_reg.activo = lector("activo")
                            Catch ex As Exception
                                tmp_pedido_reg.activo = 0
                            End Try
                            Try
                                tmp_pedido_reg.FK_cliente = lector("FK_cliente")
                            Catch ex As Exception
                                tmp_pedido_reg.FK_cliente = -1
                            End Try
                            Try
                                tmp_pedido_reg.FK_mesa = lector("FK_mesa")
                            Catch ex As Exception
                                tmp_pedido_reg.FK_mesa = -1
                            End Try
                            Try
                                tmp_pedido_reg.FK_camarero = lector("FK_camarero")
                            Catch ex As Exception
                                tmp_pedido_reg.FK_camarero = -1
                            End Try
                        Else
                            tmp_pedido_reg = error_pedido()
                        End If
                    Else
                        tmp_pedido_reg = error_pedido()
                    End If
                End With

            Catch ex As Exception
                tmp_pedido_reg = error_pedido()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_pedido_reg = error_pedido()
        End Try

        Return tmp_pedido_reg

    End Function

    Public Shared Function get_id_pedido_FKMesa(ByVal tmp_mesa_clave As mesa_clave, ByVal cadena_conexion As String) As Integer
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim id_pedido As Integer = -1

        Try
            strSQL = " SELECT DISTINCT P.id "
            strSQL += "FROM pedido P "
            strSQL += "WHERE P.FK_Mesa = " & tmp_mesa_clave.id & " AND P.activo = 1 "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            id_pedido = lector("id")
                        Else
                            id_pedido = -1
                        End If
                    Else
                        id_pedido = -1
                    End If
                End With

            Catch ex As Exception
                id_pedido = -1
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            id_pedido = -1
        End Try

        Return id_pedido

    End Function

    Public Shared Function get_pedidos_historico_FKMesa(ByVal tmp_mesa_clave As mesa_clave, ByVal cadena_conexion As String) As List(Of pedido_reg)
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim lista_pedidos As New List(Of pedido_reg)
        Dim tmp_pedido_reg As pedido_reg

        Try
            strSQL = " SELECT DISTINCT * "
            strSQL += "FROM pedido P "
            strSQL += "WHERE P.FK_Mesa = " & tmp_mesa_clave.id & " AND P.activo = 0 "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    While .Read()
                        If Not (lector Is Nothing) Then
                            tmp_pedido_reg.id = lector("id")
                            Try
                                tmp_pedido_reg.fecha = lector("fecha")
                            Catch ex As Exception
                                tmp_pedido_reg.fecha = "01/01/1900"
                            End Try
                            Try
                                tmp_pedido_reg.precio = lector("precio")
                            Catch ex As Exception
                                tmp_pedido_reg.precio = 0.0
                            End Try
                            Try
                                tmp_pedido_reg.pagado = lector("pagado")
                            Catch ex As Exception
                                tmp_pedido_reg.pagado = 0
                            End Try
                            Try
                                tmp_pedido_reg.confirmado = lector("confirmado")
                            Catch ex As Exception
                                tmp_pedido_reg.confirmado = 0
                            End Try
                            Try
                                tmp_pedido_reg.servido = lector("servido")
                            Catch ex As Exception
                                tmp_pedido_reg.servido = 0
                            End Try
                            Try
                                tmp_pedido_reg.activo = lector("activo")
                            Catch ex As Exception
                                tmp_pedido_reg.activo = 0
                            End Try
                            Try
                                tmp_pedido_reg.FK_cliente = lector("FK_cliente")
                            Catch ex As Exception
                                tmp_pedido_reg.FK_cliente = -1
                            End Try
                            Try
                                tmp_pedido_reg.FK_mesa = lector("FK_mesa")
                            Catch ex As Exception
                                tmp_pedido_reg.FK_mesa = -1
                            End Try
                            Try
                                tmp_pedido_reg.FK_camarero = lector("FK_camarero")
                            Catch ex As Exception
                                tmp_pedido_reg.FK_camarero = -1
                            End Try

                            lista_pedidos.Add(tmp_pedido_reg)
                        End If
                    End While
                End With

            Catch ex As Exception
                tmp_pedido_reg = error_pedido()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_pedido_reg = error_pedido()
        End Try

        Return lista_pedidos

    End Function

    Public Shared Function get_pedidos_historico_FKCliente(ByVal tmp_cliente_clave As cliente_clave, ByVal cadena_conexion As String) As List(Of pedido_reg)
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim lista_pedidos As New List(Of pedido_reg)
        Dim tmp_pedido_reg As pedido_reg

        Try
            strSQL = " SELECT DISTINCT * "
            strSQL += "FROM pedido P "
            strSQL += "WHERE P.FK_Cliente = " & tmp_cliente_clave.id & " AND P.activo = 0 "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    While .Read()
                        If Not (lector Is Nothing) Then
                            tmp_pedido_reg.id = lector("id")
                            Try
                                tmp_pedido_reg.fecha = lector("fecha")
                            Catch ex As Exception
                                tmp_pedido_reg.fecha = "01/01/1900"
                            End Try
                            Try
                                tmp_pedido_reg.precio = lector("precio")
                            Catch ex As Exception
                                tmp_pedido_reg.precio = 0.0
                            End Try
                            Try
                                tmp_pedido_reg.pagado = lector("pagado")
                            Catch ex As Exception
                                tmp_pedido_reg.pagado = 0
                            End Try
                            Try
                                tmp_pedido_reg.confirmado = lector("confirmado")
                            Catch ex As Exception
                                tmp_pedido_reg.confirmado = 0
                            End Try
                            Try
                                tmp_pedido_reg.servido = lector("servido")
                            Catch ex As Exception
                                tmp_pedido_reg.servido = 0
                            End Try
                            Try
                                tmp_pedido_reg.activo = lector("activo")
                            Catch ex As Exception
                                tmp_pedido_reg.activo = 0
                            End Try
                            Try
                                tmp_pedido_reg.FK_cliente = lector("FK_cliente")
                            Catch ex As Exception
                                tmp_pedido_reg.FK_cliente = -1
                            End Try
                            Try
                                tmp_pedido_reg.FK_mesa = lector("FK_mesa")
                            Catch ex As Exception
                                tmp_pedido_reg.FK_mesa = -1
                            End Try
                            Try
                                tmp_pedido_reg.FK_camarero = lector("FK_camarero")
                            Catch ex As Exception
                                tmp_pedido_reg.FK_camarero = -1
                            End Try

                            lista_pedidos.Add(tmp_pedido_reg)
                        End If
                    End While
                End With

            Catch ex As Exception
                tmp_pedido_reg = error_pedido()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_pedido_reg = error_pedido()
        End Try

        Return lista_pedidos

    End Function

    Public Shared Function existen_pedidos_historico_FKMesa(ByVal tmp_mesa_clave As mesa_clave, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = False
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String

        Try
            strSQL = "SELECT P.id "
            strSQL += "FROM pedido P "
            strSQL += "WHERE P.FK_Mesa = " & tmp_mesa_clave.id & " AND P.activo = 0 "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            If lector.HasRows Then
                ret_ok = True
            End If

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Public Shared Function existen_pedidos_historico_FKCamarero(ByVal tmp_camarero_clave As camarero_clave, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = False
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String

        Try
            strSQL = "SELECT P.id "
            strSQL += "FROM pedido P "
            strSQL += "WHERE P.FK_Camarero = " & tmp_camarero_clave.id & " AND P.activo = 0 "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            If lector.HasRows Then
                ret_ok = True
            End If

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Public Shared Function existen_pedidos_historico_FKCliente(ByVal tmp_cliente_clave As cliente_clave, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = False
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String

        Try
            strSQL = "SELECT P.id "
            strSQL += "FROM pedido P "
            strSQL += "WHERE P.FK_Cliente = " & tmp_cliente_clave.id & " AND P.activo = 0 "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            If lector.HasRows Then
                ret_ok = True
            End If

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Public Shared Function get_historial_pedidos_str(ByVal tmp_cliente_clave As cliente_clave, ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim strSQL As String

        Try
            strSQL = " SELECT DISTINCT P.id, P.fecha, P.precio, M.numero, C.nombre, C.apellido1, C.apellido2 "
            strSQL += " FROM pedido P, mesa M, camarero C "
            strSQL += "WHERE P.FK_Mesa = M.id AND P.FK_Camarero = C.id AND "
            strSQL += " P.FK_Cliente = " & tmp_cliente_clave.id & " AND P.activo = 0 "
            strSQL += " ORDER BY P.fecha "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Cierro la conexion
            conexion.Close()
        Catch ex As Exception
            comando = Nothing
        End Try

        Return comando

    End Function

    Public Shared Function get_historial_pedidos_fechas_str(ByVal tmp_fecha_inicio As Date, ByVal tmp_fecha_fin As Date, ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim strSQL As String

        Try
            strSQL = " SELECT DISTINCT P.id, P.fecha, P.precio, M.numero, C.nombre, C.apellido1, C.apellido2 "
            strSQL += " FROM pedido P LEFT OUTER JOIN mesa M ON P.FK_Mesa = M.id LEFT OUTER JOIN camarero C ON P.FK_Camarero = C.id "
            strSQL += "WHERE "
            strSQL += " P.fecha >= '" & Ayudador.ToFechaYYMMDDHHMMSS(tmp_fecha_inicio) & "' AND P.fecha < '" & Ayudador.ToFechaYYMMDDHHMMSS(tmp_fecha_fin) & "' AND P.activo = 0 "
            strSQL += " ORDER BY P.fecha "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            comando = Nothing
        End Try

        Return comando

    End Function

    Public Shared Function get_pedidos_activos_str(ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim strSQL As String

        Try
            strSQL = " SELECT P.id, P.fecha, P.precio, P.confirmado, P.pagado, P.servido, M.numero, C.nombre, C.apellido1, C.apellido2 "
            strSQL += "FROM pedido P, mesa M, camarero C "
            strSQL += "WHERE P.FK_Mesa = M.id AND P.FK_Camarero = C.id "
            strSQL += "AND P.activo = 1 "
            strSQL += "ORDER BY P.fecha "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            comando = Nothing
        End Try

        Return comando

    End Function

    Public Shared Function insertar_pedido(ByVal tmp_pedido_reg As pedido_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " INSERT INTO pedido(id,fecha,confirmado,servido,precio,pagado,activo,FK_cliente,FK_mesa,FK_camarero) VALUES (" & tmp_pedido_reg.id & ",'" & Ayudador.ToFechaYYMMDDHHMMSS(tmp_pedido_reg.fecha) & "'," & tmp_pedido_reg.confirmado & "," & tmp_pedido_reg.servido & "," & Ayudador.ToCurrencyDecimal(tmp_pedido_reg.precio) & "," & tmp_pedido_reg.pagado & "," & tmp_pedido_reg.activo & "," & tmp_pedido_reg.FK_cliente & "," & tmp_pedido_reg.FK_mesa & ", " & tmp_pedido_reg.FK_camarero & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function actualizar_pedido(ByVal tmp_pedido_reg As pedido_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " UPDATE pedido SET fecha = '" & Ayudador.ToFechaYYMMDDHHMMSS(tmp_pedido_reg.fecha) & "',confirmado = " & tmp_pedido_reg.confirmado & ", servido = " & tmp_pedido_reg.servido & ",precio = " & Ayudador.ToCurrencyDecimal(tmp_pedido_reg.precio) & ",pagado = " & tmp_pedido_reg.pagado & ",activo = " & tmp_pedido_reg.activo & ", "
            If tmp_pedido_reg.FK_cliente = Nothing Then
                strSQL += "FK_cliente = NULL, "
            Else
                strSQL += "FK_cliente = " & tmp_pedido_reg.FK_cliente & ", "
            End If
            If tmp_pedido_reg.FK_mesa = Nothing Then
                strSQL += "FK_mesa = NULL, "
            Else
                strSQL += "FK_mesa = " & tmp_pedido_reg.FK_mesa & ", "
            End If
            If tmp_pedido_reg.FK_camarero = Nothing Then
                strSQL += "FK_camarero = NULL "
            Else
                strSQL += "FK_camarero = " & tmp_pedido_reg.FK_camarero & " "
            End If
            strSQL += "WHERE id = " & tmp_pedido_reg.id & " "
            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function existe_pedido(ByVal tmp_pedido_clave As pedido_clave, ByVal cadena_conexion As String) As Boolean

        If es_error_pedido(get_pedido(tmp_pedido_clave, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_pedido() As pedido_reg
        Dim tmp_pedido_reg As pedido_reg

        tmp_pedido_reg.id = -1
        tmp_pedido_reg.fecha = "01/01/1900"
        tmp_pedido_reg.precio = 0.0
        tmp_pedido_reg.pagado = 0
        tmp_pedido_reg.confirmado = 0
        tmp_pedido_reg.servido = 0
        tmp_pedido_reg.activo = 0
        tmp_pedido_reg.FK_cliente = -1
        tmp_pedido_reg.FK_mesa = -1
        tmp_pedido_reg.FK_camarero = -1

        Return tmp_pedido_reg
    End Function

    Public Shared Function es_error_pedido(ByVal tmp_pedido_reg As pedido_reg) As Boolean
        If tmp_pedido_reg.id = -1 Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
