Imports MySql.Data
Imports accesoBDeRestaurante.tipoproducto_bd
Imports accesoBDeRestaurante.itemconsumicion_bd
Imports accesoBDeRestaurante.menu_bd

Public Class producto_bd

    Public Structure producto_reg
        Dim id As Integer
        Dim FK_tipoproducto As Integer
        Dim FK_itemconsumicion As Integer
    End Structure

    Public Structure producto_clave
        Dim id As String
    End Structure

    Public Shared Function get_producto(ByVal tmp_producto_clave As producto_clave, ByVal cadena_conexion As String) As producto_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_producto_reg As New producto_reg

        Try
            strSQL = " SELECT * FROM producto WHERE id = " & tmp_producto_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_producto_reg.id = lector("id")
                            Try
                                tmp_producto_reg.FK_tipoproducto = lector("FK_tipoproducto")
                            Catch ex As Exception
                                tmp_producto_reg.FK_tipoproducto = -1
                            End Try
                            Try
                                tmp_producto_reg.FK_itemconsumicion = lector("FK_itemconsumicion")
                            Catch ex As Exception
                                tmp_producto_reg.FK_itemconsumicion = -1
                            End Try
                        Else
                            tmp_producto_reg = error_producto()
                        End If
                    Else
                        tmp_producto_reg = error_producto()
                    End If
                End With

            Catch ex As Exception
                tmp_producto_reg = error_producto()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_producto_reg = error_producto()
        End Try

        Return tmp_producto_reg

    End Function

    Public Shared Function get_todos_producto(ByVal cadena_conexion As String) As List(Of producto_reg)
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_producto_reg As New List(Of producto_reg)
        Dim tmp As producto_reg

        Try
            strSQL = " SELECT * FROM producto ORDER BY id ASC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()
            'Leo el registro 
            Try
                With lector
                    If .HasRows Then
                        While .Read()
                            If Not (lector Is Nothing) Then
                                tmp.id = lector("id")
                                Try
                                    tmp.FK_tipoproducto = lector("FK_tipoproducto")
                                Catch ex As Exception
                                    tmp.FK_tipoproducto = -1
                                End Try
                                Try
                                    tmp.FK_itemconsumicion = lector("FK_itemconsumicion")
                                Catch ex As Exception
                                    tmp.FK_itemconsumicion = -1
                                End Try
                                tmp_producto_reg.Add(tmp)
                            End If
                        End While
                    End If
                End With

            Catch ex As Exception

            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception

        End Try

        Return tmp_producto_reg

    End Function

    Public Shared Function get_productos_tipo(ByVal tmp_tipoproducto_clave As tipoproducto_clave, ByVal cadena_conexion As String) As List(Of producto_reg)
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_producto_reg As New producto_reg
        Dim productos_list As New List(Of producto_reg)

        Try
            strSQL = " SELECT P.* "
            strSQL = strSQL & "FROM producto P, itemconsumicion I, tipoproducto T "
            strSQL = strSQL & "WHERE P.FK_TipoProducto = T.id "
            strSQL = strSQL & "AND P.FK_ItemConsumicion = I.id "
            strSQL = strSQL & "AND T.id = " & tmp_tipoproducto_clave.id & " AND I.tipo = 'P' "
            strSQL = strSQL & "ORDER BY P.id ASC"

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .HasRows Then
                        While .Read()
                            If Not (lector Is Nothing) Then
                                tmp_producto_reg.id = lector("id")
                                tmp_producto_reg.FK_tipoproducto = lector("FK_TipoProducto")
                                tmp_producto_reg.FK_itemconsumicion = lector("FK_ItemConsumicion")
                                productos_list.Add(tmp_producto_reg)
                            End If
                        End While
                    End If
                End With

            Catch ex As Exception

            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception

        End Try

        Return productos_list

    End Function

    Public Shared Function get_producto_FKItemConsumicion(ByVal tmp_itemconsumicion_clave As itemconsumicion_clave, ByVal cadena_conexion As String) As producto_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_producto_reg As New producto_reg

        Try
            strSQL = " SELECT P.* "
            strSQL = strSQL & "FROM producto P, itemconsumicion I "
            strSQL = strSQL & "WHERE P.FK_ItemConsumicion = I.id "
            strSQL = strSQL & "AND P.FK_ItemConsumicion = " & tmp_itemconsumicion_clave.id & " "
            strSQL = strSQL & "AND I.tipo = 'P' "
            strSQL = strSQL & "ORDER BY P.id ASC"

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .HasRows Then
                        If .Read() Then
                            If Not (lector Is Nothing) Then
                                tmp_producto_reg.id = lector("id")
                                Try
                                    tmp_producto_reg.FK_tipoproducto = lector("FK_TipoProducto")
                                Catch ex As Exception
                                    tmp_producto_reg.FK_tipoproducto = -1
                                End Try
                                Try
                                    tmp_producto_reg.FK_itemconsumicion = lector("FK_ItemConsumicion")
                                Catch ex As Exception
                                    tmp_producto_reg.FK_itemconsumicion = -1
                                End Try
                            End If
                        End If
                    End If
                End With

            Catch ex As Exception

            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception

        End Try

        Return tmp_producto_reg

    End Function

    Public Shared Function get_seleccion_productos(ByVal cadena_conexion As String) As List(Of producto_reg)
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_producto_reg As New List(Of producto_reg)
        Dim tmp As producto_reg

        Try
            strSQL = " SELECT * FROM producto ORDER BY id ASC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()
            'Leo el registro 
            Try
                With lector
                    If .HasRows Then
                        While .Read()
                            If Not (lector Is Nothing) Then
                                tmp.id = lector("id")
                                Try
                                    tmp.FK_tipoproducto = lector("FK_tipoproducto")
                                Catch ex As Exception
                                    tmp.FK_tipoproducto = -1
                                End Try
                                Try
                                    tmp.FK_itemconsumicion = lector("FK_itemconsumicion")
                                Catch ex As Exception
                                    tmp.FK_itemconsumicion = -1
                                End Try
                                tmp_producto_reg.Add(tmp)
                            End If
                        End While
                    End If
                End With

            Catch ex As Exception

            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception

        End Try

        Return tmp_producto_reg

    End Function

    Public Shared Function insertar_producto(ByVal tmp_producto_reg As producto_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            If tmp_producto_reg.FK_tipoproducto <> -1 Then
                strSQL = " INSERT INTO producto(id,FK_tipoproducto,FK_itemconsumicion) VALUES (" & tmp_producto_reg.id & "," & tmp_producto_reg.FK_tipoproducto & "," & tmp_producto_reg.FK_itemconsumicion & ") "
            Else
                strSQL = " INSERT INTO producto(id,FK_tipoproducto,FK_itemconsumicion) VALUES (" & tmp_producto_reg.id & ",NULL," & tmp_producto_reg.FK_itemconsumicion & ") "
            End If

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function actualizar_producto(ByVal tmp_producto_reg As producto_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            If (tmp_producto_reg.FK_tipoproducto <> -1) Then
                strSQL = " UPDATE producto SET FK_tipoproducto = " & tmp_producto_reg.FK_tipoproducto & ",FK_itemconsumicion = " & tmp_producto_reg.FK_itemconsumicion & " WHERE id = " & tmp_producto_reg.id & " "
            Else
                strSQL = " UPDATE producto SET FK_tipoproducto = NULL,FK_itemconsumicion = " & tmp_producto_reg.FK_itemconsumicion & " WHERE id = " & tmp_producto_reg.id & " "
            End If

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function existe_producto(ByVal tmp_producto_clave As producto_clave, ByVal cadena_conexion As String) As Boolean

        If es_error_producto(get_producto(tmp_producto_clave, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_producto() As producto_reg
        Dim tmp_producto_reg As producto_reg

        tmp_producto_reg.id = -1
        tmp_producto_reg.FK_tipoproducto = -1
        tmp_producto_reg.FK_itemconsumicion = -1

        Return tmp_producto_reg
    End Function

    Public Shared Function es_error_producto(ByVal tmp_producto_reg As producto_reg) As Boolean
        If (tmp_producto_reg.id) = -1 Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
