Imports MySql.Data
Imports accesoBDeRestaurante.menu_bd
Imports accesoBDeRestaurante.producto_bd

Public Class productosmenu_bd

    Public Structure productosmenu_reg
        Dim id As Integer
        Dim cantidad As Integer
        Dim FK_menu As Integer
        Dim FK_producto As Integer
    End Structure

    Public Structure productosmenu_clave
        Dim id As String
    End Structure

    Public Shared Function get_productosmenu(ByVal tmp_productosmenu_clave As productosmenu_clave, ByVal cadena_conexion As String) As productosmenu_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_productosmenu_reg As New productosmenu_reg

        Try
            strSQL = " SELECT * FROM productosmenu WHERE id = " & tmp_productosmenu_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_productosmenu_reg.id = lector("id")
                            Try
                                tmp_productosmenu_reg.cantidad = lector("cantidad")
                            Catch ex As Exception
                                tmp_productosmenu_reg.cantidad = -1
                            End Try
                            Try
                                tmp_productosmenu_reg.FK_menu = lector("FK_menu")
                            Catch ex As Exception
                                tmp_productosmenu_reg.FK_menu = -1
                            End Try
                            Try
                                tmp_productosmenu_reg.FK_producto = lector("FK_producto")
                            Catch ex As Exception
                                tmp_productosmenu_reg.FK_producto = -1
                            End Try
                        Else
                            tmp_productosmenu_reg = error_productosmenu()
                        End If
                    Else
                        tmp_productosmenu_reg = error_productosmenu()
                    End If
                End With

            Catch ex As Exception
                tmp_productosmenu_reg = error_productosmenu()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_productosmenu_reg = error_productosmenu()
        End Try

        Return tmp_productosmenu_reg

    End Function

    Public Shared Function get_productosmenu_FKMenu(ByVal tmp_menu_clave As menu_clave, ByVal cadena_conexion As String) As List(Of productosmenu_reg)
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_productosmenu_reg As New productosmenu_reg
        Dim productosmenu_list As New List(Of productosmenu_reg)

        Try
            strSQL = " SELECT * FROM productosmenu WHERE FK_Menu = " & tmp_menu_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            With lector
                If .HasRows Then
                    While .Read()
                        If Not (lector Is Nothing) Then
                            tmp_productosmenu_reg.id = lector("id")
                            Try
                                tmp_productosmenu_reg.cantidad = lector("cantidad")
                            Catch ex As Exception
                                tmp_productosmenu_reg.cantidad = -1
                            End Try
                            Try
                                tmp_productosmenu_reg.FK_menu = lector("FK_menu")
                            Catch ex As Exception
                                tmp_productosmenu_reg.FK_menu = -1
                            End Try
                            Try
                                tmp_productosmenu_reg.FK_producto = lector("FK_producto")
                            Catch ex As Exception
                                tmp_productosmenu_reg.FK_producto = -1
                            End Try
                            productosmenu_list.Add(tmp_productosmenu_reg)
                        End If
                    End While
                End If
            End With

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception

        End Try

        Return productosmenu_list

    End Function

    Public Shared Function get_productosmenu_FKMenu_FKProducto(ByVal tmp_productosmenu_reg As productosmenu_reg, ByVal cadena_conexion As String) As productosmenu_reg
        Dim strSQL As String
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing

        Try
            strSQL = "SELECT * FROM productosmenu WHERE FK_Menu =  " & tmp_productosmenu_reg.FK_menu & " AND FK_Producto = " & tmp_productosmenu_reg.FK_producto & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            With lector
                If .HasRows Then
                    While .Read()
                        If Not (lector Is Nothing) Then
                            tmp_productosmenu_reg.id = lector("id")
                            Try
                                tmp_productosmenu_reg.cantidad = lector("cantidad")
                            Catch ex As Exception
                                tmp_productosmenu_reg.cantidad = -1
                            End Try
                            Try
                                tmp_productosmenu_reg.FK_menu = lector("FK_menu")
                            Catch ex As Exception
                                tmp_productosmenu_reg.FK_menu = -1
                            End Try
                            Try
                                tmp_productosmenu_reg.FK_producto = lector("FK_producto")
                            Catch ex As Exception
                                tmp_productosmenu_reg.FK_producto = -1
                            End Try
                        Else
                            tmp_productosmenu_reg = error_productosmenu()
                        End If
                    End While
                Else
                    tmp_productosmenu_reg = error_productosmenu()
                End If
            End With

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_productosmenu_reg = error_productosmenu()
        End Try

        Return tmp_productosmenu_reg
    End Function

    Public Shared Function get_productosmenu_FKMenu_str(ByVal tmp_menu_clave As menu_clave, ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String

        Try
            strSQL = " SELECT PM.cantidad, I.nombre "
            strSQL += "FROM productosmenu PM, producto P, itemconsumicion I "
            strSQL += "WHERE PM.FK_producto = P.id AND P.FK_itemconsumicion = I.id "
            strSQL += " AND FK_Menu = " & tmp_menu_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            comando = Nothing
        End Try

        Return comando

    End Function

    Public Shared Function insertar_productosmenu(ByVal tmp_productosmenu_reg As productosmenu_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " INSERT INTO productosmenu(id,cantidad,FK_menu,FK_producto) VALUES (" & tmp_productosmenu_reg.id & "," & tmp_productosmenu_reg.cantidad & "," & tmp_productosmenu_reg.FK_menu & "," & tmp_productosmenu_reg.FK_producto & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function actualizar_productosmenu(ByVal tmp_productosmenu_reg As productosmenu_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " UPDATE productosmenu SET cantidad = " & tmp_productosmenu_reg.cantidad & ",FK_menu = " & tmp_productosmenu_reg.FK_menu & ",FK_producto = " & tmp_productosmenu_reg.FK_producto & " WHERE id = " & tmp_productosmenu_reg.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_productosmenu(ByVal tmp_productosmenu_clave As productosmenu_clave, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String
        Dim lista_str As String = ""

        Try
            strSQL = " DELETE FROM productosmenu WHERE id = " & tmp_productosmenu_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Public Shared Function existe_productosmenu(ByVal tmp_productosmenu_reg As productosmenu_reg, ByVal cadena_conexion As String) As Boolean

        If es_error_productosmenu(get_productosmenu_FKMenu_FKProducto(tmp_productosmenu_reg, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_productosmenu() As productosmenu_reg
        Dim tmp_productosmenu_reg As productosmenu_reg

        tmp_productosmenu_reg.id = -1
        tmp_productosmenu_reg.cantidad = -1
        tmp_productosmenu_reg.FK_menu = -1
        tmp_productosmenu_reg.FK_producto = -1

        Return tmp_productosmenu_reg
    End Function

    Public Shared Function es_error_productosmenu(ByVal tmp_productosmenu_reg As productosmenu_reg) As Boolean
        If (tmp_productosmenu_reg.id) = -1 Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
