Imports MySql.Data
Imports accesoBDeRestaurante.mesa_bd
Imports accesoBDeRestaurante.cliente_bd

Public Class reserva_bd

    Public Structure reserva_reg
        Dim id As Integer
        Dim fecha As DateTime
        Dim finalizada As Integer
        Dim FK_cliente As Integer
        Dim FK_mesa As Integer
    End Structure

    Public Structure reserva_clave
        Dim id As String
    End Structure

    Public Shared Function get_reserva(ByVal tmp_reserva_clave As reserva_clave, ByVal cadena_conexion As String) As reserva_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_reserva_reg As New reserva_reg

        Try
            strSQL = " SELECT * FROM reserva WHERE id = " & tmp_reserva_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_reserva_reg.id = lector("id")
                            Try
                                tmp_reserva_reg.fecha = lector("fecha")
                            Catch ex As Exception
                                tmp_reserva_reg.fecha = "01/01/1900"
                            End Try

                            Try
                                tmp_reserva_reg.finalizada = lector("finalizada")
                            Catch ex As Exception
                                tmp_reserva_reg.finalizada = 0
                            End Try

                            Try
                                tmp_reserva_reg.FK_cliente = lector("FK_cliente")
                            Catch ex As Exception
                                tmp_reserva_reg.FK_cliente = -1
                            End Try
                            Try
                                tmp_reserva_reg.FK_mesa = lector("FK_mesa")
                            Catch ex As Exception
                                tmp_reserva_reg.FK_mesa = -1
                            End Try
                        Else
                            tmp_reserva_reg = error_reserva()
                        End If
                    Else
                        tmp_reserva_reg = error_reserva()
                    End If
                End With

            Catch ex As Exception
                tmp_reserva_reg = error_reserva()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_reserva_reg = error_reserva()
        End Try

        Return tmp_reserva_reg

    End Function

    Public Shared Function get_reserva(ByVal tmp_mesa_clave As mesa_clave, ByVal dia_hora As Date, ByVal cadena_conexion As String) As reserva_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_reserva_reg As New reserva_reg

        Try
            strSQL = " SELECT DISTINCT * "
            strSQL += " FROM reserva R "
            strSQL += " WHERE R.fecha >= '" & Ayudador.ToFechaYYMMDDHHMMSS(CDate(dia_hora).AddHours(-1)) & "' AND R.fecha <= '" & Ayudador.ToFechaYYMMDDHHMMSS(CDate(dia_hora)) & "' "
            strSQL += " AND R.FK_Mesa = " & tmp_mesa_clave.id & " AND R.finalizada = 0 "
            strSQL += " ORDER BY R.FK_Mesa ASC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_reserva_reg.id = lector("id")
                            Try
                                tmp_reserva_reg.fecha = lector("fecha")
                            Catch ex As Exception
                                tmp_reserva_reg.fecha = "01/01/1900"
                            End Try

                            Try
                                tmp_reserva_reg.finalizada = lector("finalizada")
                            Catch ex As Exception
                                tmp_reserva_reg.finalizada = 0
                            End Try

                            Try
                                tmp_reserva_reg.FK_cliente = lector("FK_cliente")
                            Catch ex As Exception
                                tmp_reserva_reg.FK_cliente = -1
                            End Try
                            Try
                                tmp_reserva_reg.FK_mesa = lector("FK_mesa")
                            Catch ex As Exception
                                tmp_reserva_reg.FK_mesa = -1
                            End Try
                        Else
                            tmp_reserva_reg = error_reserva()
                        End If
                    Else
                        tmp_reserva_reg = error_reserva()
                    End If
                End With

            Catch ex As Exception
                tmp_reserva_reg = error_reserva()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_reserva_reg = error_reserva()
        End Try

        Return tmp_reserva_reg

    End Function

    Public Shared Function get_reserva_iniciada(ByVal tmp_mesa_clave As mesa_clave, ByVal dia_hora As Date, ByVal cadena_conexion As String) As reserva_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_reserva_reg As New reserva_reg

        Try
            strSQL = " SELECT DISTINCT * "
            strSQL += " FROM reserva R "
            strSQL += " WHERE R.fecha >= '" & Ayudador.ToFechaYYMMDDHHMMSS(CDate(dia_hora)) & "' AND R.fecha < '" & Ayudador.ToFechaYYMMDDHHMMSS(CDate(dia_hora).AddHours(2)) & "' "
            strSQL += " AND R.FK_Mesa = " & tmp_mesa_clave.id & " AND R.finalizada = 0 "
            strSQL += " ORDER BY R.FK_Mesa ASC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_reserva_reg.id = lector("id")
                            Try
                                tmp_reserva_reg.fecha = lector("fecha")
                            Catch ex As Exception
                                tmp_reserva_reg.fecha = "01/01/1900"
                            End Try

                            Try
                                tmp_reserva_reg.finalizada = lector("finalizada")
                            Catch ex As Exception
                                tmp_reserva_reg.finalizada = 0
                            End Try

                            Try
                                tmp_reserva_reg.FK_cliente = lector("FK_cliente")
                            Catch ex As Exception
                                tmp_reserva_reg.FK_cliente = -1
                            End Try
                            Try
                                tmp_reserva_reg.FK_mesa = lector("FK_mesa")
                            Catch ex As Exception
                                tmp_reserva_reg.FK_mesa = -1
                            End Try
                        Else
                            tmp_reserva_reg = error_reserva()
                        End If
                    Else
                        tmp_reserva_reg = error_reserva()
                    End If
                End With

            Catch ex As Exception
                tmp_reserva_reg = error_reserva()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_reserva_reg = error_reserva()
        End Try

        Return tmp_reserva_reg

    End Function

    Public Shared Function get_reservas_str(ByVal tmp_cliente_clave As cliente_clave, ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim strSQL As String

        Try
            strSQL = " SELECT R.id, R.fecha, M.numero "
            strSQL += "FROM reserva R, mesa M "
            strSQL += "WHERE R.FK_Mesa = M.id AND R.FK_Cliente = " & tmp_cliente_clave.id & " "
            strSQL += "AND R.fecha >= '" & Ayudador.ToFechaYYMMDDHHMMSS(Date.Now) & "' AND R.finalizada = 0 "
            strSQL += "ORDER BY R.fecha ASC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            comando = Nothing
        End Try

        Return comando

    End Function

    Public Shared Function insertar_reserva(ByVal tmp_reserva_reg As reserva_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " INSERT INTO reserva(id,fecha,FK_cliente,finalizada,FK_mesa) VALUES (" & tmp_reserva_reg.id & ",'" & Ayudador.ToFechaYYMMDDHHMMSS(tmp_reserva_reg.fecha) & "'," & tmp_reserva_reg.FK_cliente & "," & tmp_reserva_reg.finalizada & "," & tmp_reserva_reg.FK_mesa & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_reserva(ByVal reserva As reserva_clave, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try

            strSQL = " DELETE FROM reserva WHERE id = " & reserva.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function actualizar_reserva(ByVal tmp_reserva_reg As reserva_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " UPDATE reserva SET fecha = '" & Ayudador.ToFechaYYMMDDHHMMSS(tmp_reserva_reg.fecha) & "',FK_cliente = " & tmp_reserva_reg.FK_cliente & ",finalizada = " & tmp_reserva_reg.finalizada & ", FK_mesa = " & tmp_reserva_reg.FK_mesa & " WHERE id = " & tmp_reserva_reg.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function existe_reserva(ByVal tmp_reserva_clave As reserva_clave, ByVal cadena_conexion As String) As Boolean

        If es_error_reserva(get_reserva(tmp_reserva_clave, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_reserva() As reserva_reg
        Dim tmp_reserva_reg As reserva_reg

        tmp_reserva_reg.id = -1
        tmp_reserva_reg.fecha = "01/01/1900"
        tmp_reserva_reg.finalizada = 0
        tmp_reserva_reg.FK_cliente = -1
        tmp_reserva_reg.FK_mesa = -1

        Return tmp_reserva_reg
    End Function

    Public Shared Function es_error_reserva(ByVal tmp_reserva_reg As reserva_reg) As Boolean
        If (tmp_reserva_reg.id) = -1 Then
            Return True
        Else
            Return False
        End If
    End Function
    Public Shared Function existe_reserva_mesa(ByVal mesa As mesa_clave, ByVal dia_hora As Date, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = False
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String

        Try

            strSQL = " SELECT DISTINCT * "
            strSQL += " FROM reserva R "
            strSQL += " WHERE R.fecha >= '" & Ayudador.ToFechaYYMMDDHHMMSS(CDate(dia_hora).AddHours(-1)) & "' AND R.fecha <= '" & Ayudador.ToFechaYYMMDDHHMMSS(CDate(dia_hora)) & "' "
            strSQL += " AND R.FK_Mesa = " & mesa.id & " AND R.finalizada = 0 "
            strSQL += " ORDER BY R.FK_Mesa ASC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            With lector
                If .HasRows Then
                    ret_ok = True
                End If
            End With

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Public Shared Function existe_reserva_mesa_iniciada(ByVal mesa As mesa_clave, ByVal dia_hora As Date, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = False
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String

        Try

            strSQL = " SELECT DISTINCT * "
            strSQL += " FROM reserva R "
            strSQL += " WHERE R.fecha >= '" & Ayudador.ToFechaYYMMDDHHMMSS(CDate(dia_hora)) & "' AND R.fecha < '" & Ayudador.ToFechaYYMMDDHHMMSS(CDate(dia_hora).AddHours(2)) & "' "
            strSQL += " AND R.FK_Mesa = " & mesa.id & " AND R.finalizada = 0 "
            strSQL += " ORDER BY R.FK_Mesa ASC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            With lector
                If .HasRows Then
                    ret_ok = True
                End If
            End With

            'Cierro la conexion
            conexion.Close()

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

End Class
