Imports MySql.Data
Imports accesoBDeRestaurante.producto_bd

Public Class tipoproducto_bd

    Public Structure tipoproducto_reg
        Dim id As Integer
        Dim nombre As String
    End Structure

    Public Structure tipoproducto_clave
        Dim id As String
    End Structure

    Public Shared Function get_tipoproducto(ByVal tmp_tipoproducto_clave As tipoproducto_clave, ByVal cadena_conexion As String) As tipoproducto_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_tipoproducto_reg As New tipoproducto_reg

        Try
            strSQL = " SELECT * FROM tipoproducto WHERE id = " & tmp_tipoproducto_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_tipoproducto_reg.id = lector("id")
                            tmp_tipoproducto_reg.nombre = lector("nombre")
                        Else
                            tmp_tipoproducto_reg = error_tipoproducto()
                        End If
                    Else
                        tmp_tipoproducto_reg = error_tipoproducto()
                    End If
                End With

            Catch ex As Exception
                tmp_tipoproducto_reg = error_tipoproducto()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_tipoproducto_reg = error_tipoproducto()
        End Try

        Return tmp_tipoproducto_reg

    End Function

    Public Shared Function get_todos_tipoproducto(ByVal cadena_conexion As String) As List(Of tipoproducto_reg)
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_tipoproducto_reg As New List(Of tipoproducto_reg)
        Dim tmp As tipoproducto_reg

        Try
            strSQL = " SELECT * FROM tipoproducto ORDER BY id ASC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()
            'Leo el registro 
            Try
                With lector
                    If .HasRows Then
                        While .Read()
                            If Not (lector Is Nothing) Then
                                tmp.id = lector("id")
                                tmp.nombre = lector("nombre")
                                tmp_tipoproducto_reg.Add(tmp)
                            End If
                        End While
                    End If
                End With

            Catch ex As Exception

            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception

        End Try

        Return tmp_tipoproducto_reg

    End Function

    Public Shared Function get_todos_tipoproducto_str(ByVal cadena_conexion As String) As MySqlClient.MySqlCommand
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim strSQL As String

        Try
            strSQL = " SELECT * FROM tipoproducto ORDER BY id ASC "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            
            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            comando = Nothing
        End Try

        Return comando

    End Function

    Public Shared Function insertar_tipoproducto(ByVal tmp_tipoproducto_reg As tipoproducto_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " INSERT INTO tipoproducto(id,nombre) VALUES (" & tmp_tipoproducto_reg.id & ",'" & tmp_tipoproducto_reg.nombre & "') "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function actualizar_tipoproducto(ByVal tmp_tipoproducto_reg As tipoproducto_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " UPDATE tipoproducto SET nombre = '" & tmp_tipoproducto_reg.nombre & "' WHERE id = " & tmp_tipoproducto_reg.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_varios_tipoproducto(ByVal tipoproducto As List(Of Integer), ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String
        Dim lista_str As String = ""

        Try
            For Each item In tipoproducto
                If item = tipoproducto.Last Then
                    lista_str += item.ToString
                Else
                    lista_str += item.ToString & ", "
                End If
            Next

            strSQL = " DELETE FROM tipoproducto WHERE id IN (" & lista_str & ") "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function existe_tipoproducto(ByVal tmp_tipoproducto_clave As tipoproducto_clave, ByVal cadena_conexion As String) As Boolean

        If es_error_tipoproducto(get_tipoproducto(tmp_tipoproducto_clave, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_tipoproducto() As tipoproducto_reg
        Dim tmp_tipoproducto_reg As tipoproducto_reg

        tmp_tipoproducto_reg.id = -1
        tmp_tipoproducto_reg.nombre = ""

        Return tmp_tipoproducto_reg
    End Function

    Public Shared Function es_error_tipoproducto(ByVal tmp_tipoproducto_reg As tipoproducto_reg) As Boolean
        If (tmp_tipoproducto_reg.id) = -1 Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
