Imports MySql.Data
Imports accesoBDeRestaurante.cliente_bd
Imports accesoBDeRestaurante.pedido_bd

Public Class usuario_bd

    Public Structure usuario_reg
        Dim id As Integer
        Dim clave As String
        Dim passwd As String
        Dim tipo As String
    End Structure

    Public Structure usuario_clave
        Dim id As String
    End Structure

    Public Shared Function get_usuario(ByVal tmp_usuario_clave As usuario_clave, ByVal cadena_conexion As String) As usuario_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_usuario_reg As New usuario_reg

        Try
            strSQL = " SELECT * FROM usuario WHERE id = " & tmp_usuario_clave.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_usuario_reg.id = lector("id")
                            tmp_usuario_reg.clave = lector("clave")
                            tmp_usuario_reg.passwd = lector("passwd")
                            tmp_usuario_reg.tipo = lector("tipo")
                        Else
                            tmp_usuario_reg = error_usuario()
                        End If
                    Else
                        tmp_usuario_reg = error_usuario()
                    End If
                End With

            Catch ex As Exception
                tmp_usuario_reg = error_usuario()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_usuario_reg = error_usuario()
        End Try

        Return tmp_usuario_reg

    End Function

    Public Shared Function get_usuario_por_clave(ByVal clave As String, ByVal cadena_conexion As String) As usuario_reg
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim lector As MySqlClient.MySqlDataReader = Nothing
        Dim strSQL As String
        Dim tmp_usuario_reg As New usuario_reg

        Try
            strSQL = " SELECT * FROM usuario WHERE clave = '" & clave & "' "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)
            'Ejecuto la consulta y la guardo
            lector = comando.ExecuteReader()

            'Leo el registro 
            Try
                With lector
                    If .Read() Then
                        If Not (lector Is Nothing) Then
                            tmp_usuario_reg.id = lector("id")
                            tmp_usuario_reg.clave = lector("clave")
                            tmp_usuario_reg.passwd = lector("passwd")
                            tmp_usuario_reg.tipo = lector("tipo")
                        Else
                            tmp_usuario_reg = error_usuario()
                        End If
                    Else
                        tmp_usuario_reg = error_usuario()
                    End If
                End With

            Catch ex As Exception
                tmp_usuario_reg = error_usuario()
            End Try

            'Cierro la conexion
            conexion.Close()

        Catch e As Exception
            tmp_usuario_reg = error_usuario()
        End Try

        Return tmp_usuario_reg

    End Function

    Public Shared Function insertar_usuario(ByVal tmp_usuario_reg As usuario_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " INSERT INTO usuario(id,clave,passwd,tipo) VALUES (" & tmp_usuario_reg.id & ",'" & tmp_usuario_reg.clave & "','" & tmp_usuario_reg.passwd & "','" & tmp_usuario_reg.tipo & "') "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function actualizar_usuario(ByVal tmp_usuario_reg As usuario_reg, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String

        Try
            strSQL = " UPDATE usuario SET clave = '" & tmp_usuario_reg.clave & "',passwd = '" & tmp_usuario_reg.passwd & "',tipo= '" & tmp_usuario_reg.tipo & "' WHERE id = " & tmp_usuario_reg.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            'Cierro la conexion
            conexion.Close()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function eliminar_usuario(ByVal usuario As usuario_clave, ByVal cadena_conexion As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim conexion As New MySqlClient.MySqlConnection(cadena_conexion)
        Dim comando As New MySqlClient.MySqlCommand
        Dim filas As Integer
        Dim strSQL As String
        Dim tmp_usuario_reg As usuario_reg
        Dim tmp_usuario_clave As usuario_clave
        Dim tmp_cliente_reg As cliente_reg
        Dim tmp_cliente_clave As cliente_clave
        Dim lista_pedidos As List(Of pedido_reg)

        Try

            strSQL = " DELETE FROM usuario WHERE id = " & usuario.id & " "

            'Abro la conexion
            conexion.Open()

            comando = New MySqlClient.MySqlCommand(strSQL, conexion)

            'Ejecuto la consulta y guardo el num de filas devueltas
            filas = comando.ExecuteNonQuery()

            If filas <= 0 Then
                ret_ok = False
            End If

        Catch ex As Exception

            Try
                ' Si tiene pedidos asignados no activos, desreferencio el usuario en los pedidos y la elimino
                tmp_usuario_reg = get_usuario(usuario, cadena_conexion)

                If Not es_error_usuario(tmp_usuario_reg) Then

                    If tmp_usuario_reg.tipo.Equals("C") Then

                        tmp_usuario_clave.id = tmp_usuario_reg.id
                        tmp_cliente_reg = get_cliente_FKUsuario(tmp_usuario_clave, cadena_conexion)
                        tmp_cliente_clave.id = tmp_cliente_reg.id
                        If existen_pedidos_historico_FKCliente(tmp_cliente_clave, cadena_conexion) Then
                            lista_pedidos = get_pedidos_historico_FKCliente(tmp_cliente_clave, cadena_conexion)

                            For Each pedido In lista_pedidos
                                pedido.FK_cliente = Nothing
                                If Not actualizar_pedido(pedido, cadena_conexion) Then
                                    Throw New Exception
                                End If
                            Next

                            'Ejecuto la consulta y guardo el num de filas devueltas
                            filas = comando.ExecuteNonQuery()

                            'Cierro la conexion
                            conexion.Close()

                            If filas <= 0 Then
                                ret_ok = False
                            End If

                        End If

                    End If
                End If

            Catch ex2 As Exception
                ret_ok = False
            End Try

        End Try

        Return ret_ok

    End Function

    Public Shared Function existe_usuario(ByVal tmp_usuario_reg As usuario_reg, ByVal cadena_conexion As String) As Boolean
        Dim tmp_usuario_clave As usuario_clave

        tmp_usuario_clave.id = tmp_usuario_reg.id

        If es_error_usuario(get_usuario_por_clave(tmp_usuario_reg.clave, cadena_conexion)) Then
            Return False
        Else
            Return True
        End If

    End Function

    Private Shared Function error_usuario() As usuario_reg
        Dim tmp_usuario_reg As usuario_reg

        tmp_usuario_reg.id = -1
        tmp_usuario_reg.clave = ""
        tmp_usuario_reg.passwd = ""
        tmp_usuario_reg.tipo = ""

        Return tmp_usuario_reg
    End Function

    Public Shared Function es_error_usuario(ByVal tmp_usuario_reg As usuario_reg) As Boolean
        If tmp_usuario_reg.id = -1 Then
            Return True
        Else
            Return False
        End If
    End Function

End Class
