﻿Imports Microsoft.VisualBasic
Imports accesoBDeRestaurante.cliente_bd
Imports accesoBDeRestaurante.usuario_bd

Public Class funciones_generales

    'Funcion que valida que el id, clave, nombre y dni no contienen caracteres especiales
    'y que el nombre no contiene numeros
    Public Shared Function validar_datos_cadenas(ByVal cliente As cliente_reg, ByVal usuario As usuario_reg) As Boolean
        Dim especiales() As String = {" ", "\", "!", "|", "·", "@", "#", "$", "%", "&", "/", "(", ")", "=", "?", "¿", "¡", "*", "+", "^", "[", "]", "¨", "{", "}", ",", ";", ".", ":", "<", ">"}
        Dim numeros() As String = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9"}
        Dim contador As Integer = 0
        Dim ret_ok As Boolean = True

        Try

            While contador < especiales.Length AndAlso ret_ok
                If (Trim(cliente.apellido1).Contains(especiales.GetValue(contador)) OrElse Trim(cliente.apellido2).Contains(especiales.GetValue(contador)) OrElse Trim(cliente.nombre).Contains(especiales.GetValue(contador)) OrElse Trim(usuario.passwd).Contains(especiales.GetValue(contador)) OrElse Trim(usuario.clave).Contains(especiales.GetValue(contador))) Then
                    ret_ok = False
                End If
                contador = contador + 1
            End While

            If ret_ok Then

                contador = 0
                While contador < numeros.Length AndAlso ret_ok
                    If Trim(cliente.nombre).Contains(numeros.GetValue(contador)) OrElse Trim(cliente.apellido1).Contains(numeros.GetValue(contador)) OrElse Trim(cliente.apellido2).Contains(numeros.GetValue(contador)) Then
                        ret_ok = False
                    End If
                    contador = contador + 1
                End While

            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    'Funcion que valida que el dni esta formado por 8 digitos y una letra
    Public Shared Function validar_dni(ByVal dni As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim contador As Integer = 0

        Try

            'Compruebo que ocupa 9 caracteres
            If Trim(dni).Length <> 9 Then
                ret_ok = False
            Else
                'Compruebo que los 8 primeros caracteres son numericos
                While contador < Trim(dni).Length - 1 AndAlso ret_ok
                    If Char.IsDigit(Trim(dni), contador) Then
                        contador = contador + 1
                    Else
                        ret_ok = False
                    End If
                End While

                If ret_ok Then
                    'Compruebo que el caracter noveno es una letra distinta de Ñ
                    If Char.IsLetter(Trim(dni), 8) AndAlso (Trim(dni).Substring(8, 1) <> "Ñ") Then
                        ret_ok = True
                    Else
                        ret_ok = False
                    End If
                End If

            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function


    'Funcion que valida el numero de telefono, debe ser un numero
    Public Shared Function validar_telefono(ByVal cliente As cliente_reg) As Boolean
        Dim ret_ok As Boolean = True
        Dim tmp As Integer

        Try
            tmp = cliente.telefono
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function validar_email(ByVal email As String) As Boolean
        Dim especiales() As String = {" ", "\", "!", "|", "·", "#", "$", "%", "&", "/", "(", ")", "=", "?", "¿", "¡", "*", "+", "^", "[", "]", "¨", "{", "}", ",", ";", ":", "<", ">"}
        Dim ret_ok As Boolean = True
        Dim tmp As String()
        Dim contador As Integer = 0

        Try
            If (email.Contains("@")) Then
                tmp = email.Split("@")
                If tmp.Length = 2 Then
                    While contador < especiales.Length AndAlso ret_ok
                        If email.Contains(especiales.GetValue(contador)) Then
                            ret_ok = False
                        End If
                        contador = contador + 1
                    End While
                Else
                    ret_ok = False
                End If
            Else
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Public Shared Function validar_passwd(ByVal pass As String, ByVal pass2 As String) As Boolean
        Dim ret_ok As Boolean = True

        Try
            If (Trim(pass).CompareTo(Trim(pass2)) <> 0) Then
                ret_ok = False
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Public Shared Function obtener_nombre_apellido1_apellido2(ByVal nom As String, ByVal ape1 As String, ByVal ape2 As String) As String
        Dim res As String = ""

        If nom <> Nothing Then
            res += nom
            If ape1 <> Nothing Then
                res += " " + ape1
                If ape2 <> Nothing Then
                    res += " " + ape2
                End If
            End If
        End If

        Return res
    End Function
End Class
