﻿Imports accesoBDeRestaurante.cliente_bd
Imports accesoBDeRestaurante.usuario_bd
Imports variables_globales
Imports funciones_generales


Partial Class anonimo_nuevo_usuario
    Inherits System.Web.UI.Page

    Protected Shared procedencia As String

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            ' Si se llega aqui como registro rapido damos la opcion de volver
            procedencia = Request.QueryString("proc")

            EstadoDatos(False)
        End If
    End Sub

    Protected Sub EstadoDatos(ByVal estado As Boolean)
        Me.MsgEstadoErrorPanel.Visible = estado
        Me.FormNuevoUsuario.Visible = Not estado
        Me.PanelNuevoUsuarioExito.Visible = estado

        If (Not procedencia Is Nothing AndAlso Not procedencia.Equals("")) Then
            Me.Volver2Button.Visible = True
        End If
    End Sub

    Protected Sub botonSubmit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles botonSubmit.Click
        Dim usuario As New usuario_reg
        Dim usuario_clave As New usuario_clave
        Dim cliente As New cliente_reg
        Dim tmp_usuario_reg As New usuario_reg

        'Guardo los datos del formulario de alta en los registros
        With usuario
            .clave = Me.Dni.Text.Trim()
            .passwd = Me.Password.Text.Trim()
            .tipo = "C"
        End With

        With cliente
            .nombre = Me.Nombre.Text.Trim()
            .telefono = Me.Telefono.Text.Trim()
            .apellido1 = Me.PrimerApellido.Text.Trim()
            .apellido2 = Me.SegundoApellido.Text.Trim()
            .email = Me.Correo.Text.Trim()
        End With

        'Compruebo los datos introducidos
        If validar_datos_cadenas(cliente, usuario) Then
            If validar_dni(usuario.clave) Then
                If validar_telefono(cliente) Then
                    If validar_email(cliente.email) Then
                        If validar_passwd(Me.Password.Text, Me.Password2.Text) Then
                            If Not existe_usuario(usuario, cadena_conexion) Then
                                If Not insertar_usuario(usuario, cadena_conexion) Then
                                    Me.MsgEstadoErrorPanel.Visible = True
                                    Me.texto_error.Text = "Error al crear el nuevo cliente"
                                Else
                                    'Inserto el cliente en la bd
                                    cliente.FK_usuario = get_usuario_por_clave(usuario.clave, cadena_conexion).id
                                    If insertar_cliente(cliente, cadena_conexion) Then
                                        Me.FormNuevoUsuario.Visible = False
                                        Me.PanelNuevoUsuarioExito.Visible = True
                                    Else
                                        Me.MsgEstadoErrorPanel.Visible = True
                                        Me.texto_error.Text = "Error al crear el nuevo cliente."
                                    End If
                                End If
                            Else
                                Me.MsgEstadoErrorPanel.Visible = True
                                Me.texto_error.Text = "Error! El dni introducido ya está registrado. Entre en su zona de cliente o revise su dni."
                                limpiar_dni()
                            End If
                        Else
                            Me.MsgEstadoErrorPanel.Visible = True
                            Me.texto_error.Text = "Error! Las contraseñas deben ser iguales."
                            Me.limpiar_passwds()
                        End If
                    Else
                        Me.MsgEstadoErrorPanel.Visible = True
                        Me.texto_error.Text = "Error! El email introducido no es correcto. Revíselo por favor."
                        limpiar_email()
                    End If
                Else
                    Me.MsgEstadoErrorPanel.Visible = True
                    Me.texto_error.Text = "Error! El teléfono introducido no es correcto. Revíselo por favor."
                    limpiar_telf()
                End If
            Else
                Me.MsgEstadoErrorPanel.Visible = True
                Me.texto_error.Text = "Error! El formato del dni no es correcto. Debe estar formado por 8 dígitos y una letra distinta de 'Ñ' (Ejemplo: 11111111A)"
                limpiar_dni()
            End If
        Else
            Me.MsgEstadoErrorPanel.Visible = True
            Me.texto_error.Text = "Error! Datos incorrectos. Revisa que no hayas incluido espacios o caracteres especiales en los datos."
            limpiar_campos()
        End If
    End Sub

    Private Sub limpiar_campos()
        Me.Nombre.Text = ""
        Me.Telefono.Text = ""
        Me.PrimerApellido.Text = ""
        Me.SegundoApellido.Text = ""
        Me.Correo.Text = ""
        Me.Dni.Text = ""
        Me.Password.Text = ""
        Me.Password2.Text = ""
    End Sub

    Private Sub limpiar_dni()
        Me.Dni.Text = ""
    End Sub

    Private Sub limpiar_telf()
        Me.Telefono.Text = ""
    End Sub

    Private Sub limpiar_email()
        Me.Correo.Text = ""
    End Sub

    Private Sub limpiar_passwds()
        Me.Password.Text = ""
        Me.Password2.Text = ""
    End Sub

    Protected Sub VolverButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles VolverButton.Click, Volver2Button.Click
        Try
            If Not procedencia Is Nothing AndAlso Not procedencia.Trim.Equals("") Then
                Response.Redirect(procedencia)
            End If
        Catch ex As Exception

        End Try
    End Sub
End Class
