﻿Imports accesoBDeRestaurante.mesa_bd
Imports accesoBDeRestaurante.cliente_bd
Imports variables_globales
Imports AjaxControlToolkit
Imports accesoBDeRestaurante.pedido_bd
Imports accesoBDeRestaurante.camarero_bd
Imports System.Threading
Imports funciones_generales

Partial Class camarero_AsignarMesaCliente
    Inherits System.Web.UI.Page

    Shared mesa_clave As mesa_clave

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Try
            If Not IsPostBack Then

                ' Recojo el id de la mesa a asignar
                mesa_clave.id = Request.QueryString("id")

                InicializarDatos()
                EstadoDatos()

                ' Si la mesa existe muestro los datos, sino lanzo excepcion
                If existe_mesa(mesa_clave, cadena_conexion) Then
                    MostrarDatos()
                Else
                    Throw New Exception()
                End If
            End If
        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoLbl.Text = "Error al mostrar los datos"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try

    End Sub

    Protected Sub InicializarDatos()
        Me.NoMesaTxt.Text = ""
        Me.FechaTxt.Text = "01/01/1990"
        Me.ClienteIdTxt.Text = ""
        Me.ClienteNombreTxt.Text = ""
        Me.CamareroIdTxt.Text = ""
        Me.CamareroNombreTxt.Text = ""
        Me.ComensalesAsignarTxt.Text = 0
    End Sub

    Protected Sub EstadoDatos()
        Me.NoMesaTxt.ReadOnly = True
        Me.ClienteIdTxt.Enabled = False
        Me.CamareroIdTxt.Enabled = False
        Me.FechaTxt.ReadOnly = True
        Me.HoraTxt.ReadOnly = True
    End Sub

    Protected Sub MostrarDatos()
        Dim tmp_mesa_reg As mesa_reg
        Dim tmp_pedido_clave As pedido_clave
        Dim tmp_pedido_reg As pedido_reg
        Dim tmp_cliente_clave As cliente_clave
        Dim tmp_cliente_reg As cliente_reg
        Dim tmp_camarero_clave As camarero_clave
        Dim tmp_camarero_reg As camarero_reg

        tmp_mesa_reg = get_mesa(mesa_clave, cadena_conexion)

        If Not es_error_mesa(tmp_mesa_reg) Then
            Me.NoMesaTxt.Text = tmp_mesa_reg.numero
            Me.FechaTxt.Text = DateAndTime.Now.ToShortDateString
            Me.HoraTxt.Text = DateAndTime.Now.ToShortTimeString
            ' Si la mesa ya está asignada muestro cliente, camarero y comensales asignados para poder modificarlos
            tmp_pedido_clave.id = get_id_pedido_FKMesa(mesa_clave, cadena_conexion)
            tmp_pedido_reg = get_pedido(tmp_pedido_clave, cadena_conexion)
            If Not es_error_pedido(tmp_pedido_reg) Then
                tmp_cliente_clave.id = tmp_pedido_reg.FK_cliente
                Me.ClienteIdTxt.Text = tmp_cliente_clave.id
                tmp_cliente_reg = get_cliente(tmp_cliente_clave, cadena_conexion)
                Me.ClienteNombreTxt.Text = obtener_nombre_apellido1_apellido2(tmp_cliente_reg.nombre, tmp_cliente_reg.apellido1, tmp_cliente_reg.apellido2)
                tmp_camarero_clave.id = tmp_pedido_reg.FK_camarero
                Me.CamareroIdTxt.Text = tmp_camarero_clave.id
                tmp_camarero_reg = get_camarero(tmp_camarero_clave, cadena_conexion)
                Me.CamareroNombreTxt.Text = obtener_nombre_apellido1_apellido2(tmp_camarero_reg.nombre, tmp_camarero_reg.apellido1, tmp_camarero_reg.apellido2)
                Me.ComensalesAsignarTxt.Text = tmp_mesa_reg.comensales
            End If
        Else
            Throw New Exception()
        End If
    End Sub

    Protected Sub GuardarDatos()
        Dim tmp_pedido_reg As New pedido_reg
        Dim tmp_pedido_clave As New pedido_clave
        Dim tmp_mesa_reg As New mesa_reg
        Dim tmp_mesa_clave As New mesa_clave
        Dim tmp_cliente_reg As New cliente_reg
        Dim tmp_camarero_reg As New camarero_reg
        Dim comensales As Integer = 0
        Dim fecha_con_hora As Date
        Dim ret_ok = False

        ' Me guardo el camarero
        tmp_camarero_reg.id = CInt(Me.CamareroIdTxt.Text)

        If Not es_error_camarero(tmp_camarero_reg) Then

            ' Me guardo el cliente
            tmp_cliente_reg.id = CInt(Me.ClienteIdTxt.Text)

            If Not es_error_cliente(tmp_cliente_reg) Then

                ' Me guardo la mesa
                tmp_mesa_reg.id = CInt(mesa_clave.id)

                If Not es_error_mesa(tmp_mesa_reg) Then

                    ' Me guardo los comensales y la hora
                    comensales = CInt(Me.ComensalesAsignarTxt.Text)
                    fecha_con_hora = New DateTime(CDate(Me.FechaTxt.Text).Year, CDate(Me.FechaTxt.Text).Month, CDate(Me.FechaTxt.Text).Day, CDate(Me.HoraTxt.Text).Hour, CDate(Me.HoraTxt.Text).Minute, CDate(Me.HoraTxt.Text).Second, DateTimeKind.Utc)
                    fecha_con_hora = String.Format("{0:yyyy-MM-dd HH:mm:ss}", fecha_con_hora)

                    ' Si la mesa ya estaba asignada actualizo
                    tmp_pedido_clave.id = get_id_pedido_FKMesa(mesa_clave, cadena_conexion)
                    tmp_pedido_reg = get_pedido(tmp_pedido_clave, cadena_conexion)
                    If Not es_error_pedido(tmp_pedido_reg) Then
                        tmp_pedido_reg.fecha = fecha_con_hora
                        tmp_pedido_reg.FK_camarero = tmp_camarero_reg.id
                        tmp_pedido_reg.FK_cliente = tmp_cliente_reg.id
                        tmp_pedido_reg.FK_mesa = tmp_mesa_reg.id

                        If actualizar_pedido(tmp_pedido_reg, cadena_conexion) Then
                            ret_ok = True
                        End If
                    Else
                        ' Sino inserto un nuevo pedido para la mesa
                        tmp_pedido_reg.id = 0
                        tmp_pedido_reg.fecha = fecha_con_hora
                        tmp_pedido_reg.activo = 1
                        tmp_pedido_reg.FK_camarero = tmp_camarero_reg.id
                        tmp_pedido_reg.FK_cliente = tmp_cliente_reg.id
                        tmp_pedido_reg.FK_mesa = tmp_mesa_reg.id

                        If insertar_pedido(tmp_pedido_reg, cadena_conexion) Then
                            ret_ok = True
                        End If

                    End If

                    ' Si el pedido se ha guardado correctamente actualizo los datos de la mesa
                    If ret_ok Then
                        tmp_mesa_clave.id = tmp_mesa_reg.id
                        tmp_mesa_reg = get_mesa(tmp_mesa_clave, cadena_conexion)
                        tmp_mesa_reg.libre = 0
                        tmp_mesa_reg.comensales = comensales
                        If Not actualizar_mesa(tmp_mesa_reg, cadena_conexion) Then
                            Throw New Exception()
                        End If
                    Else
                        Throw New Exception()
                    End If
                End If
            Else
                Throw New Exception()
            End If
        Else
            Throw New Exception()
        End If

    End Sub

    Protected Sub CancelAsignarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelAsignarButton.Click
        Response.Redirect("EstadoMesas.aspx")
    End Sub

    Protected Sub OkAsignarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles OkAsignarButton.Click
        Try

            GuardarDatos()
            Response.Redirect("EstadoMesas.aspx")

        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoLbl.Text = "Error al guardar los datos"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub

    Protected Sub ClienteNombreTxt_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ClienteNombreTxt.TextChanged
        Dim separadores(2) As Char
        separadores(0) = "("
        separadores(1) = ")"
        Me.ClienteIdTxt.Text = Me.ClienteNombreTxt.Text.Split(separadores).GetValue(1)
        Me.ClienteNombreTxt.Text = Me.ClienteNombreTxt.Text.Split(separadores).GetValue(0)
    End Sub

    Protected Sub CamareroNombreTxt_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CamareroNombreTxt.TextChanged
        Dim separadores(2) As Char
        separadores(0) = "("
        separadores(1) = ")"
        Me.CamareroIdTxt.Text = Me.CamareroNombreTxt.Text.Split(separadores).GetValue(1)
        Me.CamareroNombreTxt.Text = Me.CamareroNombreTxt.Text.Split(separadores).GetValue(0)
    End Sub

    Protected Sub RegistroRapidoHyperlink_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles RegistroRapidoHyperlink.Load
        Me.RegistroRapidoHyperlink.NavigateUrl = Me.RegistroRapidoHyperlink.NavigateUrl & "?&proc=../camarero/AsignarMesaCliente.aspx?id=" & mesa_clave.id
    End Sub
End Class
