﻿Imports variables_globales
Imports accesoBDeRestaurante.comentario_bd

Partial Class camarero_Comentarios
    Inherits System.Web.UI.Page

    Protected Const Ret_Vacio As Integer = -1
    Protected Const Ret_Error As Integer = 0
    Protected Const Ret_Correcto As Integer = 1
    Protected Const Ret_NoPedido As Integer = -2

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Try

            If Not IsPostBack Then
                InicializarDatos()
                EstadoDatos()
                ActualizarDatos()
            End If

        Catch ex As Exception
            MsgErrorLbl.Text = "Ha habido un problema al mostrar los comentarios, vuelva a intentarlo o consulte con el administrador.<br />Disculpe las molestias."
            MsgErrorPanel.Visible = True
        End Try

    End Sub

    Protected Sub InicializarDatos()
        Me.ComentariosGridView.DataSource = Nothing
        Me.ComentariosGridView.DataBind()
        Me.MsgEstadoLbl.Text = ""
        Me.MsgErrorLbl.Text = ""
    End Sub

    Protected Sub EstadoDatos()
        Me.MsgEstadoLbl.Visible = False
        Me.MsgErrorPanel.Visible = False
    End Sub

    Protected Sub ActualizarDatos()
        Dim ret_ok As Boolean = True

        Select Case ActualizarGridView()
            Case Ret_Vacio
                MsgEstadoLbl.Text = "No hay comentarios disponibles"
                MsgEstadoLbl.Visible = True
                Me.EliminarButton.Visible = False
            Case Ret_Error
                ret_ok = False
                Me.EliminarButton.Visible = False
            Case Ret_Correcto
                Me.MsgEstadoLbl.Visible = False
                Me.MsgErrorPanel.Visible = False
                Me.EliminarButton.Visible = True
        End Select

        If ret_ok = Ret_Error Then
            Throw New Exception()
        End If
    End Sub

    Protected Function ActualizarGridView() As Integer
        Dim ret_ok As Integer

        ret_ok = LlenarGridView()
        Me.ComentariosGridView.DataBind()

        Return ret_ok
    End Function

    Protected Function LlenarGridView() As Integer
        Dim ret_ok As Integer = Ret_Correcto
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand

        Try

            ' Recupero los clientes del restaurante
            comando = get_todos_comentarios_str(cadena_conexion)

            MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
            MyDataSet.Clear()
            MyDataAdapter.Fill(MyDataSet)
            If MyDataSet.Tables(0).Rows.Count = 0 Then
                ret_ok = Ret_Vacio
            Else
                Me.ComentariosGridView.DataSource = MyDataSet.Tables(0)
            End If

        Catch ex As Exception
            ret_ok = Ret_Error
        End Try

        Return ret_ok
    End Function

    Protected Function EliminarComentario(ByVal index As Integer) As Integer
        Dim tmp_comentario_clave As comentario_clave
        Dim ret_ok As Integer = 1

        Try
            tmp_comentario_clave.id = CInt(Me.ComentariosGridView.Rows(index).Cells(1).Text)
            If existe_comentario(tmp_comentario_clave, cadena_conexion) Then
                If Not eliminar_comentario(tmp_comentario_clave, cadena_conexion) Then
                    ret_ok = 0
                End If
            Else
                ret_ok = 0
            End If
        Catch ex As Exception
            ret_ok = 0
        End Try

        Return ret_ok
    End Function

    Protected Function EliminarVariosComentarios() As Boolean
        Dim tmp_comentario_clave As comentario_clave
        Dim lista_id_comentarios As New List(Of Integer)
        Dim ret_ok As Boolean = True

        Try
            ' Recupero las filas seleccionadas
            For Each row As GridViewRow In Me.ComentariosGridView.Rows
                Dim ch As CheckBox = CType(row.FindControl("SelectCheck"), CheckBox)
                If ch.Checked Then
                    tmp_comentario_clave.id = CInt(row.Cells(1).Text)
                    lista_id_comentarios.Add(tmp_comentario_clave.id)
                End If
            Next

            If Not eliminar_varios_comentarios(lista_id_comentarios, cadena_conexion) Then
                Throw New Exception()
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Sub ComentariosGridView_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles ComentariosGridView.PageIndexChanging
        Me.ComentariosGridView.PageIndex = e.NewPageIndex()
        InicializarDatos()

        If ActualizarGridView() Then
            Me.MsgEstadoLbl.Visible = False
        Else
            Me.MsgEstadoLbl.Visible = True
        End If

        Try
            If Me.ComentariosGridView.SelectedIndex <> -1 Then
                If Me.ComentariosGridView.SelectedIndex Mod 2 = 0 Then
                    Me.ComentariosGridView.Rows(Me.ComentariosGridView.SelectedIndex).RowState = DataControlRowState.Normal
                Else
                    Me.ComentariosGridView.Rows(Me.ComentariosGridView.SelectedIndex).RowState = DataControlRowState.Alternate
                End If
            End If
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub ComentariosGridView_RowDeleting(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewDeleteEventArgs) Handles ComentariosGridView.RowDeleting
        Dim ret_ok As Integer = 0

        ret_ok = EliminarComentario(e.RowIndex)

        If ret_ok = 1 Then
            ActualizarDatos()
        Else
            MsgErrorLbl.Text = "Error al eliminar el comentario, vuelva a intentarlo o consulte al administrador.<br>Disculpe las molestias"
            MsgErrorPanel.Visible = True
        End If
    End Sub

    Protected Sub EliminarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EliminarButton.Click
        If Not EliminarVariosComentarios() Then
            Me.MsgErrorPanel.Visible = True
            Me.MsgErrorLbl.Text = "Puede que no se haya eliminado correctamente alg&uacute;n comentario."
        End If
        ActualizarDatos()
    End Sub

End Class
