﻿Imports variables_globales
Imports accesoBDeRestaurante.pedido_bd
Imports accesoBDeRestaurante.consumicion_bd
Imports accesoBDeRestaurante.itemconsumicion_bd
Imports accesoBDeRestaurante.mesa_bd


Partial Class camarero_Consumiciones
    Inherits System.Web.UI.Page

    Protected Const Ret_Vacio As Integer = -1
    Protected Const Ret_Error As Integer = 0
    Protected Const Ret_Correcto As Integer = 1
    Protected Const Ret_NoPedido As Integer = -2
    Protected Shared pedido_actual_clave As pedido_clave
    Protected Shared mesa_clave As mesa_clave
    Protected Shared camino_ant As String = ""
    Protected Shared camino_ret As String = ""
    Protected Shared camino_ret2 As String = ""

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Try
            If Not IsPostBack Then
                ' Recupero los parámetros pasados por el método GET
                pedido_actual_clave.id = CInt(Request.QueryString("id"))
                mesa_clave.id = CInt(Request.QueryString("mesa"))
                camino_ant = Trim(Request.QueryString("nav"))
                camino_ret = Trim(Request.QueryString("nav_ret"))
                camino_ret2 = Trim(Request.QueryString("nav_ret2"))

                If existe_pedido(pedido_actual_clave, cadena_conexion) Then
                    Me.CaminoLbl.Text = camino_ant & ">Consumiciones"
                    InicializarDatos()
                    EstadoDatos(True)
                    ActualizarDatos()
                Else
                    Throw New Exception()
                End If

            End If
        Catch ex As Exception
            MsgErrorPanel.Visible = True
            MsgErrorLbl.Text = "Ha habido un problema al mostrar las consumiciones. Vuelva a intentarlo o consulte con el administrador.<br />Disculpe las molestias."
        End Try

    End Sub

    Protected Sub InicializarDatos()
        Me.MsgErrorPanel.Visible = False
        Me.PedidoGridView.DataSource = Nothing
        Me.PedidoGridView.DataBind()
        Me.PrecioTxt.Text = "0 €"
        Me.MsgErrorPanel.Visible = False
    End Sub

    Protected Sub EstadoDatos(ByVal est As Boolean)
        Me.AddProductosButton.Visible = est
        Me.VolverButton.Visible = True
    End Sub

    Protected Sub ActualizarDatos()
        Dim ret_ok As Boolean = True

        Select Case ActualizarGridViewPedido()
            Case Ret_Vacio
                MsgEstadoLbl.Text = "No hay consumiciones añadidas al pedido"
                MsgEstadoUpdatePanel.Visible = True
                MsgEstadoLbl.CssClass = "gris-oscuro"
            Case Ret_Error
                ret_ok = False
            Case Ret_Correcto

        End Select

        ActualizarDatosPedido()

        If ret_ok = Ret_Error Then
            Throw New Exception()
        End If
    End Sub

    Protected Function ActualizarGridViewPedido() As Integer
        Dim ret_ok As Integer

        ret_ok = LlenarGridViewPedido()
        Me.PedidoGridView.DataBind()

        Return ret_ok
    End Function

    Protected Function LlenarGridViewPedido() As Integer
        Dim ret_ok As Integer = Ret_Correcto
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand

        Try

            ' Muestro las consumiciones del pedido si el pedido existe
            If pedido_actual_clave.id <> -1 Then
                If existe_pedido(pedido_actual_clave, cadena_conexion) Then

                    ' Recupero las consumiciones del pedido
                    comando = get_consumiciones_pedido_str(pedido_actual_clave, cadena_conexion)

                    MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
                    MyDataSet.Clear()
                    MyDataAdapter.Fill(MyDataSet)
                    If MyDataSet.Tables(0).Rows.Count = 0 Then
                        ret_ok = Ret_Vacio
                    Else
                        Me.PedidoGridView.DataSource = MyDataSet.Tables(0)
                    End If
                Else
                    ret_ok = Ret_NoPedido
                End If
            Else
                ret_ok = Ret_NoPedido
            End If
        Catch ex As Exception
            ret_ok = Ret_Error
        End Try

        Return ret_ok
    End Function

    Protected Sub ActualizarDatosPedido()
        Dim tmp_pedido_reg As pedido_reg

        tmp_pedido_reg = get_pedido(pedido_actual_clave, cadena_conexion)

        If Not es_error_pedido(tmp_pedido_reg) Then
            Me.PrecioTxt.Text = tmp_pedido_reg.precio & " €"
        End If
    End Sub

    Protected Function EliminarConsumicion(ByVal index As Integer) As Boolean
        Dim tmp_consumicion_clave As consumicion_clave
        Dim tmp_pedido_reg As pedido_reg
        Dim ret_ok As Boolean = True

        Try
            tmp_consumicion_clave.id = CInt(Me.PedidoGridView.Rows(index).Cells(0).Text)

            If existe_consumicion(tmp_consumicion_clave, cadena_conexion) Then
                If eliminar_consumicion(tmp_consumicion_clave, cadena_conexion) Then

                    ' Si al eliminar la consumición el pedido queda servido lo marco como tal
                    If get_num_consumiciones_sin_servir_pedido(pedido_actual_clave, cadena_conexion) = 0 Then

                        tmp_pedido_reg = get_pedido(pedido_actual_clave, cadena_conexion)

                        If tmp_pedido_reg.servido = 0 Then

                            tmp_pedido_reg.servido = 1
                            If Not actualizar_pedido(tmp_pedido_reg, cadena_conexion) Then
                                ret_ok = False
                            End If

                        End If
                    End If

                Else
                    ret_ok = False
                End If
            Else
                ret_ok = False
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function ActualizarPrecioPedido(ByVal index As Integer) As Boolean
        Dim tmp_pedido_reg As pedido_reg
        Dim precio As Decimal = 0.0
        Dim cantidad As Integer = 0
        Dim ret_ok As Boolean = True

        Try
            precio = CDec(Me.PedidoGridView.Rows(index).Cells(5).Text)
            tmp_pedido_reg = get_pedido(pedido_actual_clave, cadena_conexion)
            If Not es_error_pedido(tmp_pedido_reg) Then
                tmp_pedido_reg.precio -= precio
                If Not actualizar_pedido(tmp_pedido_reg, cadena_conexion) Then
                    ret_ok = False
                End If
            Else
                ret_ok = False
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Sub AddDelItemConsumicion(ByVal commandname As String, ByVal indice As Integer)
        Dim fila As Integer = -1
        Dim tmp_pedido_actual_reg As pedido_reg
        Dim tmp_consumicion_clave As consumicion_clave
        Dim tmp_consumicion_reg As consumicion_reg
        Dim tmp_itemconsumicion_clave As itemconsumicion_clave
        Dim tmp_itemconsumicion_reg As itemconsumicion_reg
        Dim marca As Boolean = False
        Dim ret_ok As Boolean = True

        fila = indice
        If fila <> -1 Then
            tmp_consumicion_clave.id = CInt(Me.PedidoGridView.Rows(fila).Cells(0).Text)
            tmp_consumicion_reg = get_consumicion(tmp_consumicion_clave, cadena_conexion)

            ' Añado una unidad de consumicion mas
            With tmp_consumicion_reg

                ' Si la consumicion ya existia añado una unidad de consumicion más, sino, será la primera
                If Not es_error_consumicion(tmp_consumicion_reg) Then

                    Select Case commandname
                        Case "Mas"
                            .cantidad = tmp_consumicion_reg.cantidad + 1
                        Case "Menos"
                            .cantidad = tmp_consumicion_reg.cantidad - 1
                            If .cantidad = 0 Then
                                marca = True
                            End If
                    End Select

                    tmp_itemconsumicion_clave.id = tmp_consumicion_reg.FK_itemconsumicion
                    tmp_itemconsumicion_reg = get_itemconsumicion(tmp_itemconsumicion_clave, cadena_conexion)

                    If Not es_error_itemconsumicion(tmp_itemconsumicion_reg) Then
                        If Not marca Then
                            .precio = (tmp_itemconsumicion_reg.precio * (.cantidad))
                            ret_ok = actualizar_consumicion(tmp_consumicion_reg, cadena_conexion)
                        Else
                            ret_ok = eliminar_consumicion(tmp_consumicion_clave, cadena_conexion)
                        End If

                        If ret_ok Then
                            If existe_pedido(pedido_actual_clave, cadena_conexion) Then
                                tmp_pedido_actual_reg = get_pedido(pedido_actual_clave, cadena_conexion)
                                tmp_pedido_actual_reg.servido = 0
                                tmp_pedido_actual_reg.pagado = 0
                                Select Case commandname
                                    Case "Mas"
                                        tmp_pedido_actual_reg.precio += tmp_itemconsumicion_reg.precio
                                    Case "Menos"
                                        tmp_pedido_actual_reg.precio -= tmp_itemconsumicion_reg.precio
                                End Select

                                If Not actualizar_pedido(tmp_pedido_actual_reg, cadena_conexion) Then
                                    Throw New Exception()
                                End If
                            Else
                                Throw New Exception()
                            End If
                        End If
                    End If
                End If
            End With

            ActualizarDatos()
        End If
    End Sub

    Protected Sub ServirItemConsumicion(ByVal fila As Integer, ByVal des_servir As Boolean)
        Dim tmp_consumicion_reg As consumicion_reg
        Dim tmp_consumicion_clave As consumicion_clave
        Dim tmp_pedido_reg As pedido_reg
        Dim es_pedido_servido As Integer = 0

        If (fila > -1) Then
            ' Obtengo el id de la consumicion seleccionada
            tmp_consumicion_clave.id = CInt(Me.PedidoGridView.Rows.Item(fila).Cells(0).Text)

            ' Obtengo el registro de la bd de la consumicion seleccionada
            tmp_consumicion_reg = get_consumicion(tmp_consumicion_clave, cadena_conexion)

            If Not es_error_consumicion(tmp_consumicion_reg) Then

                If Not des_servir Then
                    ' Marco como servido un itemconsumicion mas 
                    If tmp_consumicion_reg.servida < tmp_consumicion_reg.cantidad Then
                        tmp_consumicion_reg.servida += 1
                    End If
                Else
                    ' Marco como servido un itemconsumicion menos
                    If tmp_consumicion_reg.servida > 0 Then
                        tmp_consumicion_reg.servida -= 1
                    End If
                End If

                If actualizar_consumicion(tmp_consumicion_reg, cadena_conexion) Then

                    ' Si todas las consumiciones del pedido están servidas lo marco como servido
                    If get_num_consumiciones_sin_servir_pedido(pedido_actual_clave, cadena_conexion) = 0 Then
                        es_pedido_servido = 1
                    End If

                    ' Recupero y actualizo el pedido actual
                    tmp_pedido_reg = get_pedido(pedido_actual_clave, cadena_conexion)
                    If tmp_pedido_reg.servido <> es_pedido_servido Then
                        tmp_pedido_reg.servido = es_pedido_servido
                        If Not actualizar_pedido(tmp_pedido_reg, cadena_conexion) Then
                            Throw New Exception()
                        End If
                    End If

                Else
                    Throw New Exception()
                End If
            End If

            ActualizarDatos()

        End If

    End Sub

    Protected Sub PedidosGridView_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles PedidoGridView.PageIndexChanging
        Try
            Me.PedidoGridView.PageIndex = e.NewPageIndex()

            If ActualizarGridViewPedido() Then
                Me.MsgEstadoLbl.Visible = False
            Else
                Me.MsgEstadoLbl.Visible = True
            End If

            Try
                If Me.PedidoGridView.SelectedIndex <> -1 Then
                    If Me.PedidoGridView.SelectedIndex Mod 2 = 0 Then
                        Me.PedidoGridView.Rows(Me.PedidoGridView.SelectedIndex).RowState = DataControlRowState.Normal
                    Else
                        Me.PedidoGridView.Rows(Me.PedidoGridView.SelectedIndex).RowState = DataControlRowState.Alternate
                    End If
                End If
            Catch ex As Exception

            End Try
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub PedidoGridView_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles PedidoGridView.RowCommand
        Dim ret_ok As Boolean = True
        Dim fila As Integer = -1
        Dim marca As Boolean = False

        Try
            If e.CommandName.Equals("Mas") OrElse e.CommandName.Equals("Menos") Then
                AddDelItemConsumicion(e.CommandName, e.CommandArgument)
            ElseIf e.CommandName.Equals("Servir") Then
                ServirItemConsumicion(e.CommandArgument, False)
            ElseIf e.CommandName.Equals("Deservir") Then
                ServirItemConsumicion(e.CommandArgument, True)
            End If

        Catch ex As Exception
            MsgErrorPanel.Visible = True
            MsgErrorLbl.Text = "Ha habido un problema al actualizar su pedido"
            MsgErrorLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub PedidoGridView_RowDeleting(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewDeleteEventArgs) Handles PedidoGridView.RowDeleting
        Dim ret_ok As Boolean = False

        ret_ok = EliminarConsumicion(e.RowIndex)

        If ret_ok Then
            ret_ok = ActualizarPrecioPedido(e.RowIndex)
        End If

        If ret_ok Then
            Select Case ActualizarGridViewPedido()
                Case Ret_Vacio
                    MsgEstadoLbl.Text = "No hay consumiciones añadidas al pedido"
                    MsgEstadoUpdatePanel.Visible = True
                    MsgEstadoLbl.CssClass = "gris-oscuro"
                Case Ret_Error
                    ret_ok = False
            End Select
            ActualizarDatosPedido()
        Else
            MsgErrorLbl.Text = "Error al eliminar la consumici&oacute;n, consulte con un empleado por favor"
            MsgErrorPanel.Visible = True
        End If
    End Sub

    Protected Sub VolverButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles VolverButton.Click
        Try
            If existe_pedido(pedido_actual_clave, cadena_conexion) Then
                If (camino_ret2.Equals("")) Then
                    Response.Redirect("DetallesPedido.aspx?id=" & pedido_actual_clave.id & "&mesa=" & mesa_clave.id & "&nav=" & camino_ret)
                Else
                    Response.Redirect("DetallesPedido.aspx?id=" & pedido_actual_clave.id & "&mesa=" & mesa_clave.id & "&nav=" & camino_ret2)
                End If
            End If
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub AddProductosButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddProductosButton.Click
        Try
            If existe_pedido(pedido_actual_clave, cadena_conexion) Then
                Response.Redirect("AddProductosPedido.aspx?id=" & pedido_actual_clave.id & "&mesa=" & mesa_clave.id & "&nav=" & Trim(Me.CaminoLbl.Text) & "&nav_ret=" & Trim(camino_ant) & "&nav_ret2=" & Trim(camino_ret))
            End If
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub PedidoGridView_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles PedidoGridView.RowDataBound
        Dim nombreHyperLink As HyperLink

        Try
            If e.Row.RowType = DataControlRowType.DataRow Then
                nombreHyperLink = CType(e.Row.FindControl("NombreHyperLink"), HyperLink)
                nombreHyperLink.NavigateUrl = "DetallesItemConsumicion.aspx?id=" & nombreHyperLink.NavigateUrl & "&pedido=" & pedido_actual_clave.id & "&mesa=" & mesa_clave.id & "&nav=" & Trim(Me.CaminoLbl.Text) & "&nav_ret=" & Trim(camino_ant) & "&nav_ret2=" & Trim(camino_ret) & "&desde=Consumiciones.aspx"
            End If
        Catch ex As Exception
            MsgErrorPanel.Visible = True
            MsgErrorLbl.Text = "Ha habido un problema al mostrar las consumiciones. Vuelva a intentarlo o consulte con el administrador.<br />Disculpe las molestias."
        End Try
    End Sub

End Class
