﻿Imports variables_globales
Imports accesoBDeRestaurante.camarero_bd

Partial Class camarero_DetallesCamarero
    Inherits System.Web.UI.Page

    Protected Shared camarero As Integer = -1
    Protected Shared acamino As String = ""
    Protected Shared pedido As String = ""
    Protected Shared mesa As Integer = -1

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ret_ok As Boolean = True
        Dim camino As String = ""

        Try
            ' Carga de los datos sólo una vez, cuando la página carga
            If Not IsPostBack Then

                ' Recojo los parametros
                camarero = CInt(Request.QueryString("id"))
                camino = Trim(Request.QueryString("nav"))
                acamino = Trim(Request.QueryString("anav"))
                pedido = CInt(Request.QueryString("pedido"))
                Try
                    mesa = CInt(Request.QueryString("mesa"))
                Catch ex As NotFiniteNumberException
                    mesa = -1
                End Try


                ' Establezco el camino navegacional
                Me.CaminoLbl.Text = camino & ">Detalles de camarero"

                InicializarDatos()
                EstadoDatos()
                MostrarDatos()

            End If

        Catch ex As Exception
            MsgEstadoLbL.Text = "Ha habido un problema al mostrar los datos del camarero"
            MsgEstadoPanel.Visible = True
            MsgEstadoLbL.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub InicializarDatos()
        Me.IdTxt.Text = ""
        Me.NombreTxt.Text = ""
        Me.Apellidos1Txt.Text = ""
        Me.Apellidos2Txt.Text = ""
        Me.FotoImage.ImageUrl = "../img/sinfoto.gif"
        Me.MsgEstadoPanel.Visible = False
    End Sub

    Protected Sub EstadoDatos()
        Me.VolverButton.Visible = True
    End Sub

    Protected Sub MostrarDatos()
        Dim tmp_camarero_reg As camarero_reg
        Dim tmp_camarero_clave As camarero_clave

        tmp_camarero_clave.id = camarero

        If existe_camarero(tmp_camarero_clave, cadena_conexion) Then
            tmp_camarero_reg = get_camarero(tmp_camarero_clave, cadena_conexion)
            Me.IdTxt.Text = tmp_camarero_reg.id
            Me.NombreTxt.Text = tmp_camarero_reg.nombre
            Me.Apellidos1Txt.Text = tmp_camarero_reg.apellido1
            Me.Apellidos2Txt.Text = tmp_camarero_reg.apellido2
            If Trim(tmp_camarero_reg.foto) = "" Then
                Me.FotoImage.ImageUrl = "../img/sinfoto.gif"
            Else
                Me.FotoImage.ImageUrl = tmp_camarero_reg.foto
                Me.FotoImage.ToolTip = tmp_camarero_reg.nombre & " " & tmp_camarero_reg.apellido1 & " " & tmp_camarero_reg.apellido2
            End If
        Else
            Throw New Exception()
        End If
    End Sub

    Protected Sub VolverButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles VolverButton.Click
        If mesa <> -1 Then
            Response.Redirect("DetallesPedido.aspx?id=" & pedido & "&nav=" & acamino & "&mesa=" & mesa)
        Else
            Response.Redirect("DetallesPedido.aspx?id=" & pedido & "&nav=" & acamino)
        End If
    End Sub
End Class
