﻿Imports variables_globales
Imports funciones_generales
Imports accesoBDeRestaurante.usuario_bd
Imports accesoBDeRestaurante.cliente_bd

Partial Class camarero_DetallesCliente
    Inherits System.Web.UI.Page

    Protected Shared op As String
    Protected Shared dni As String
    Protected Shared cliente As Integer = -1
    Protected Shared acamino As String = ""
    Protected Shared pedido As String = ""
    Protected Shared pag_ret As String = ""
    Protected Shared mesa As Integer = -1

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ret_ok As Boolean = True
        Dim camino As String = ""

        Try
            ' Carga de los datos sólo una vez, cuando la página carga
            If Not IsPostBack Then

                ' Recojo los parametros
                cliente = CInt(Request.QueryString("id"))
                camino = Trim(Request.QueryString("nav"))
                acamino = Trim(Request.QueryString("anav"))
                pedido = CInt(Request.QueryString("pedido"))
                pag_ret = Trim(Request.QueryString("pag"))
                Try
                    mesa = CInt(Request.QueryString("mesa"))
                Catch ex As NotFiniteNumberException
                    mesa = -1
                End Try
                
                ' Establezco el camino navegacional
                Me.CaminoLbl.Text = camino & ">Detalles de cliente"

                InicializarDatos()
                EstadoDatos(True, False)
                If Not MostrarDatos() Then
                    Throw New Exception()
                Else
                    Me.MsgEstadoPanel.Visible = False
                End If

            End If

        Catch ex As Exception
            MsgEstadoLbl.Text = "Ha habido un problema al mostrar los datos personales"
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub

    Private Sub InicializarDatos()
        Me.NombreTxt.Text = ""
        Me.Apellido1Txt.Text = ""
        Me.Apellido2Txt.Text = ""
        Me.TelefonoTxt.Text = ""
        Me.DniTxt.Text = ""
        Me.EmailTxt.Text = ""
        Me.PasswordTxt.Text = ""
        Me.NuevoPasswordTxt.Text = ""
        Me.ConfNuevoPasswordTxt.Text = ""
        Me.MsgEstadoPanel.Visible = False
    End Sub

    Private Sub EstadoDatos(ByVal modo_ro As Boolean, ByVal cambiar_passwd As Boolean)
        Me.NombreTxt.Enabled = Not modo_ro
        Me.Apellido1Txt.Enabled = Not modo_ro
        Me.Apellido2Txt.Enabled = Not modo_ro
        Me.DniTxt.Enabled = Not modo_ro
        Me.TelefonoTxt.Enabled = Not modo_ro
        Me.EmailTxt.Enabled = Not modo_ro

        Me.NombreLbl.Visible = Not cambiar_passwd
        Me.NombreTxt.Visible = Not cambiar_passwd
        Me.Apellido1Lbl.Visible = Not cambiar_passwd
        Me.Apellido1Txt.Visible = Not cambiar_passwd
        Me.Apellido2Lbl.Visible = Not cambiar_passwd
        Me.Apellido2Txt.Visible = Not cambiar_passwd
        Me.DniLbl.Visible = Not cambiar_passwd
        Me.DniTxt.Visible = Not cambiar_passwd
        Me.TelefonoLbl.Visible = Not cambiar_passwd
        Me.TelefonoTxt.Visible = Not cambiar_passwd
        Me.EmailLbl.Visible = Not cambiar_passwd
        Me.EmailTxt.Visible = Not cambiar_passwd
        Me.CambiarPasswordPanel.Visible = cambiar_passwd
        Me.ConfirmarNuevoPasswdButton.Visible = cambiar_passwd
        Me.CancelarCambiarPasswdButton.Visible = cambiar_passwd

        Me.ModificarButton.Visible = modo_ro AndAlso Not cambiar_passwd
        Me.VolverButton.Visible = modo_ro AndAlso Not cambiar_passwd
        Me.GuardarButton.Visible = Not modo_ro AndAlso Not cambiar_passwd
        Me.CancelarButton.Visible = Not modo_ro AndAlso Not cambiar_passwd
        Me.CambiarPasswdButton.Visible = modo_ro AndAlso Not cambiar_passwd
    End Sub

    Private Function MostrarDatos() As Boolean
        Dim ret_ok As Boolean = True
        Dim tmp_usuario_clave As usuario_clave
        Dim tmp_usuario_reg As usuario_reg
        Dim tmp_cliente_clave As cliente_clave
        Dim tmp_cliente_reg As cliente_reg

        Try
            ' Obtengo el cliente del que vamos a mostrar los detalles
            tmp_cliente_clave.id = cliente
            tmp_cliente_reg = get_cliente(tmp_cliente_clave, cadena_conexion)
            tmp_usuario_clave.id = tmp_cliente_reg.FK_usuario
            tmp_usuario_reg = get_usuario(tmp_usuario_clave, cadena_conexion)

            ' Muestro los datos si no hay error
            If es_error_usuario(tmp_usuario_reg) OrElse es_error_cliente(tmp_cliente_reg) Then
                Throw New Exception()
            End If

            Me.NombreTxt.Text = Trim(tmp_cliente_reg.nombre)
            Me.Apellido1Txt.Text = Trim(tmp_cliente_reg.apellido1)
            Me.Apellido2Txt.Text = Trim(tmp_cliente_reg.apellido2)
            Me.DniTxt.Text = Trim(tmp_usuario_reg.clave)
            dni = Trim(tmp_usuario_reg.clave)
            Me.TelefonoTxt.Text = Trim(tmp_cliente_reg.telefono)
            Me.EmailTxt.Text = Trim(tmp_cliente_reg.email)

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Sub GuardarDatos()
        Dim tmp_usuario_clave As usuario_clave
        Dim tmp_usuario_reg As usuario_reg
        Dim tmp_cliente_clave As cliente_clave
        Dim tmp_cliente_reg As cliente_reg
        Dim ret_ok As Boolean = True

        Try
            ' Obtengo el cliente 
            tmp_cliente_clave.id = cliente
            tmp_cliente_reg = get_cliente(tmp_cliente_clave, cadena_conexion)
            tmp_usuario_clave.id = tmp_cliente_reg.FK_usuario
            tmp_usuario_reg = get_usuario(tmp_usuario_clave, cadena_conexion)

            ' Recojo los datos si no hay error
            If es_error_usuario(tmp_usuario_reg) OrElse es_error_cliente(tmp_cliente_reg) Then
                Throw New Exception()
            End If

            tmp_cliente_reg.nombre = Trim(Me.NombreTxt.Text)
            tmp_cliente_reg.apellido1 = Trim(Me.Apellido1Txt.Text)
            tmp_cliente_reg.apellido2 = Trim(Me.Apellido2Txt.Text)
            tmp_usuario_reg.clave = Trim(Me.DniTxt.Text)
            tmp_cliente_reg.telefono = Trim(Me.TelefonoTxt.Text)
            tmp_cliente_reg.email = Trim(Me.EmailTxt.Text)

            'Compruebo los datos introducidos
            If validar_datos_cadenas(tmp_cliente_reg, tmp_usuario_reg) Then
                If validar_dni(tmp_usuario_reg.clave) Then
                    If validar_telefono(tmp_cliente_reg) Then
                        If validar_email(tmp_cliente_reg.email) Then

                            If (dni.CompareTo(tmp_usuario_reg.clave)) <> 0 Then
                                ' Guardo los datos modificados si el dni no existe ya
                                If existe_usuario(tmp_usuario_reg, cadena_conexion) Then
                                    ret_ok = False
                                End If
                            End If

                            If ret_ok Then

                                If actualizar_usuario(tmp_usuario_reg, cadena_conexion) Then
                                    If actualizar_cliente(tmp_cliente_reg, cadena_conexion) Then

                                        MsgEstadoLbl.Text = "Datos guardados correctamente"
                                        MsgEstadoPanel.Visible = True
                                        MsgEstadoLbl.CssClass = "verde"
                                        Me.MsgEstadoImage.ImageUrl = icono_ok

                                    Else
                                        Throw New Exception()
                                    End If
                                Else
                                    Throw New Exception()
                                End If
                            Else
                                Me.MsgEstadoLbl.Text = "Error! El dni introducido ya está registrado. Revise el dni."
                                Me.MsgEstadoPanel.Visible = True
                                Me.MsgEstadoLbl.CssClass = "rojo"
                                Me.MsgEstadoImage.ImageUrl = icono_error
                                LimpiarDni()
                                Me.DniTxt.Focus()
                            End If
                        Else
                            Me.MsgEstadoLbl.Text = "Error! El email introducido no es correcto. Revíselo por favor."
                            Me.MsgEstadoPanel.Visible = True
                            Me.MsgEstadoLbl.CssClass = "rojo"
                            Me.MsgEstadoImage.ImageUrl = icono_error
                            LimpiarEmail()
                            Me.EmailTxt.Focus()
                        End If
                    Else
                        Me.MsgEstadoLbl.Text = "Error! El teléfono introducido no es correcto. Revíselo por favor."
                        Me.MsgEstadoPanel.Visible = True
                        Me.MsgEstadoLbl.CssClass = "rojo"
                        Me.MsgEstadoImage.ImageUrl = icono_error
                        LimpiarTelf()
                        Me.TelefonoTxt.Focus()
                    End If
                Else
                    Me.MsgEstadoLbl.Text = "Error! El formato del dni no es correcto. Debe estar formado por 8 dígitos y una letra distinta de 'Ñ' (Ejemplo: 11111111A)"
                    Me.MsgEstadoPanel.Visible = True
                    Me.MsgEstadoLbl.CssClass = "rojo"
                    Me.MsgEstadoImage.ImageUrl = icono_error
                    LimpiarDni()
                    Me.DniTxt.Focus()
                End If
            Else
                Me.MsgEstadoLbl.Text = "Error! Datos incorrectos. Revisa que no hayas incluido espacios o caracteres especiales en los datos."
                Me.MsgEstadoPanel.Visible = True
                Me.MsgEstadoLbl.CssClass = "rojo"
                Me.MsgEstadoImage.ImageUrl = icono_error
                Me.NombreTxt.Focus()
            End If

        Catch ex As Exception
            MsgEstadoLbl.Text = "Ha habido un problema al guardar los datos"
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try

    End Sub

    Protected Sub LimpiarDni()
        Me.DniTxt.Text = ""
    End Sub

    Protected Sub LimpiarEmail()
        Me.EmailTxt.Text = ""
    End Sub

    Protected Sub LimpiarTelf()
        Me.TelefonoTxt.Text = ""
    End Sub

    Protected Sub ModificarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ModificarButton.Click
        Try
            EstadoDatos(False, False)
            If Not MostrarDatos() Then
                Throw New Exception()
            End If

        Catch ex As Exception
            MsgEstadoLbl.Text = "Ha habido un problema al mostrar los datos personales"
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub

    Protected Sub CancelarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelarButton.Click
        Try
            InicializarDatos()
            EstadoDatos(True, False)
            If Not MostrarDatos() Then
                Throw New Exception()
            End If
        Catch ex As Exception
            MsgEstadoLbl.Text = "Ha habido un problema al mostrar los datos personales"
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub

    Protected Function ValidarPasswdActual(ByVal pass As String) As Boolean
        Dim ret_ok As Boolean = True

        Try
            If Trim(Me.PasswordTxt.Text).CompareTo(Trim(pass)) <> 0 Then
                ret_ok = False
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Sub CambiarPasswd()
        Dim tmp_cliente_clave As cliente_clave
        Dim tmp_cliente_reg As cliente_reg
        Dim tmp_usuario_reg As usuario_reg
        Dim tmp_usuario_clave As usuario_clave
        Dim ret_ok As Boolean = True

        Try
            ' Valido que la contraseña actual es la introducida
            tmp_cliente_clave.id = cliente
            tmp_cliente_reg = get_cliente(tmp_cliente_clave, cadena_conexion)
            tmp_usuario_clave.id = tmp_cliente_reg.FK_usuario
            tmp_usuario_reg = get_usuario(tmp_usuario_clave, cadena_conexion)

            If ValidarPasswdActual(tmp_usuario_reg.passwd) Then

                ' Valido la contraseña nueva
                If validar_passwd(Me.NuevoPasswordTxt.Text, Me.ConfNuevoPasswordTxt.Text) Then
                    ' Guardo la nueva contraseña
                    tmp_usuario_reg.passwd = Trim(Me.NuevoPasswordTxt.Text)
                    If actualizar_usuario(tmp_usuario_reg, cadena_conexion) Then
                        MsgEstadoLbl.Text = "Contraseña cambiada correctamente"
                        MsgEstadoPanel.Visible = True
                        MsgEstadoLbl.CssClass = "verde"
                        Me.MsgEstadoImage.ImageUrl = icono_ok
                    End If
                Else
                    MsgEstadoLbl.Text = "La nueva contraseña debe ser igual a la nueva contraseña confirmada"
                    MsgEstadoPanel.Visible = True
                    MsgEstadoLbl.CssClass = "rojo"
                    Me.MsgEstadoImage.ImageUrl = icono_error
                End If

            Else
                MsgEstadoLbl.Text = "La contraseña introducida no es correcta"
                MsgEstadoPanel.Visible = True
                MsgEstadoLbl.CssClass = "rojo"
                Me.MsgEstadoImage.ImageUrl = icono_error
            End If
        Catch ex As Exception
            MsgEstadoLbl.Text = "Ha habido un problema al cambiar la contraseña"
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try

    End Sub

    Protected Sub CambiarPasswdButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CambiarPasswdButton.Click
        Try
            EstadoDatos(False, True)
        Catch ex As Exception
            MsgEstadoLbl.Text = "Ha habido un problema al mostrar el formulario para cambiar la contraseña"
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub

    Protected Sub ConfirmarNuevoPasswdButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ConfirmarNuevoPasswdButton.Click
        Try
            CambiarPasswd()
        Catch ex As Exception
            MsgEstadoLbl.Text = "Ha habido un problema al guardar la nueva contraseña"
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub

    Protected Sub CancelarCambiarPasswdButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelarCambiarPasswdButton.Click
        Try
            InicializarDatos()
            EstadoDatos(True, False)
            If Not MostrarDatos() Then
                Throw New Exception()
            End If
        Catch ex As Exception
            MsgEstadoLbl.Text = "Ha habido un problema al mostrar el formulario para cambiar la contraseña"
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub

    Protected Sub GuardarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GuardarButton.Click
        GuardarDatos()
    End Sub

    Protected Sub VolverButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles VolverButton.Click
        If mesa <> -1 Then
            Response.Redirect(pag_ret & "?id=" & pedido & "&nav=" & acamino & "&mesa=" & mesa)
        Else
            Response.Redirect(pag_ret & "?id=" & pedido & "&nav=" & acamino)
        End If
    End Sub
End Class
