﻿Imports variables_globales
Imports funciones_generales
Imports accesoBDeRestaurante.comentario_bd

Partial Class camarero_DetallesComentario
    Inherits System.Web.UI.Page

    Protected Shared comentario_clave As New comentario_clave

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim camino As String = ""

        Try
            If Not IsPostBack Then

                ' Recupero el id del comentario
                comentario_clave.id = Request.QueryString("id")

                ' Recupero el camino navegacional
                camino = Request.QueryString("nav")
                Me.CaminoLbL.Text = camino & ">Detalles de comentario"

                If existe_comentario(comentario_clave, cadena_conexion) Then
                    InicializarDatos()
                    EstadoDatos(True)
                    MostrarDatos()
                Else
                    Me.ResponderButton.Visible = False
                    Me.EnviarButton.Visible = False
                    Throw New Exception()
                End If

            End If
        Catch ex As Exception
            MsgEstadoLbl.Text = "Ha habido un problema al mostrar los datos. Vuelva a intentarlo o consulte al administrador.<br />Disculpe las molestias."
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub

    Protected Sub InicializarDatos()
        Me.MsgEstadoPanel.Visible = False
        Me.IdTxt.Text = ""
        Me.DesdeTxt.Text = ""
        Me.AsuntoTxt.Text = ""
        Me.ComentarioTxt.Text = ""
    End Sub

    Protected Sub EstadoDatos(ByVal est As Boolean)
        Me.IdLbl.Visible = est
        Me.IdTxt.Visible = est
        Me.IdTxt.Enabled = False
        Me.DesdeTxt.Enabled = Not est
        Me.ParaLbl.Enabled = False
        Me.ParaTxt.Enabled = False
        Me.ParaLbl.Visible = Not est
        Me.ParaTxt.Visible = Not est
        Me.AsuntoTxt.Enabled = Not est
        Me.ComentarioTxt.Enabled = Not est
        Me.VolverButton.Visible = True
        Me.ResponderButton.Visible = est
        Me.EnviarButton.Visible = Not est
        If est Then
            Me.TituloLbL.Text = "Detalles de comentario"
        Else
            Me.TituloLbL.Text = "Responder comentario"
        End If
    End Sub

    Protected Sub MostrarDatos()
        Dim tmp_comentario_reg As comentario_reg

        tmp_comentario_reg = get_comentario(comentario_clave, cadena_conexion)

        If Not es_error_comentario(tmp_comentario_reg) Then
            Me.IdTxt.Text = tmp_comentario_reg.id
            Me.DesdeTxt.Text = tmp_comentario_reg.desde
            Me.AsuntoTxt.Text = tmp_comentario_reg.asunto
            Me.ComentarioTxt.Text = tmp_comentario_reg.comentario
        End If
    End Sub

    Protected Sub EnviarRespuesta()
        Dim correo As New System.Net.Mail.MailMessage
        Dim smtp As New System.Net.Mail.SmtpClient
        Dim desde As String = ""
        Dim asunto As String = ""
        Dim para As String = ""
        Dim comentario As String = ""
        Dim smtpServer As String = "localhost"

        ' Recojo los datos
        desde = Trim(Me.DesdeTxt.Text)
        para = Trim(Me.ParaTxt.Text)
        asunto = Trim(Me.AsuntoTxt.Text)
        comentario = Trim(Me.ComentarioTxt.Text)

        ' Valido los datos
        If ValidarDatos(desde, para, asunto, comentario) Then

            ' Guardo los datos en el objeto de tipo correo
            correo.From = New System.Net.Mail.MailAddress(desde)
            correo.To.Add(para)
            correo.Subject = asunto
            correo.Body = comentario
            correo.IsBodyHtml = False
            correo.Priority = System.Net.Mail.MailPriority.Normal


            ' Indico el servidor de correo smtp
            smtp = New System.Net.Mail.SmtpClient(smtpServer)

            ' Envio el comentario
            smtp.Send(correo)

        Else
            Throw New Exception()
        End If

    End Sub

    Protected Function ValidarDatos(ByVal d As String, ByVal p As String, ByVal a As String, ByVal c As String) As Boolean
        Dim ret_ok As Boolean = False

        If validar_email(d) AndAlso validar_email(p) Then
            If Not Trim(a).Equals("") Then
                If Not Trim(c).Equals("") Then
                    ret_ok = True
                End If
            End If
        End If

        Return ret_ok
    End Function

    Protected Sub VolverButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles VolverButton.Click
        Try
            Response.Redirect("Comentarios.aspx")
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub ResponderButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ResponderButton.Click
        Dim desde As String = ""
        Dim asunto As String = "Re: "

        Try
            EstadoDatos(False)
            asunto &= Trim(Me.AsuntoTxt.Text)
            desde = Trim(Me.DesdeTxt.Text)
            InicializarDatos()
            Me.ParaTxt.Text = desde
            Me.AsuntoTxt.Text = asunto
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub EnviarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EnviarButton.Click
        Try
            EnviarRespuesta()
            MsgEstadoLbl.Text = "Respuesta enviada correctamente"
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "verde"
            Me.MsgEstadoImage.ImageUrl = icono_ok
        Catch ex As Exception
            MsgEstadoLbl.Text = "No se puede enviar la respuesta. Revise que haya rellenado todos los datos por favor."
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub
End Class
