﻿Imports accesoBDeRestaurante.producto_bd
Imports accesoBDeRestaurante.tipoproducto_bd
Imports accesoBDeRestaurante.itemconsumicion_bd
Imports variables_globales
Imports accesoBDeRestaurante.productosmenu_bd
Imports accesoBDeRestaurante.menu_bd
Imports accesoBDeRestaurante.pedido_bd
Imports accesoBDeRestaurante.mesa_bd

Partial Class camarero_DetallesItemConsumicion
    Inherits System.Web.UI.Page

    Protected Shared id_itemconsumicion As Integer = -1
    Protected Shared pedido_actual_clave As pedido_clave
    Protected Shared mesa_clave As mesa_clave
    Protected Shared camino_ret As String
    Protected Shared camino_ret2 As String
    Protected Const Ret_Vacio As Integer = -1
    Protected Const Ret_Error As Integer = 0
    Protected Const Ret_Correcto As Integer = 1
    Protected Const Ret_NoPedido As Integer = -2

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ret_ok As Boolean = True
        Dim desde As String = ""
        Dim camino As String = ""
        Dim es_menu As Boolean = False

        Try
            ' Carga de los datos sólo una vez, cuando la página carga
            If Not IsPostBack Then

                ' Recupero el producto
                id_itemconsumicion = CInt(Request.QueryString("id"))

                ' Recupero el pedido
                pedido_actual_clave.id = CInt(Request.QueryString("pedido"))

                ' Recupero la mesa
                mesa_clave.id = CInt(Request.QueryString("mesa"))

                ' Recupero la pagina de la que vengo
                desde = Request.QueryString("desde")

                ' Recupero el camino navegacional y lo establezco
                camino = Request.QueryString("nav")
                Me.CaminoLbl.Text = camino & ">Detalles ItemConsumici&oacute;n"

                ' Recupero los caminos para volver
                camino_ret = Request.QueryString("nav_ret")
                camino_ret2 = Request.QueryString("nav_ret2")

                InicializarDatos()
                es_menu = EsMenu(id_itemconsumicion)
                If es_menu Then
                    Me.TituloLbl.Text = "Men&uacute;"
                Else
                    Me.TituloLbl.Text = "Producto"
                End If
                EstadoDatos(es_menu)
                MostrarDatos(es_menu)

                If Not ret_ok Then
                    Throw New Exception()
                End If
            End If
        Catch ex As Exception
            Me.MsgEstadoLbl.Text = "Error al mostrar los datos"
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub

    Private Sub InicializarDatos()
        Me.NombreTxt.Text = ""
        Me.DescripcionTxt.Text = ""
        Me.PrecioTxt.Text = 0
        Me.TipoProductoTxt.Text = ""
        Me.MsgEstadoPanel.Visible = False
    End Sub

    Private Sub EstadoDatos(ByVal es_menu As Boolean)

        Me.TipoProductoLbl.Visible = Not es_menu
        Me.TipoProductoTxt.Visible = Not es_menu
        Me.ProductosMenuPanel.Visible = es_menu
        Me.VolverButton.Visible = True

    End Sub

    Private Function MostrarDatos(ByVal es_menu As Boolean) As Boolean
        Dim tmp_itemconsumicion_clave As New itemconsumicion_clave
        Dim tmp_itemconsumicion_reg As New itemconsumicion_reg
        Dim tmp_tipoproducto_clave As New tipoproducto_clave
        Dim tmp_tipoproducto_reg As New tipoproducto_reg
        Dim tmp_producto_reg As New producto_reg
        Dim ret_ok As Boolean = True

        Try
            If (id_itemconsumicion <> -1) Then
                tmp_itemconsumicion_clave.id = id_itemconsumicion
                tmp_itemconsumicion_reg = get_itemconsumicion(tmp_itemconsumicion_clave, cadena_conexion)

                If Not es_error_itemconsumicion(tmp_itemconsumicion_reg) Then
                    Me.IdTxt.Text = tmp_itemconsumicion_reg.id
                    Select Case tmp_itemconsumicion_reg.tipo
                        Case "M"
                            Me.TipoTxt.Text = "Men&uacute;"
                        Case "P"
                            Me.TipoTxt.Text = "Producto"
                    End Select
                    Me.NombreTxt.Text = tmp_itemconsumicion_reg.nombre
                    Me.DescripcionTxt.Text = tmp_itemconsumicion_reg.descripcion
                    Me.PrecioTxt.Text = tmp_itemconsumicion_reg.precio
                    If Not es_menu Then
                        tmp_producto_reg = get_producto_FKItemConsumicion(tmp_itemconsumicion_clave, cadena_conexion)
                        tmp_tipoproducto_clave.id = tmp_producto_reg.FK_tipoproducto
                        tmp_tipoproducto_reg = get_tipoproducto(tmp_tipoproducto_clave, cadena_conexion)
                        Me.TipoProductoTxt.Text = tmp_tipoproducto_reg.nombre
                    Else
                        ActualizarGridView()
                    End If
                Else
                    ret_ok = False
                End If
            Else
                ret_ok = False
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function ActualizarGridView() As Integer
        Dim ret_ok As Integer

        ret_ok = LlenarGridView()
        Me.ProductosGridView.DataBind()

        Return ret_ok
    End Function

    Protected Function LlenarGridView() As Integer
        Dim ret_ok As Integer = Ret_Correcto
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand
        Dim tmp_itemconsumicion_clave As itemconsumicion_clave
        Dim tmp_menu_clave As menu_clave

        Try

            ' Recupero los productos del menu
            tmp_itemconsumicion_clave.id = id_itemconsumicion
            tmp_menu_clave.id = get_menu_FKItemConsumicion(tmp_itemconsumicion_clave, cadena_conexion).id
            comando = get_productosmenu_FKMenu_str(tmp_menu_clave, cadena_conexion)

            MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
            MyDataSet.Clear()
            MyDataAdapter.Fill(MyDataSet)
            If MyDataSet.Tables(0).Rows.Count = 0 Then
                ret_ok = Ret_Vacio
            Else
                Me.ProductosGridView.DataSource = MyDataSet.Tables(0)
            End If

        Catch ex As Exception
            ret_ok = Ret_Error
        End Try

        Return ret_ok
    End Function

    Protected Function EsMenu(ByVal item As Integer) As Boolean
        Dim ret As Boolean = False
        Dim tmp_itemconsumicion_clave As itemconsumicion_clave
        Dim tmp_itemconsumicion_reg As itemconsumicion_reg

        ' Recupero el item de consumicion
        tmp_itemconsumicion_clave.id = item
        tmp_itemconsumicion_reg = get_itemconsumicion(tmp_itemconsumicion_clave, cadena_conexion)

        ' Compruebo si es menu o no
        ret = (tmp_itemconsumicion_reg.tipo = "M")

        Return ret
    End Function

    Protected Sub ProductosGridView_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles ProductosGridView.PageIndexChanging
        Me.ProductosGridView.PageIndex = e.NewPageIndex()

        ActualizarGridView()

        Try
            If Me.ProductosGridView.SelectedIndex <> -1 Then
                If Me.ProductosGridView.SelectedIndex Mod 2 = 0 Then
                    Me.ProductosGridView.Rows(Me.ProductosGridView.SelectedIndex).RowState = DataControlRowState.Normal
                Else
                    Me.ProductosGridView.Rows(Me.ProductosGridView.SelectedIndex).RowState = DataControlRowState.Alternate
                End If
            End If

        Catch ex As Exception

        End Try
    End Sub

    Protected Sub VolverButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles VolverButton.Click
        Try
            Response.Redirect("Consumiciones.aspx?id=" & pedido_actual_clave.id & "&mesa=" & mesa_clave.id & "&nav=" & camino_ret & "&nav_ret=" & camino_ret2)
        Catch ex As Exception

        End Try
    End Sub
End Class
