﻿Imports variables_globales
Imports accesoBDeRestaurante.pedido_bd
Imports accesoBDeRestaurante.mesa_bd
Imports accesoBDeRestaurante.camarero_bd
Imports accesoBDeRestaurante.cliente_bd

Partial Class camarero_DetallesPedido
    Inherits System.Web.UI.Page

    Protected Shared pedido_clave As New pedido_clave
    Protected Shared mesa_clave As New mesa_clave
    Protected Shared camino As String = ""
    Protected Const PantallaPedidos As String = ">Pedidos"
    Protected Const PantallaEstadoMesas As String = ">Estado mesas"

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim pedido_actual_reg As pedido_reg

        Try
            If Not IsPostBack Then
                ' Recupero el pedido actual
                pedido_clave.id = CInt(Request.QueryString("id"))
                ' Recupero la mesa
                mesa_clave.id = CInt(Request.QueryString("mesa"))
                ' Recupero el camino navegacional y lo establezco
                camino = Trim(Request.QueryString("nav"))
                Me.CaminoLbl.Text = camino & ">Detalles de pedido"

                pedido_actual_reg = get_pedido(pedido_clave, cadena_conexion)
                InicializarDatos()
                EstadoDatos(True)
                MostrarDatos()

            End If
        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.Text = "Ha habido un problema al mostrar los detalles de pedido, vuelva a intentarlo o consulte con un empleado.<br />Disculpe las molestias."
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub InicializarDatos()
        Me.MsgEstadoPanel.Visible = False
        'Mesa
        Me.IdMesaTxt.Text = "-"
        Me.NumeroMesaTxt.Text = "-"
        Me.MaxComensalesTxt.Text = "0"
        Me.ComensalesTxt.Text = "0"
        Me.NoMesasTxt.Text = "0"
        Me.LibreMesaTxt.Text = "S&iacute;"
        'Pedido
        Me.IdPedidoTxt.Text = "-"
        Me.FechaPedidoTxt.Text = "-"
        Me.ActivoPedidoTxt.Text = "No"
        Me.ServidoPedidoTxt.Text = "No"
        Me.ConfirmadoPedidoTxt.Text = "No"
        Me.PrecioTotalPedidoTxt.Text = "0 €"
        Me.PagadoPedidoTxt.Text = "No"
        Me.CamareroHyperLink.Text = "-"
    End Sub

    Protected Sub EstadoDatos(ByVal est As Boolean)
        Me.MarcarPagadoButton.Visible = est
    End Sub

    Protected Sub MostrarDatos()
        Dim tmp_pedido_reg As pedido_reg
        Dim tmp_camarero_clave As camarero_clave
        Dim tmp_camarero_reg As camarero_reg
        Dim tmp_mesa_reg As mesa_reg
        Dim tmp_mesa_clave As mesa_clave
        Dim tmp_cliente_clave As cliente_clave
        Dim tmp_cliente_reg As cliente_reg

        ' Obtengo el pedido a mostrar
        If existe_pedido(pedido_clave, cadena_conexion) Then
            tmp_pedido_reg = get_pedido(pedido_clave, cadena_conexion)

            ' Muestro los datos del pedido
            Me.InfoPedidoPanel.Visible = True
            Me.NoHayPedidoPanel.Visible = False
            Me.IdPedidoTxt.Text = tmp_pedido_reg.id
            Me.FechaPedidoTxt.Text = tmp_pedido_reg.fecha.ToShortDateString & " " & tmp_pedido_reg.fecha.ToLongTimeString
            ' Activo
            Me.ActivoPedidoTxt.Text = "No"
            If tmp_pedido_reg.activo = 1 Then
                Me.ActivoPedidoTxt.Text = "S&iacute;"
            End If
            ' Servido
            Me.ServidoPedidoTxt.Text = "No"
            If tmp_pedido_reg.servido = 1 Then
                Me.ServidoPedidoTxt.Text = "S&iacute;"
            End If
            ' Confirmado
            Me.ConfirmadoPedidoTxt.Text = "No"
            If tmp_pedido_reg.confirmado = 1 Then
                Me.ConfirmadoPedidoTxt.Text = "S&iacute;"
            End If
            Me.PrecioTotalPedidoTxt.Text = tmp_pedido_reg.precio & " €"
            If tmp_pedido_reg.pagado = 1 Then
                Me.PagadoPedidoTxt.Text = "S&iacute;"
            ElseIf tmp_pedido_reg.pagado = 2 Then
                Me.PagadoPedidoTxt.Text = "Cuenta solicitada"
            Else
                Me.PagadoPedidoTxt.Text = "No"
            End If
            ' Obtengo y muestro el camarero
            tmp_camarero_clave.id = tmp_pedido_reg.FK_camarero
            tmp_camarero_reg = get_camarero(tmp_camarero_clave, cadena_conexion)
            If Not es_error_camarero(tmp_camarero_reg) Then
                Me.CamareroHyperLink.NavigateUrl = "DetallesCamarero.aspx?id=" & tmp_camarero_reg.id & "&mesa=" & mesa_clave.id & "&pedido=" & pedido_clave.id & "&nav=" & Trim(Me.CaminoLbl.Text) & "&anav=" & camino
                Me.CamareroHyperLink.Text = tmp_camarero_reg.nombre & " " & tmp_camarero_reg.apellido1 & " " & tmp_camarero_reg.apellido2
            End If

            ' Obtengo y muestro el cliente
            tmp_cliente_clave.id = tmp_pedido_reg.FK_cliente
            tmp_cliente_reg = get_cliente(tmp_cliente_clave, cadena_conexion)
            If Not es_error_cliente(tmp_cliente_reg) Then
                Me.ClienteHyperLink.NavigateUrl = "DetallesCliente.aspx?id=" & tmp_cliente_reg.id & "&mesa=" & mesa_clave.id & "&pedido=" & pedido_clave.id & "&nav=" & Trim(Me.CaminoLbl.Text) & "&anav=" & camino & "&pag=DetallesPedido.aspx"
                Me.ClienteHyperLink.Text = tmp_cliente_reg.nombre & " " & tmp_cliente_reg.apellido1 & " " & tmp_cliente_reg.apellido2
            End If
        Else
            ' Si no existe ningún pedido informo de ello
            Me.InfoPedidoPanel.Visible = False
            Me.NoHayPedidoPanel.Visible = True
        End If

        ' Obtengo la mesa a mostrar
        tmp_mesa_clave.id = mesa_clave.id
        tmp_mesa_reg = get_mesa(tmp_mesa_clave, cadena_conexion)
        If Not es_error_mesa(tmp_mesa_reg) Then
            ' Muestro los datos de la mesa 
            Me.IdMesaTxt.Text = tmp_mesa_reg.id
            Me.NumeroMesaTxt.Text = tmp_mesa_reg.numero
            Me.MaxComensalesTxt.Text = tmp_mesa_reg.max_personas
            Me.ComensalesTxt.Text = tmp_mesa_reg.comensales
            Me.NoMesasTxt.Text = tmp_mesa_reg.num_mesas
            If tmp_mesa_reg.libre Then
                Me.LibreMesaTxt.Text = "S&iacute;"
                Me.LiberarMesaButton.Visible = False
            Else
                Me.LibreMesaTxt.Text = "No"
                Me.LiberarMesaButton.Visible = True
            End If
        End If
    End Sub

    Protected Sub MarcarPagadoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MarcarPagadoButton.Click
        Dim tmp_pedido_reg As pedido_reg

        Try
            ' Oculto el mensaje de estado
            Me.MsgEstadoPanel.Visible = False

            ' Recupero el pedido
            tmp_pedido_reg = get_pedido(pedido_clave, cadena_conexion)

            If tmp_pedido_reg.pagado = 1 Then
                ' Cambio el estado a no pagado y, por tanto, activo
                tmp_pedido_reg.pagado = 0
                tmp_pedido_reg.activo = 1
            ElseIf tmp_pedido_reg.pagado = 0 OrElse tmp_pedido_reg.pagado = 2 Then
                ' Cambio el estado a pagado y, por tanto, inactivo
                tmp_pedido_reg.pagado = 1
                tmp_pedido_reg.activo = 0
            End If

            ' Lo guardo
            If actualizar_pedido(tmp_pedido_reg, cadena_conexion) Then
                If tmp_pedido_reg.pagado = 0 Then
                    Me.PagadoPedidoTxt.Text = "No"
                    Me.MarcarPagadoButton.Text = "Marcar pagado"
                Else
                    Me.PagadoPedidoTxt.Text = "S&iacute;"
                    Me.MarcarPagadoButton.Text = "Marcar sin pagar"
                End If
            Else
                Throw New Exception()
            End If
        Catch ex As Exception
            Me.MsgEstadoLbl.Text = "Error al guardar como pagado el pedido."
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub ConsumicionesButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ConsumicionesButton.Click
        Try
            If existe_pedido(pedido_clave, cadena_conexion) Then
                Response.Redirect("Consumiciones.aspx?id=" & pedido_clave.id & "&mesa=" & mesa_clave.id & "&nav=" & Trim(Me.CaminoLbl.Text) & "&nav_ret=" & Trim(camino))
            End If
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub OKButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles OKButton.Click
        Dim tmp_pedido_reg As New pedido_reg

        Try

            If existe_pedido(pedido_clave, cadena_conexion) Then
                tmp_pedido_reg = get_pedido(pedido_clave, cadena_conexion)
                tmp_pedido_reg.activo = 0
                If Not actualizar_pedido(tmp_pedido_reg, cadena_conexion) Then
                    Throw New Exception
                End If
            Else
                Throw New Exception
            End If

            If (camino.Equals(PantallaPedidos)) Then
                Response.Redirect("Pedidos.aspx")
            ElseIf (camino.Equals(PantallaEstadoMesas)) Then
                Response.Redirect("EstadoMesas.aspx")
            End If

        Catch ex As Exception
            Me.MsgEstadoLbl.Text = "Error al cancelar el pedido."
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub LiberarMesaButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles LiberarMesaButton.Click
        Dim tmp_mesa_reg As New mesa_reg

        Try

            If existe_mesa(mesa_clave, cadena_conexion) Then
                tmp_mesa_reg = get_mesa(mesa_clave, cadena_conexion)
                tmp_mesa_reg.libre = 1
                tmp_mesa_reg.comensales = 0
                If actualizar_mesa(tmp_mesa_reg, cadena_conexion) Then
                    InicializarDatos()
                    EstadoDatos(True)
                    MostrarDatos()
                    Me.LiberarMesaButton.Visible = False
                Else
                    Throw New Exception
                End If
            Else
                Throw New Exception
            End If

        Catch ex As Exception
            Me.MsgEstadoLbl.Text = "La mesa no se ha liberado."
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub
End Class
