﻿Imports variables_globales
Imports accesoBDeRestaurante.mesa_bd
Imports accesoBDeRestaurante.pedido_bd
Imports accesoBDeRestaurante.reserva_bd
Imports AjaxControlToolkit
Imports accesoBDeRestaurante.camarero_bd
Imports accesoBDeRestaurante.cliente_bd
Imports funciones_generales

Partial Class camarero_EstadoMesas
    Inherits System.Web.UI.Page

    Protected Shared num_mesa_seleccionada As Integer = -1
    Protected Shared index_mesa_seleccionada As Integer = -1
    Protected Shared dia_hora As Date

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            If Not IsPostBack Then
                InicializarDatos()
                EstadoDatos(False)
                ActualizarDatos()
            End If
        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoLbl.Text = "Error al mostrar los datos"
        End Try
    End Sub

    Protected Sub InicializarDatos()
        Me.CamareroTxt.Text = ""
        Me.MaxPersonasTxt.Text = ""
        Me.DiaTxt.Text = System.DateTime.Now.ToShortDateString
        Me.HorasDropDownList.SelectedValue = System.DateTime.Now.Hour.ToString
        Me.MinDropDownList.SelectedValue = System.DateTime.Now.Minute.ToString
        dia_hora = System.DateTime.Now
        num_mesa_seleccionada = -1
        Me.MsgEstadoLbl.Text = ""
    End Sub

    Protected Sub InicializarDatosMesa()
        Me.NumeroMesaTxt.Text = ""
        Me.CantidadMesasTxt.Text = ""
        Me.MaxComensalesTxt.Text = ""
        Me.MsgEstadoLbl.Text = ""
    End Sub

    Protected Sub InicializarDatosSinFecha()
        Me.CamareroTxt.Text = ""
        Me.MaxPersonasTxt.Text = ""
        num_mesa_seleccionada = -1
        Me.MsgEstadoLbl.Text = ""
        dia_hora = CDate(Me.DiaTxt.Text).AddHours(Me.HorasDropDownList.Text).AddMinutes(Me.MinDropDownList.Text)
    End Sub

    Protected Sub InicializarDatosSinFechaHora()
        Me.CamareroTxt.Text = ""
        Me.MaxPersonasTxt.Text = ""
        num_mesa_seleccionada = -1
        Me.MsgEstadoLbl.Text = ""
    End Sub

    Protected Sub EstadoDatos(ByVal est As Boolean)
        Me.DetallesMesaButton.Visible = est
        Me.ModificarMesaButton.Visible = est
        Me.EliminarMesaButton.Visible = est
        Me.AsignarMesaButton.Visible = est
    End Sub

    Protected Sub CambiarFecha(ByVal hora As Boolean)
        If hora Then
            InicializarDatosSinFecha()
        Else
            InicializarDatosSinFechaHora()
        End If

        ActualizarDatos()
        EstadoDatos(False)
    End Sub

    Protected Sub CargarDatosMesa()
        Dim tmp_mesa_reg As mesa_reg
        Dim tmp_mesa_clave As mesa_clave

        tmp_mesa_clave.id = num_mesa_seleccionada

        If existe_mesa(tmp_mesa_clave, cadena_conexion) Then
            tmp_mesa_reg = get_mesa(tmp_mesa_clave, cadena_conexion)
            Me.NumeroMesaTxt.Text = tmp_mesa_reg.numero
            Me.CantidadMesasTxt.Text = tmp_mesa_reg.num_mesas
            Me.MaxComensalesTxt.Text = tmp_mesa_reg.max_personas
        Else
            Throw New Exception()
        End If
    End Sub

    Protected Sub ActualizarDatos()
        Dim ret_ok As Boolean = True
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand

        Try
            comando = get_todas_mesas_str(cadena_conexion)

            MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
            MyDataSet.Clear()
            MyDataAdapter.Fill(MyDataSet)

            If MyDataSet.Tables(0).Rows.Count = 0 Then
                Me.MsgEstadoLbl.Text = "No hay mesas disponibles"
                Me.MsgEstadoLbl.CssClass = "gris-muy-oscuro"
                Me.MsgEstadoPanel.Visible = True
            Else
                Me.MesasRepeater.DataSource = MyDataSet.Tables(0)
                Me.MesasRepeater.DataBind()
            End If
        Catch ex As Exception
            Me.MsgEstadoLbl.Text = "Ha habido un problema al actualizar los datos. Vuelva a intentarlo o consulte con el administrador.<br />Disculpe las molestias."
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub GuardarDatosMesa()
        Dim num_mesa As Integer
        Dim cant_mesas As Integer
        Dim max_com As Integer
        Dim tmp_mesa_reg As New mesa_reg

        ' Recojo los datos
        num_mesa = CInt(Me.NumeroMesaTxt.Text)
        cant_mesas = CInt(Me.CantidadMesasTxt.Text)
        max_com = CInt(Me.MaxComensalesTxt.Text)

        ' Los asigno a la estructura mesa
        tmp_mesa_reg.numero = num_mesa
        tmp_mesa_reg.num_mesas = cant_mesas
        tmp_mesa_reg.max_personas = max_com
        tmp_mesa_reg.libre = 1

        If Not insertar_mesa(tmp_mesa_reg, cadena_conexion) Then
            Throw New Exception()
        End If
    End Sub

    Protected Sub PintarMesas()
        Dim mesa_clave As mesa_clave
        Dim tmp_cliente_clave As cliente_clave
        Dim tmp_cliente_reg As cliente_reg
        Dim tmp_reserva_reg As reserva_reg

        For Each mesa In Me.MesasRepeater.Items

            mesa_clave.id = CInt(CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).CommandArgument)

            ' Si la fecha no es la actual sólo comprobamos reservas, ya que no tiene sentido en la aplicación
            ' que una mesa esté ocupada ahora-mañana.
            If Not dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then
                If existe_reserva_mesa(mesa_clave, dia_hora, cadena_conexion) Then
                    CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).CssClass = "boton-mesa-reservada"
                    tmp_reserva_reg = get_reserva(mesa_clave, dia_hora, cadena_conexion)
                    tmp_cliente_clave.id = tmp_reserva_reg.FK_cliente
                    tmp_cliente_reg = get_cliente(tmp_cliente_clave, cadena_conexion)
                    If Not (es_error_cliente(tmp_cliente_reg)) Then
                        CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).ToolTip = "Cliente: " & obtener_nombre_apellido1_apellido2(tmp_cliente_reg.nombre, tmp_cliente_reg.apellido1, tmp_cliente_reg.apellido2)
                    End If
                Else
                    CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                End If
            Else
                ' Si la fecha es la actual comprobamos reservas y ocupación en el momento.
                If existe_reserva_mesa(mesa_clave, dia_hora, cadena_conexion) Then
                    CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).CssClass = "boton-mesa-reservada"
                    tmp_reserva_reg = get_reserva(mesa_clave, dia_hora, cadena_conexion)
                    tmp_cliente_clave.id = tmp_reserva_reg.FK_cliente
                    tmp_cliente_reg = get_cliente(tmp_cliente_clave, cadena_conexion)
                    If Not (es_error_cliente(tmp_cliente_reg)) Then
                        CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).ToolTip = "Cliente: " & obtener_nombre_apellido1_apellido2(tmp_cliente_reg.nombre, tmp_cliente_reg.apellido1, tmp_cliente_reg.apellido2)
                    End If
                Else
                    If esta_ocupada(mesa_clave, cadena_conexion) Then
                        CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).CssClass = "boton-mesa-ocupada"
                    Else
                        CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                    End If
                End If
            End If
        Next
    End Sub

    Protected Sub Calendar1_SelectionChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Calendar1.SelectionChanged
        Dim pce As PopupControlExtender
        Dim tmp_fecha As Date

        ' Recupero fecha y hora seleccionadas
        tmp_fecha = CDate(CType(sender, Calendar).SelectedDate.ToShortDateString)
        dia_hora = New Date(tmp_fecha.Year, tmp_fecha.Month, tmp_fecha.Day, Me.HorasDropDownList.SelectedValue, Me.HorasDropDownList.SelectedValue, 0)

        CambiarFecha(False)

        pce = AjaxControlToolkit.PopupControlExtender.GetProxyForCurrentPopup(Page)
        pce.Commit(CType(sender, Calendar).SelectedDate.ToShortDateString)

    End Sub

    Protected Sub OkButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles OkButton.Click

        Try
            GuardarDatosMesa()
            ActualizarDatos()
            InicializarDatos()
            InicializarDatosMesa()
            num_mesa_seleccionada = -1
            PintarMesas()
            EstadoDatos(False)
        Catch ex As Exception
            Me.MsgEstadoLbl.Text = "Ha habido un problema al guardar la mesa. Vuelva a intentarlo o p&oacute;ngase en contacto con el administrador.<br />Disculpe las molestias."
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub


    Protected Sub MesasRepeater_ItemCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.RepeaterCommandEventArgs) Handles MesasRepeater.ItemCommand
        Dim mesa_clave As mesa_clave
        Dim mesa_clave_ant As mesa_clave
        Dim tmp_reserva_reg As reserva_reg
        Dim tmp_cliente_clave As cliente_clave
        Dim tmp_cliente_reg As cliente_reg

        Try

            ' Borramos el posible mensaje de estado
            Me.MsgEstadoLbl.Text = ""

            ' Si la mesa que habia seleccionada es la que hemos pulsado...
            If num_mesa_seleccionada = e.CommandArgument Then

                ' Deseleccionamos la mesa 
                mesa_clave.id = num_mesa_seleccionada
                num_mesa_seleccionada = -1
                index_mesa_seleccionada = -1

                If existe_reserva_mesa(mesa_clave, dia_hora, cadena_conexion) Then
                    CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-reservada"
                    tmp_reserva_reg = get_reserva(mesa_clave, dia_hora, cadena_conexion)
                    tmp_cliente_clave.id = tmp_reserva_reg.FK_cliente
                    tmp_cliente_reg = get_cliente(tmp_cliente_clave, cadena_conexion)
                    If Not (es_error_cliente(tmp_cliente_reg)) Then
                        CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).ToolTip = "Cliente: " & obtener_nombre_apellido1_apellido2(tmp_cliente_reg.nombre, tmp_cliente_reg.apellido1, tmp_cliente_reg.apellido2)
                    End If
                ElseIf dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then
                    If esta_ocupada(mesa_clave, cadena_conexion) Then
                        CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-ocupada"
                    Else
                        CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                    End If
                Else
                    CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                End If

                Me.CamareroTxt.Text = ""
                Me.MaxPersonasTxt.Text = ""

                ' Deshabilito los botones de acción sobre una mesa concreta
                EstadoDatos(False)
            Else
                ' Si habia una mesa antes seleccionada la deseleccionamos
                If (num_mesa_seleccionada <> Nothing And num_mesa_seleccionada <> -1) Then
                    mesa_clave_ant.id = num_mesa_seleccionada
                    If existe_reserva_mesa(mesa_clave_ant, dia_hora, cadena_conexion) Then
                        CType(Me.MesasRepeater.Items.Item(index_mesa_seleccionada).FindControl("Button"), Button).CssClass = "boton-mesa-reservada"
                    ElseIf dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then
                        If esta_ocupada(mesa_clave_ant, cadena_conexion) Then
                            CType(Me.MesasRepeater.Items.Item(index_mesa_seleccionada).FindControl("Button"), Button).CssClass = "boton-mesa-ocupada"
                        Else
                            CType(Me.MesasRepeater.Items.Item(index_mesa_seleccionada).FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                        End If
                    Else
                        CType(Me.MesasRepeater.Items.Item(index_mesa_seleccionada).FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                    End If
                End If

                ' Seleccionamos la mesa pulsada
                num_mesa_seleccionada = e.CommandArgument
                index_mesa_seleccionada = e.Item.ItemIndex
                mesa_clave.id = num_mesa_seleccionada

                If existe_reserva_mesa(mesa_clave, dia_hora, cadena_conexion) Then
                    CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-reservada-sel"
                ElseIf dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then
                    If esta_ocupada(mesa_clave, cadena_conexion) Then
                        CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-ocupada-sel"
                    Else
                        CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-libre-sel"
                    End If
                Else
                    CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-libre-sel"
                End If

                Dim tmp_mesa_clave As mesa_clave
                Dim tmp_pedido_clave As pedido_clave
                Dim tmp_camarero_clave As camarero_clave
                Dim tmp_camarero_reg As camarero_reg

                tmp_mesa_clave.id = num_mesa_seleccionada

                ' Sólo mostramos datos del camarero para los pedidos actuales, no para las reservas.
                If dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then

                    tmp_pedido_clave.id = get_id_pedido_FKMesa(tmp_mesa_clave, cadena_conexion)

                    If existe_pedido(tmp_pedido_clave, cadena_conexion) Then
                        tmp_camarero_clave.id = get_pedido(tmp_pedido_clave, cadena_conexion).FK_camarero
                        If existe_camarero(tmp_camarero_clave, cadena_conexion) Then
                            tmp_camarero_reg = get_camarero(tmp_camarero_clave, cadena_conexion)
                            Me.CamareroTxt.Text = tmp_camarero_reg.nombre & " " & tmp_camarero_reg.apellido1 & " " & tmp_camarero_reg.apellido2
                        End If
                    Else
                        Me.CamareroTxt.Text = "No asignado"
                    End If

                    Me.MaxPersonasTxt.Text = get_mesa(tmp_mesa_clave, cadena_conexion).max_personas

                    ' Habilito los botones de acción sobre una mesa concreta
                    EstadoDatos(True)
                End If
            End If

        Catch ex As Exception
            ex.StackTrace.ToString()
        End Try
    End Sub

    Protected Sub ModificarMesaButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ModificarMesaButton.Click
        Dim mesa As mesa_clave

        Try
            mesa.id = num_mesa_seleccionada
            If existe_mesa(mesa, cadena_conexion) Then
                Response.Redirect("ModificarMesa.aspx?id=" & mesa.id & "&nav=" & Me.CaminoLbl.Text)
                num_mesa_seleccionada = -1
            End If
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub CancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        InicializarDatosMesa()
        PintarMesas()
        num_mesa_seleccionada = -1
        EstadoDatos(False)
    End Sub

    Protected Sub OkEliminarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles OkEliminarButton.Click
        Dim tmp_mesa_clave As mesa_clave

        Try
            tmp_mesa_clave.id = num_mesa_seleccionada

            If existe_mesa(tmp_mesa_clave, cadena_conexion) Then
                If eliminar_mesa(tmp_mesa_clave, cadena_conexion) Then
                    ActualizarDatos()
                    EstadoDatos(False)
                Else
                    Me.MsgEstadoLbl.Text = "La mesa seleccionada no puede ser eliminada: tiene un pedido/reserva activo."
                    Me.MsgEstadoPanel.Visible = True
                    Me.MsgEstadoLbl.CssClass = "rojo"
                End If
            End If
            EstadoDatos(False)
        Catch ex As Exception
            Me.MsgEstadoLbl.Text = "Ha habido un problema al eliminar la mesa. Vuelva a intentarlo o p&oacute;ngase en contacto con el administrador.<br />Disculpe las molestias."
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub DetallesMesaButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DetallesMesaButton.Click
        Dim id_pedido As Integer = -1
        Dim tmp_mesa_clave As mesa_clave

        Try
            tmp_mesa_clave.id = num_mesa_seleccionada

            If existe_mesa(tmp_mesa_clave, cadena_conexion) Then
                ' Recupero el pedido de la mesa si lo tiene asignado
                id_pedido = get_id_pedido_FKMesa(tmp_mesa_clave, cadena_conexion)
                Response.Redirect("DetallesPedido.aspx?id=" & id_pedido & "&nav=" & Trim(Me.CaminoLbl.Text) & "&mesa=" & tmp_mesa_clave.id)
            End If

        Catch ex As Exception

        End Try
    End Sub

    Protected Sub MesasRepeater_ItemDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.RepeaterItemEventArgs) Handles MesasRepeater.ItemDataBound
        Dim mesa_clave As mesa_clave
        Dim tmp_dia_hora As Date
        Dim tmp_reserva_reg As reserva_reg
        Dim tmp_cliente_clave As cliente_clave
        Dim tmp_cliente_reg As cliente_reg

        Try
            mesa_clave.id = CType(e.Item.FindControl("Button"), Button).CommandArgument

            ' Recuperamos el dia y la hora sin los minutos para comprobar si hay reservas
            tmp_dia_hora = New Date(dia_hora.Year, dia_hora.Month, dia_hora.Day, dia_hora.Hour, 0, 0)

            ' Si la fecha no es la actual sólo comprobamos reservas, ya que no tiene sentido en la aplicación
            ' que una mesa esté ocupada ahora mañana.
            If Not dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then

                If existe_reserva_mesa(mesa_clave, dia_hora, cadena_conexion) Then
                    CType(e.Item.FindControl("Button"), Button).CssClass = "boton-mesa-reservada"
                    tmp_reserva_reg = get_reserva(mesa_clave, dia_hora, cadena_conexion)
                    tmp_cliente_clave.id = tmp_reserva_reg.FK_cliente
                    tmp_cliente_reg = get_cliente(tmp_cliente_clave, cadena_conexion)
                    If Not (es_error_cliente(tmp_cliente_reg)) Then
                        CType(e.Item.FindControl("Button"), Button).ToolTip = "Cliente: " & obtener_nombre_apellido1_apellido2(tmp_cliente_reg.nombre, tmp_cliente_reg.apellido1, tmp_cliente_reg.apellido2)
                    End If
                Else
                    CType(e.Item.FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                End If

            Else
                ' Si la fecha es la actual comprobamos reservas y ocupación en el momento.
                If existe_reserva_mesa(mesa_clave, tmp_dia_hora, cadena_conexion) Then
                    CType(e.Item.FindControl("Button"), Button).CssClass = "boton-mesa-reservada"
                    tmp_reserva_reg = get_reserva(mesa_clave, dia_hora, cadena_conexion)
                    tmp_cliente_clave.id = tmp_reserva_reg.FK_cliente
                    tmp_cliente_reg = get_cliente(tmp_cliente_clave, cadena_conexion)
                    If Not (es_error_cliente(tmp_cliente_reg)) Then
                        CType(e.Item.FindControl("Button"), Button).ToolTip = "Cliente: " & obtener_nombre_apellido1_apellido2(tmp_cliente_reg.nombre, tmp_cliente_reg.apellido1, tmp_cliente_reg.apellido2)
                    End If
                ElseIf dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then
                    If esta_ocupada(mesa_clave, cadena_conexion) Then
                        CType(e.Item.FindControl("Button"), Button).CssClass = "boton-mesa-ocupada"
                    Else
                        CType(e.Item.FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                    End If
                Else
                    CType(e.Item.FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                End If
            End If

        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoLbl.Text = "Error al mostrar los datos"
        End Try

    End Sub

    Protected Sub AsignarMesaButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AsignarMesaButton.Click
        Dim tmp_mesa_clave As mesa_clave

        Try
            tmp_mesa_clave.id = num_mesa_seleccionada
            If existe_mesa(tmp_mesa_clave, cadena_conexion) Then
                Response.Redirect("AsignarMesaCliente.aspx?id=" & tmp_mesa_clave.id)
            End If
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub HorasDropDownList_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles HorasDropDownList.Init
        For i As Integer = 6 To 23
            Me.HorasDropDownList.Items.Add(New ListItem(i.ToString("00"), i))
        Next

        For i As Integer = 0 To 2
            Me.HorasDropDownList.Items.Add(New ListItem(i.ToString("00"), i))
        Next
    End Sub

    Protected Sub MinDropDownList_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles MinDropDownList.Init
        For i As Integer = 0 To 59 Step 1
            Me.MinDropDownList.Items.Add(New ListItem(i.ToString("00"), i))
        Next
    End Sub


    Protected Sub Calendar1_DayRender(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DayRenderEventArgs) Handles Calendar1.DayRender
        ' No permito seleccionar los dias pasados a hoy
        If e.Day.Date.CompareTo(Today) < 0 Then
            e.Cell.Font.Strikeout = True
            e.Day.IsSelectable = False
        End If
    End Sub

    Protected Sub HoraDropDownList_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles HorasDropDownList.SelectedIndexChanged
        Try
            CambiarFecha(True)
        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoLbl.Text = "Error al cambiar la hora"
        End Try
    End Sub

    Protected Sub MinDropDownList_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles MinDropDownList.SelectedIndexChanged
        Try
            CambiarFecha(True)
        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoLbl.Text = "Error al cambiar la hora"
        End Try
    End Sub
End Class
