﻿Imports variables_globales
Imports accesoBDeRestaurante.usuario_bd
Imports accesoBDeRestaurante.cliente_bd
Imports accesoBDeRestaurante.pedido_bd
Imports AjaxControlToolkit

Partial Class camarero_HistorialPedidos
    Inherits System.Web.UI.Page

    Protected Const Ret_Vacio As Integer = -1
    Protected Const Ret_Error As Integer = 0
    Protected Const Ret_Correcto As Integer = 1
    Protected Const Ret_NoPedido As Integer = -2
    Protected Shared fecha_ini As String
    Protected Shared fecha_fin As String

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Try
            If Not IsPostBack Then
                ' Recupero los filtros: fecha inicio y fecha fin, (si volvemos de detalles de pedido)
                fecha_ini = Trim(Request.QueryString("fini"))
                fecha_fin = Trim(Request.QueryString("ffin"))

                InicializarMensajes()
                If (fecha_ini.Equals("") Or fecha_fin.Equals("")) Then
                    InicializarDatos()
                Else
                    Me.FechaIniTxt.Text = fecha_ini
                    Me.FechaFinTxt.Text = fecha_fin
                End If
                EstadoDatos(False)
                ActualizarDatos()
            End If
        Catch ex As Exception
            Me.MsgErrorLbl.Text = "Ha habido un problema al mostral el historial de pedidos, vuelva a intentarlo o consulte con el administrador. <br /> Disculpe las molestias"
            Me.MsgErrorPanel.Visible = True
        End Try
    End Sub

    Protected Sub InicializarMensajes()
        Me.MsgEstadoLbl.Visible = False
        Me.MsgErrorPanel.Visible = False
    End Sub

    Protected Sub InicializarDatos()
        Me.FechaIniTxt.Text = Date.Today
        Me.FechaFinTxt.Text = Date.Today
    End Sub

    Protected Sub EstadoDatos(ByVal est As Boolean)
        Me.DetallesPedidoButton.Visible = est
    End Sub

    Protected Sub ActualizarDatos()
        Dim ret_ok As Boolean = True

        Select Case ActualizarGridViewPedido()
            Case Ret_Vacio
                MsgEstadoLbl.Visible = True
                MsgEstadoLbl.Text = "No hay pedidos en el hist&oacute;rico en el intervalo de fechas seleccionado"
                MsgEstadoLbl.CssClass = "gris-oscuro"
                EstadoDatos(False)
            Case Ret_Error
                ret_ok = False
            Case Ret_Correcto
                EstadoDatos(True)
        End Select

        If ret_ok = Ret_Error Then
            Throw New Exception()
        End If
    End Sub

    Protected Function ActualizarGridViewPedido() As Integer
        Dim ret_ok As Integer

        ret_ok = LlenarGridViewPedido()
        Me.PedidoGridView.DataBind()

        Return ret_ok
    End Function

    Protected Function LlenarGridViewPedido() As Integer
        Dim ret_ok As Integer = Ret_Correcto
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand
        Dim fecha_inicio As Date
        Dim fecha_fin As Date

        Try
            ' Recupero las fechas de inicio y fin
            Try
                fecha_inicio = Date.Parse(Me.FechaIniTxt.Text)
            Catch ex As Exception
                fecha_inicio = Date.Today
            End Try
            Try
                fecha_fin = Date.Parse(Me.FechaFinTxt.Text)
            Catch ex As Exception
                fecha_fin = Date.Today
            End Try

            ' Sumo un dia a la fecha para que llegue hasta el final del dia seleccionado
            fecha_fin = fecha_fin.AddDays(1)

            ' Recupero el historial de pedidos en el intervalo de fechas seleccionado
            comando = get_historial_pedidos_fechas_str(fecha_inicio, fecha_fin, cadena_conexion)
            MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
            MyDataSet.Clear()
            MyDataAdapter.Fill(MyDataSet)

            If MyDataSet.Tables(0).Rows.Count = 0 Then
                ret_ok = Ret_Vacio
            Else
                Me.PedidoGridView.DataSource = MyDataSet.Tables(0)
            End If

        Catch ex As Exception
            ret_ok = Ret_Error
        End Try

        Return ret_ok
    End Function

    Protected Function ObtenerPrimeraFilaSeleccionada() As Integer
        Dim result As Integer

        For Each row As GridViewRow In Me.PedidoGridView.Rows
            Dim ch As CheckBox = CType(row.FindControl("SelectCheck"), CheckBox)
            If ch.Checked Then
                result = CInt(row.Cells(1).Text)
                Return result
            End If
        Next

        Return -1
    End Function

    Protected Sub PedidoGridView_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles PedidoGridView.PageIndexChanging
        Me.PedidoGridView.PageIndex = e.NewPageIndex()

        If ActualizarGridViewPedido() Then
            Me.MsgEstadoLbl.Visible = False
        Else
            Me.MsgEstadoLbl.Visible = True
        End If

    End Sub

    Protected Sub DetallesPedidoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DetallesPedidoButton.Click
        Dim id_get As Integer = -1

        Try
            ' Recupero el pedido seleccionado
            id_get = ObtenerPrimeraFilaSeleccionada()
            If (id_get <> -1) Then
                Response.Redirect("DetallesPedidoHistorico.aspx?id=" & id_get & "&nav=" & Trim(Me.CaminoLbl.Text) & "&fini=" & Trim(Me.FechaIniTxt.Text) & "&ffin=" & Trim(Me.FechaFinTxt.Text))
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Me.MsgErrorPanel.Visible = True
            Me.MsgErrorLbl.Text = "Debe seleccionar un empleado para mostrar los detalles."
        End Try
    End Sub

    Protected Sub Calendar1_SelectionChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles FechaIniCalendar.SelectionChanged, FechaFinCalendar.SelectionChanged
        Dim pce As PopupControlExtender

        pce = AjaxControlToolkit.PopupControlExtender.GetProxyForCurrentPopup(Page)
        pce.Commit(CType(sender, Calendar).SelectedDate.ToShortDateString)
    End Sub

    Protected Sub BuscarImageButton_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles BuscarImageButton.Click
        InicializarMensajes()
        ActualizarDatos()
    End Sub
End Class
