﻿Imports variables_globales
Imports accesoBDeRestaurante.mesa_bd

Partial Class camarero_ModificarMesa
    Inherits System.Web.UI.Page

    Protected Shared camino As String = ""
    Protected Shared mesa_clave As mesa_clave

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Try
            If Not IsPostBack Then

                ' Recupero el camino navegacional y lo establezco
                camino = Trim(Request.QueryString("nav"))
                Me.CaminoLbl.Text = camino

                ' Recupero la mesa a modificar
                mesa_clave.id = CInt(Request.QueryString("id"))

                If existe_mesa(mesa_clave, cadena_conexion) Then
                    InicializarDatos()
                    EstadoDatos()
                    MostrarDatos()
                Else
                    Throw New Exception()
                End If
            End If
        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.Text = "Ha habido un problema al mostrar datos de la mesa, vuelva a intentarlo o consulte con el administrador.<br />Disculpe las molestias."
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub InicializarDatos()
        Me.MsgEstadoPanel.Visible = False
        'Mesa
        Me.IdMesaTxt.Text = "-"
        Me.NumeroMesaTxt.Text = "-"
        Me.MaxComensalesTxt.Text = "0"
        Me.NoMesasTxt.Text = "0"
    End Sub

    Protected Sub EstadoDatos()
        Me.IdMesaTxt.Enabled = False
        Me.GuardarButton.Visible = True
        Me.CancelarButton.Visible = True
    End Sub

    Protected Sub MostrarDatos()
        Dim tmp_mesa_reg As mesa_reg

        ' Obtengo la mesa a mostrar
        tmp_mesa_reg = get_mesa(mesa_clave, cadena_conexion)

        If Not es_error_mesa(tmp_mesa_reg) Then
            ' Muestro los datos de la mesa 
            Me.IdMesaTxt.Text = tmp_mesa_reg.id
            Me.NumeroMesaTxt.Text = tmp_mesa_reg.numero
            Me.MaxComensalesTxt.Text = tmp_mesa_reg.max_personas
            Me.NoMesasTxt.Text = tmp_mesa_reg.num_mesas
        Else
            Throw New Exception()
        End If
    End Sub

    Protected Sub GuardarDatos()
        Dim tmp_mesa_reg As mesa_reg

        tmp_mesa_reg = get_mesa(mesa_clave, cadena_conexion)

        If Not es_error_mesa(tmp_mesa_reg) Then
            tmp_mesa_reg.numero = CInt(Me.NumeroMesaTxt.Text)
            tmp_mesa_reg.max_personas = CInt(Me.MaxComensalesTxt.Text)
            tmp_mesa_reg.num_mesas = CInt(Me.NoMesasTxt.Text)

            If Not actualizar_mesa(tmp_mesa_reg, cadena_conexion) Then
                Throw New Exception()
            End If
        Else
            Throw New Exception()
        End If
    End Sub

    Protected Sub GuardarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GuardarButton.Click
        Try
            GuardarDatos()
            Response.Redirect("EstadoMesas.aspx")
        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.Text = "Ha habido un problema al guardar los datos de la mesa. Vuelva a intentarlo o consule con el administador.<br>Disculpe las molestias."
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub CancelarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelarButton.Click
        Try
            Response.Redirect("EstadoMesas.aspx")
        Catch ex As Exception

        End Try
    End Sub
End Class
