﻿Imports variables_globales
Imports accesoBDeRestaurante.pedido_bd

Partial Class camarero_Pedidos
    Inherits System.Web.UI.Page

    Protected Const Ret_Vacio As Integer = -1
    Protected Const Ret_Error As Integer = 0
    Protected Const Ret_Correcto As Integer = 1
    Protected Const Ret_NoPedido As Integer = -2

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            If Not IsPostBack Then
                InicializarDatos()
                EstadoDatos(False)
                ActualizarDatos()
            End If
        Catch ex As Exception
            Me.MsgErrorLbl.Text = "Ha habido un problema al mostrar los pedidos, vuelva a intentarlo o consulte con el administrador.<br>Disculpe las molestias."
            Me.MsgErrorPanel.Visible = True
        End Try
    End Sub

    Protected Sub InicializarDatos()
        Me.MsgEstadoLbl.Visible = False
        Me.MsgErrorPanel.Visible = False
    End Sub

    Protected Sub EstadoDatos(ByVal est As Boolean)
        Me.DetallesPedidoButton.Visible = est
    End Sub

    Protected Sub ActualizarDatos()
        Dim ret_ok As Boolean = True

        Select Case ActualizarGridViewPedido()
            Case Ret_Vacio
                MsgEstadoLbl.Visible = True
                MsgEstadoLbl.Text = "No hay pedidos activos"
                MsgEstadoLbl.CssClass = "gris-oscuro"
                EstadoDatos(False)
            Case Ret_Error
                ret_ok = False
            Case Ret_Correcto
                EstadoDatos(True)
        End Select

        If ret_ok = Ret_Error Then
            Throw New Exception()
        End If
    End Sub

    Protected Function ActualizarGridViewPedido() As Integer
        Dim ret_ok As Integer

        ret_ok = LlenarGridViewPedido()
        Me.PedidosGridView.DataBind()

        Return ret_ok
    End Function

    Protected Function LlenarGridViewPedido() As Integer
        Dim ret_ok As Integer = Ret_Correcto
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand

        Try
            ' Recupero los pedidos activos del restaurante
            comando = get_pedidos_activos_str(cadena_conexion)
            MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
            MyDataSet.Clear()
            MyDataAdapter.Fill(MyDataSet)

            If MyDataSet.Tables(0).Rows.Count = 0 Then
                ret_ok = Ret_Vacio
            Else
                Me.PedidosGridView.DataSource = MyDataSet.Tables(0)
            End If

        Catch ex As Exception
            ret_ok = Ret_Error
        End Try

        Return ret_ok
    End Function

    Protected Function ObtenerPrimeraFilaSeleccionada() As Integer
        Dim result As Integer

        For Each row As GridViewRow In Me.PedidosGridView.Rows
            Dim ch As CheckBox = CType(row.FindControl("SelectCheck"), CheckBox)
            If ch.Checked Then
                result = CInt(row.Cells(1).Text)
                Return result
            End If
        Next

        Return -1
    End Function

    Protected Sub PedidosGridView_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles PedidosGridView.PageIndexChanging
        Me.PedidosGridView.PageIndex = e.NewPageIndex()

        If ActualizarGridViewPedido() Then
            Me.MsgEstadoLbl.Visible = False
        Else
            Me.MsgEstadoLbl.Visible = True
        End If

        Try
            If Me.PedidosGridView.SelectedIndex <> -1 Then
                If Me.PedidosGridView.SelectedIndex Mod 2 = 0 Then
                    Me.PedidosGridView.Rows(Me.PedidosGridView.SelectedIndex).RowState = DataControlRowState.Normal
                Else
                    Me.PedidosGridView.Rows(Me.PedidosGridView.SelectedIndex).RowState = DataControlRowState.Alternate
                End If
            End If
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub PedidosGridView_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles PedidosGridView.RowDataBound
        Dim pagado As Label
        Dim servido As Label
        Dim confirmado As Label

        Try
            If e.Row.RowType = DataControlRowType.DataRow Then
                pagado = CType(e.Row.FindControl("PagadoLbl"), Label)
                servido = CType(e.Row.FindControl("ServidoLbl"), Label)
                confirmado = CType(e.Row.FindControl("ConfirmadoLbl"), Label)

                If pagado.Text.Trim.Equals("1") Then
                    pagado.Text = "S&iacute;"
                ElseIf pagado.Text.Trim.Equals("2") Then
                    pagado.Text = "Cuenta"
                Else
                    pagado.Text = "No"
                End If

                If servido.Text.Equals("1") Then
                    servido.Text = "S&iacute;"
                Else
                    servido.Text = "No"
                End If

                If confirmado.Text.Equals("1") Then
                    confirmado.Text = "S&iacute;"
                Else
                    confirmado.Text = "No"
                End If
            End If
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub DetallesPedidoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DetallesPedidoButton.Click
        Dim tmp_pedido_clave As pedido_clave
        Dim mesa As Integer = -1

        Try
            tmp_pedido_clave.id = ObtenerPrimeraFilaSeleccionada()
            If (tmp_pedido_clave.id <> -1) Then
                mesa = get_pedido(tmp_pedido_clave, cadena_conexion).FK_mesa
                Response.Redirect("DetallesPedido.aspx?id=" & tmp_pedido_clave.id & "&mesa=" & mesa & "&nav=" & Trim(Me.CaminoLbl.Text))
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Me.MsgErrorPanel.Visible = True
            Me.MsgErrorLbl.Text = "Debe seleccionar un pedido para mostrar los detalles."
        End Try
    End Sub

    Protected Sub Timer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer.Tick
        InicializarDatos()
        ActualizarDatos()
    End Sub
End Class
