﻿Imports variables_globales
Imports accesoBDeRestaurante.pedido_bd
Imports accesoBDeRestaurante.cliente_bd
Imports accesoBDeRestaurante.usuario_bd
Imports accesoBDeRestaurante.mesa_bd
Imports accesoBDeRestaurante.camarero_bd
Imports accesoBDeRestaurante.consumicion_bd

Partial Class cliente_DetallesPedido
    Inherits System.Web.UI.Page

    Protected Const Ret_Vacio As Integer = -1
    Protected Const Ret_Error As Integer = 0
    Protected Const Ret_Correcto As Integer = 1
    Protected Const Ret_NoPedido As Integer = -2
    Protected Shared pedido_actual_reg As pedido_reg

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim tmp_pedido_clave As pedido_clave
        Dim camino As String = ""
        Try
            If Not IsPostBack Then
                ' Recupero el pedido actual
                tmp_pedido_clave.id = CInt(Request.QueryString("id"))
                ' Recupero el camino navegacional y lo establezco
                camino = Trim(Request.QueryString("nav"))
                Me.CaminoLbl.Text = camino & ">Detalles de pedido"

                If existe_pedido(tmp_pedido_clave, cadena_conexion) Then
                    pedido_actual_reg = get_pedido(tmp_pedido_clave, cadena_conexion)
                    InicializarDatos()
                    MostrarDatos()
                Else
                    Throw New Exception()
                End If
            End If
        Catch ex As Exception
            Me.MsgEstadoLbl.Visible = True
            Me.MsgEstadoLbl.Text = "Ha habido un problema al mostrar los detalles de pedido, vuelva a intentarlo o consulte con un empleado. Disculpe las molestias."
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub InicializarDatos()
        Me.IdTxt.Text = ""
        Me.FechaTxt.Text = "01/01/1990"
        Me.PrecioTxt.Text = "0 €"
        Me.MesaTxt.Text = ""
        Me.CamareroTxt.Text = ""
        Me.FotoCamareroImage.ImageUrl = sin_foto
    End Sub

    Protected Sub MostrarDatos()
        Dim tmp_mesa_clave As mesa_clave
        Dim tmp_mesa_reg As mesa_reg
        Dim tmp_camarero_clave As camarero_clave
        Dim tmp_camarero_reg As camarero_reg

        ' Muestro los datos
        Me.IdTxt.Text = pedido_actual_reg.id
        Me.FechaTxt.Text = pedido_actual_reg.fecha
        Me.PrecioTxt.Text = pedido_actual_reg.precio & " €"
        tmp_mesa_clave.id = pedido_actual_reg.FK_mesa
        tmp_mesa_reg = get_mesa(tmp_mesa_clave, cadena_conexion)
        Me.MesaTxt.Text = tmp_mesa_reg.numero
        tmp_camarero_clave.id = pedido_actual_reg.FK_camarero
        tmp_camarero_reg = get_camarero(tmp_camarero_clave, cadena_conexion)
        Me.CamareroTxt.Text = Trim(tmp_camarero_reg.nombre) & " " & Trim(tmp_camarero_reg.apellido1) & " " & Trim(tmp_camarero_reg.apellido2)
        Me.FotoCamareroImage.ImageUrl = sin_foto
        If (Not tmp_camarero_reg.foto = Nothing) AndAlso (Not Trim(tmp_camarero_reg.foto).Equals("")) Then
            Me.FotoCamareroImage.ImageUrl = Trim(tmp_camarero_reg.foto)
        End If
        Me.FotoCamareroImage.ToolTip = Trim(tmp_camarero_reg.nombre) & " " & Trim(tmp_camarero_reg.apellido1) & " " & Trim(tmp_camarero_reg.apellido2)
        ActualizarDatos()
    End Sub

    Protected Sub ActualizarDatos()
        Dim ret_ok As Boolean = True

        Select Case ActualizarGridViewPedido()
            Case Ret_Vacio
                MsgEstadoLbl.Visible = True
                MsgEstadoLbl.Text = "No hay consumiciones añadidas al pedido"
                MsgEstadoLbl.CssClass = "gris-oscuro"
            Case Ret_Error
                ret_ok = False
        End Select

        If ret_ok = Ret_Error Then
            Throw New Exception()
        End If
    End Sub

    Protected Function ActualizarGridViewPedido() As Integer
        Dim ret_ok As Integer

        ret_ok = LlenarGridViewPedido()
        Me.PedidoGridView.DataBind()

        Return ret_ok
    End Function

    Protected Function LlenarGridViewPedido() As Integer
        Dim ret_ok As Integer = Ret_Correcto
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand
        Dim tmp_pedido_clave As pedido_clave

        Try
            ' Muestro las consumiciones del pedido si el pedido existe
            If pedido_actual_reg.id <> -1 Then

                ' Recupero las consumiciones del pedido
                tmp_pedido_clave.id = pedido_actual_reg.id
                comando = get_consumiciones_pedido_str(tmp_pedido_clave, cadena_conexion)

                MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
                MyDataSet.Clear()
                MyDataAdapter.Fill(MyDataSet)
                If MyDataSet.Tables(0).Rows.Count = 0 Then
                    ret_ok = Ret_Vacio
                Else
                    Me.PedidoGridView.DataSource = MyDataSet.Tables(0)
                End If
            Else
                ret_ok = Ret_NoPedido
            End If
        Catch ex As Exception
            ret_ok = Ret_Error
        End Try

        Return ret_ok
    End Function

    Protected Sub PedidoGridView_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles PedidoGridView.PageIndexChanging
        Me.PedidoGridView.PageIndex = e.NewPageIndex()

        ActualizarDatos()

        Try
            If Me.PedidoGridView.SelectedIndex <> -1 Then
                If Me.PedidoGridView.SelectedIndex Mod 2 = 0 Then
                    Me.PedidoGridView.Rows(Me.PedidoGridView.SelectedIndex).RowState = DataControlRowState.Normal
                Else
                    Me.PedidoGridView.Rows(Me.PedidoGridView.SelectedIndex).RowState = DataControlRowState.Alternate
                End If
            End If

        Catch ex As Exception

        End Try
    End Sub
End Class
