﻿Imports accesoBDeRestaurante.usuario_bd
Imports accesoBDeRestaurante.cliente_bd
Imports accesoBDeRestaurante.pedido_bd
Imports accesoBDeRestaurante.tipoproducto_bd
Imports accesoBDeRestaurante.itemconsumicion_bd
Imports variables_globales
Imports accesoBDeRestaurante.consumicion_bd

Partial Class cliente_AddProductosPedido
    Inherits System.Web.UI.Page

    Protected Shared usuario_actual_clave As New usuario_clave
    Protected Shared cliente_actual_clave As New cliente_clave
    Protected Shared pedido_actual_clave As New pedido_clave
    Protected Shared selected_id_tipo_producto As Integer = 1
    Protected Const Ret_Vacio As Integer = -1
    Protected Const Ret_Error As Integer = 0
    Protected Const Ret_Correcto As Integer = 1

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ret_ok As Boolean = True

        Try
            ' Carga de los datos sólo una vez, cuando la página carga
            If Not IsPostBack Then

                ' Recupero el usuario actual
                usuario_actual_clave.id = Session.Item("IdUsuario")
                ' Recupero el cliente actual
                cliente_actual_clave.id = get_cliente_FKUsuario(usuario_actual_clave, cadena_conexion).id
                ' Recupero el pedido actual
                pedido_actual_clave.id = get_pedido_actual(cliente_actual_clave, cadena_conexion).id

                InicializarDatos()
                ActualizarDatosProductos()

            End If
        Catch ex As Exception
            Me.MsgErrorLbl.Text = "Ha habido un problema al mostrar los productos disponibles"
            Me.MsgErrorLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub InicializarDatos()
        Me.MsgEstado2Lbl.Visible = False
        Me.ProductosGridView.AutoGenerateColumns = False
        Me.MsgErrorPanel.Visible = False
    End Sub

    Protected Sub ActualizarDatosProductos()
        Dim ret_ok As Boolean = True

        Select Case ActualizarGridViewProductos()
            Case Ret_Vacio
                MsgEstado2Lbl.Visible = True
                MsgEstado2Lbl.Text = "No hay productos en la categor&iacute;a seleccionada"
                MsgEstado2Lbl.CssClass = "gris-oscuro"
            Case Ret_Error
                ret_ok = False
        End Select

        If ret_ok = Ret_Error Then
            Throw New Exception()
        End If
    End Sub

    Protected Function ActualizarGridViewProductos() As Integer
        Dim ret_ok As Integer

        ret_ok = LlenarGridViewProductos()
        Me.ProductosGridView.DataBind()

        Return ret_ok
    End Function

    Protected Sub ActualizarDatosMenus()
        Dim ret_ok As Boolean = True

        Select Case ActualizarGridViewMenus()
            Case Ret_Vacio
                MsgEstado2Lbl.Visible = True
                MsgEstado2Lbl.Text = "No hay men&uacute;s en la categor&iacute;a seleccionada"
                MsgEstado2Lbl.CssClass = "gris-oscuro"
            Case Ret_Error
                ret_ok = False
        End Select

        If ret_ok = Ret_Error Then
            Throw New Exception()
        End If
    End Sub

    Protected Function ActualizarGridViewMenus() As Integer
        Dim ret_ok As Integer

        ret_ok = LlenarGridViewMenus()
        Me.ProductosGridView.DataBind()

        Return ret_ok
    End Function

    Protected Function LlenarGridViewProductos() As Integer
        Dim ret_ok As Integer = Ret_Correcto
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand
        Dim tmp_tipoproducto_clave As tipoproducto_clave

        Try
            ' Obtengo el tipo de producto seleccionado
            tmp_tipoproducto_clave.id = selected_id_tipo_producto

            ' Recupero los productos que son de ese tipo y los cargo en la rejilla
            comando = get_itemconsumiciones_tipo_strsql(tmp_tipoproducto_clave, cadena_conexion)

            MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
            MyDataSet.Clear()
            MyDataAdapter.Fill(MyDataSet)
            If MyDataSet.Tables(0).Rows.Count = 0 Then
                ret_ok = Ret_Vacio
            Else
                Me.ProductosGridView.DataSource = MyDataSet.Tables(0)
            End If
        Catch ex As Exception
            ret_ok = Ret_Error
        End Try

        Return ret_ok
    End Function

    Protected Function LlenarGridViewMenus() As Integer
        Dim ret_ok As Integer = Ret_Correcto
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand

        Try
            ' Recupero los menus y los cargo en la rejilla
            comando = get_itemconsumiciones_menu_strsql(cadena_conexion)

            MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
            MyDataSet.Clear()
            MyDataAdapter.Fill(MyDataSet)
            If MyDataSet.Tables(0).Rows.Count = 0 Then
                ret_ok = Ret_Vacio
            Else
                Me.ProductosGridView.DataSource = MyDataSet.Tables(0)
            End If
        Catch ex As Exception
            ret_ok = Ret_Error
        End Try

        Return ret_ok
    End Function

    Protected Function MostrarTiposProducto() As Boolean
        Dim ret_ok As Boolean = True
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand

        Try
            comando = get_todos_tipoproducto_str(cadena_conexion)

            MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
            MyDataSet.Clear()
            MyDataAdapter.Fill(MyDataSet)

            If MyDataSet.Tables(0).Rows.Count = 0 Then
                ret_ok = Ret_Vacio
            Else
                Me.TiposProductoRepeater.DataSource = MyDataSet.Tables(0)
                Me.TiposProductoRepeater.DataBind()
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Private Sub BotonPulsado(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.CommandEventArgs) Handles TiposProductoRepeater.ItemCommand
        If Not e.CommandArgument Is Nothing AndAlso Not e.CommandArgument.Equals("") Then
            selected_id_tipo_producto = e.CommandArgument
            InicializarDatos()
            ActualizarDatosProductos()
            If Me.ProductosGridView.SelectedIndex <> -1 Then
                If (Me.ProductosGridView.SelectedIndex Mod 2) = 0 Then
                    Me.ProductosGridView.Rows(Me.ProductosGridView.SelectedIndex).RowState = DataControlRowState.Normal
                Else
                    Me.ProductosGridView.Rows(Me.ProductosGridView.SelectedIndex).RowState = DataControlRowState.Alternate
                End If
            End If
        End If
    End Sub

    Protected Sub TiposProductoPanel_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles TiposProductoPanel.Init
        Dim ret_ok As Boolean = True

        Try
            If Not MostrarTiposProducto() Then
                Throw New Exception
            End If
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub ProductosGridView_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles ProductosGridView.PageIndexChanging
        Me.ProductosGridView.PageIndex = e.NewPageIndex()
        InicializarDatos()
        ActualizarDatosProductos()
        Try
            If (Me.ProductosGridView.SelectedIndex Mod 2 = 0) Then
                Me.ProductosGridView.Rows(Me.ProductosGridView.SelectedIndex).RowState = DataControlRowState.Normal
            Else
                Me.ProductosGridView.Rows(Me.ProductosGridView.SelectedIndex).RowState = DataControlRowState.Alternate
            End If
        Catch ex As Exception

        End Try

    End Sub

    Protected Sub AddAlPedidoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddAlPedidoButton.Click
        Dim tmp_consumicion_reg As consumicion_reg
        Dim tmp_consumicion_reg_aux As consumicion_reg
        Dim tmp_itemconsumicion_reg As itemconsumicion_reg
        Dim tmp_itemconsumicion_clave As itemconsumicion_clave
        Dim tmp_pedido_actual_reg As pedido_reg
        Dim ret_ok As Boolean = True
        Dim precio_total As Decimal = 0.0

        Try
            ' Añado al pedido cada producto seleccionado
            For Each row As GridViewRow In Me.ProductosGridView.Rows
                Dim ch As CheckBox = CType(row.FindControl("SelectCheck"), CheckBox)
                If ch.Checked Then
                    tmp_itemconsumicion_clave.id = CInt(row.Cells(1).Text)
                    tmp_itemconsumicion_reg = get_itemconsumicion(tmp_itemconsumicion_clave, cadena_conexion)

                    ' Guardo los datos de la consumicion
                    With tmp_consumicion_reg
                        .FK_pedido = pedido_actual_clave.id
                        .FK_itemconsumicion = tmp_itemconsumicion_clave.id

                        ' Si la consumicion ya existia añado una unidad de consumicion más, sino, será la primera
                        If existe_consumicion_FKPedido_FKItemConsumicion(tmp_consumicion_reg, cadena_conexion) Then
                            tmp_consumicion_reg_aux = get_consumicion_FKPedido_FKItemConsumicion(tmp_consumicion_reg, cadena_conexion)
                            .id = tmp_consumicion_reg_aux.id
                            .cantidad = tmp_consumicion_reg_aux.cantidad + 1
                            .precio = (tmp_itemconsumicion_reg.precio * CDec(.cantidad))
                            .servida = tmp_consumicion_reg_aux.servida
                            ret_ok = actualizar_consumicion(tmp_consumicion_reg, cadena_conexion)
                        Else
                            .id = 0
                            .cantidad = 1
                            .precio = tmp_itemconsumicion_reg.precio
                            .servida = 0
                            ret_ok = insertar_consumicion(tmp_consumicion_reg, cadena_conexion)
                        End If

                        precio_total += tmp_itemconsumicion_reg.precio
                    End With
                End If
            Next

            If ret_ok Then
                tmp_pedido_actual_reg = get_pedido_actual(cliente_actual_clave, cadena_conexion)
                tmp_pedido_actual_reg.servido = 0
                tmp_pedido_actual_reg.pagado = 0
                tmp_pedido_actual_reg.precio += precio_total
                If Not actualizar_pedido(tmp_pedido_actual_reg, cadena_conexion) Then
                    Throw New Exception()
                End If
            Else
                Throw New Exception()
            End If

        Catch ex As Exception
            MsgErrorPanel.Visible = True
            MsgErrorLbl.Text = "Ha habido un problema al añadir el producto a su pedido"
            MsgErrorLbl.CssClass = "rojo"
        End Try

        Response.Redirect("MiPedido.aspx")
    End Sub

    Protected Sub VolverButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles VolverButton.Click
        Response.Redirect("MiPedido.aspx")
    End Sub

    Protected Sub MenusButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MenusButton.Click
        InicializarDatos()
        ActualizarDatosMenus()
        If Me.ProductosGridView.SelectedIndex <> -1 Then
            If (Me.ProductosGridView.SelectedIndex Mod 2) = 0 Then
                Me.ProductosGridView.Rows(Me.ProductosGridView.SelectedIndex).RowState = DataControlRowState.Normal
            Else
                Me.ProductosGridView.Rows(Me.ProductosGridView.SelectedIndex).RowState = DataControlRowState.Alternate
            End If
        End If
    End Sub
End Class
