﻿Imports accesoBDeRestaurante.consumicion_bd
Imports accesoBDeRestaurante.pedido_bd
Imports accesoBDeRestaurante.cliente_bd
Imports accesoBDeRestaurante.usuario_bd
Imports accesoBDeRestaurante.tipoproducto_bd
Imports accesoBDeRestaurante.itemconsumicion_bd
Imports variables_globales

Partial Class cliente_MiPedido
    Inherits System.Web.UI.Page

    Protected Shared usuario_actual_clave As New usuario_clave
    Protected Shared cliente_actual_clave As New cliente_clave
    Protected Shared pedido_actual_clave As New pedido_clave
    Protected Const Ret_Vacio As Integer = -1
    Protected Const Ret_Error As Integer = 0
    Protected Const Ret_Correcto As Integer = 1
    Protected Const Ret_NoPedido As Integer = -2


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ret_ok As Boolean = True

        Try

            ' Carga de los datos sólo una vez, cuando la página carga
            If Not IsPostBack Then

                ' Recupero el usuario actual
                usuario_actual_clave.id = Session.Item("IdUsuario")
                ' Recupero el cliente actual
                cliente_actual_clave.id = get_cliente_FKUsuario(usuario_actual_clave, cadena_conexion).id
                ' Recupero el pedido actual
                pedido_actual_clave.id = get_pedido_actual(cliente_actual_clave, cadena_conexion).id

                InicializarDatos()

                If pedido_actual_clave.id <> -1 AndAlso existe_pedido(pedido_actual_clave, cadena_conexion) Then
                    ActualizarDatos()
                End If

            End If
        Catch ex As Exception
            Me.MsgErrorPanel.Visible = True
            Me.MsgErrorLbl.Text = "Ha habido un problema al mostrar el pedido"
            Me.MsgErrorLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub InicializarDatos()
        If pedido_actual_clave.id = -1 OrElse Not existe_pedido(pedido_actual_clave, cadena_conexion) OrElse get_pedido(pedido_actual_clave, cadena_conexion).activo = 0 Then
            Me.NoHayPedidoPanel.Visible = True
            Me.MiPedidoPanel.Visible = False
            Me.DatosPagoPanel.Visible = False
            Me.TodosPanel.Visible = False
            Me.AddAlPedidoButton.Visible = False
            Me.ConfirmarPedidoButton.Visible = False
            Me.DetallesPedidoButton.Visible = False
            Me.PagarButton.Visible = False
        Else
            Me.NoHayPedidoPanel.Visible = False
            Me.MiPedidoPanel.Visible = True
            Me.TodosPanel.Visible = True
            Me.DatosPagoPanel.Visible = True
            Me.AddAlPedidoButton.Visible = True
            Me.ConfirmarPedidoButton.Visible = False
            Me.DetallesPedidoButton.Visible = True
            Me.PagarButton.Visible = False
        End If
        
        InicializarDatosPedido()
        InicializarDatosCuentaPedido()
    End Sub

    Protected Sub InicializarDatosPedido()
        Me.MsgEstadoPanel.Visible = False
        Me.MsgEstadoLbl.Text = "No hay consumiciones añadidas al pedido"
        Me.PedidoGridView.AutoGenerateColumns = False
        Me.MsgErrorPanel.Visible = False
    End Sub

    Protected Sub InicializarDatosCuentaPedido()
        Me.PrecioTotalLbl.Text = 0
        Me.ConfirmadoLbl.Text = "No"
        Me.ServidoLbl.Text = "No"
        Me.PagadoLbl.Text = "No"
    End Sub

    Protected Sub ActualizarDatos()
        Dim ret_ok As Boolean = True

        Select Case ActualizarGridViewPedido()
            Case Ret_Vacio
                MsgEstadoLbl.Text = "No hay consumiciones añadidas al pedido"
                MsgEstadoPanel.Visible = True
                MsgEstadoLbl.CssClass = "gris-oscuro"
                Me.TodosPanel.Visible = False
            Case Ret_Error
                ret_ok = False
            Case Ret_Correcto
                Me.TodosPanel.Visible = True
        End Select

        ActualizarDatosPedido()

        If ret_ok = Ret_Error Then
            Throw New Exception()
        End If
    End Sub

    Protected Sub ActualizarDatosPedido()
        Dim tmp_pedido_actual As pedido_reg

        tmp_pedido_actual = get_pedido_actual(cliente_actual_clave, cadena_conexion)

        Me.PrecioTotalLbl.Text = tmp_pedido_actual.precio

        ' Si el pedido esta confirmado no permito modificarlo
        Me.ConfirmadoLbl.Text = "No"
        If (tmp_pedido_actual.confirmado = 1) Then
            Me.ConfirmadoLbl.Text = "S&iacute"
        End If
        Me.ConfirmarPedidoButton.Visible = True
        Me.AddAlPedidoButton.Visible = True
        Me.EliminarTodosButton.Visible = True
        Me.PedidoGridView.Columns.Item(3).Visible = True
        Me.PedidoGridView.Columns.Item(4).Visible = True
        Me.PedidoGridView.Columns.Item(7).Visible = True

        If (tmp_pedido_actual.confirmado = 1) Then
            Me.ConfirmarPedidoButton.Visible = False
            Me.AddAlPedidoButton.Visible = False
            Me.EliminarTodosButton.Visible = False
            Me.PedidoGridView.Columns.Item(3).Visible = False
            Me.PedidoGridView.Columns.Item(4).Visible = False
            Me.PedidoGridView.Columns.Item(7).Visible = False
        End If

        ' Si el pedido ha sido servido permito pagarlo
        Me.ServidoLbl.Text = "No"
        If (tmp_pedido_actual.servido = 1) Then
            Me.ServidoLbl.Text = "S&iacute;"
        End If
        Me.PagarButton.Visible = False
        If (tmp_pedido_actual.servido = 1 AndAlso tmp_pedido_actual.pagado = 0) Then
            Me.PagarButton.Visible = True
        End If

        ' Muestro el pedido como pagado o no pagado
        Me.PagadoLbl.Text = "No"
        If (tmp_pedido_actual.pagado = 1) Then
            Me.PagadoLbl.Text = "S&iacute;"
        ElseIf tmp_pedido_actual.pagado = 2 Then
            Me.PagadoLbl.Text = "Cuenta"
        End If
    End Sub

    Protected Function ActualizarGridViewPedido() As Integer
        Dim ret_ok As Integer

        ret_ok = LlenarGridViewPedido()
        Me.PedidoGridView.DataBind()
        ActualizarConfirmarPedido()

        Return ret_ok
    End Function

    Protected Sub ActualizarConfirmarPedido()
        Dim tmp_pedido_reg As pedido_reg

        ' Si el pedido esta confirmado oculto el boton de confirmar pedido
        tmp_pedido_reg = get_pedido(pedido_actual_clave, cadena_conexion)

        If Not es_error_pedido(tmp_pedido_reg) Then
            ActualizarDatosPedido()
        End If
    End Sub

    Protected Function LlenarGridViewPedido() As Integer
        Dim ret_ok As Integer = Ret_Correcto
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand

        Try

            ' Muestro las consumiciones del pedido si el pedido existe
            If pedido_actual_clave.id <> -1 Then
                If existe_pedido(pedido_actual_clave, cadena_conexion) Then

                    ' Recupero las consumiciones del pedido
                    comando = get_consumiciones_pedido_str(pedido_actual_clave, cadena_conexion)

                    MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
                    MyDataSet.Clear()
                    MyDataAdapter.Fill(MyDataSet)
                    If MyDataSet.Tables(0).Rows.Count = 0 Then
                        ret_ok = Ret_Vacio
                    Else
                        Me.PedidoGridView.DataSource = MyDataSet.Tables(0)
                    End If
                Else
                    ret_ok = Ret_NoPedido
                End If
            Else
                ret_ok = Ret_NoPedido
            End If
        Catch ex As Exception
            ret_ok = Ret_Error
        End Try

        Return ret_ok
    End Function

    Protected Sub LimpiarGridView()
        Me.PedidoGridView.DataSource = Nothing
        Me.PedidoGridView.DataBind()
    End Sub

    Protected Function EliminarConsumicion(ByVal index As Integer) As Boolean
        Dim tmp_consumicion_clave As consumicion_clave
        Dim ret_ok As Boolean = True

        Try
            tmp_consumicion_clave.id = CInt(Me.PedidoGridView.Rows(index).Cells(0).Text)
            If existe_consumicion(tmp_consumicion_clave, cadena_conexion) Then
                If Not eliminar_consumicion(tmp_consumicion_clave, cadena_conexion) Then
                    ret_ok = False
                End If
            Else
                ret_ok = False
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function ActualizarPrecioPedido(ByVal index As Integer) As Boolean
        Dim tmp_pedido_reg As pedido_reg
        Dim precio As Decimal = 0.0
        Dim cantidad As Integer = 0
        Dim ret_ok As Boolean = True

        Try
            precio = CDec(Me.PedidoGridView.Rows(index).Cells(5).Text)
            tmp_pedido_reg = get_pedido(pedido_actual_clave, cadena_conexion)
            If Not es_error_pedido(tmp_pedido_reg) Then
                tmp_pedido_reg.precio -= precio
                If Not actualizar_pedido(tmp_pedido_reg, cadena_conexion) Then
                    ret_ok = False
                End If
            Else
                ret_ok = False
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Sub AddDelItemConsumicion(ByVal commandname As String, ByVal indice As Integer)
        Dim fila As Integer = -1
        Dim tmp_pedido_actual_reg As pedido_reg
        Dim tmp_consumicion_clave As consumicion_clave
        Dim tmp_consumicion_reg As consumicion_reg
        Dim tmp_itemconsumicion_clave As itemconsumicion_clave
        Dim tmp_itemconsumicion_reg As itemconsumicion_reg
        Dim marca As Boolean = False
        Dim ret_ok As Boolean = True

        fila = indice
        If fila <> -1 Then
            tmp_consumicion_clave.id = CInt(Me.PedidoGridView.Rows(fila).Cells(0).Text)
            tmp_consumicion_reg = get_consumicion(tmp_consumicion_clave, cadena_conexion)

            ' Añado una unidad de consumicion mas
            With tmp_consumicion_reg

                ' Si la consumicion ya existia añado una unidad de consumicion más, sino, será la primera
                If Not es_error_consumicion(tmp_consumicion_reg) Then

                    Select Case commandname
                        Case "Mas"
                            .cantidad = tmp_consumicion_reg.cantidad + 1
                        Case "Menos"
                            .cantidad = tmp_consumicion_reg.cantidad - 1
                            If .cantidad = 0 Then
                                marca = True
                            End If
                    End Select

                    tmp_itemconsumicion_clave.id = tmp_consumicion_reg.FK_itemconsumicion
                    tmp_itemconsumicion_reg = get_itemconsumicion(tmp_itemconsumicion_clave, cadena_conexion)

                    If Not es_error_itemconsumicion(tmp_itemconsumicion_reg) Then
                        If Not marca Then
                            .precio = (tmp_itemconsumicion_reg.precio * CDec(.cantidad))
                            ret_ok = actualizar_consumicion(tmp_consumicion_reg, cadena_conexion)
                        Else
                            ret_ok = eliminar_consumicion(tmp_consumicion_clave, cadena_conexion)
                        End If

                        If ret_ok Then
                            tmp_pedido_actual_reg = get_pedido_actual(cliente_actual_clave, cadena_conexion)
                            tmp_pedido_actual_reg.servido = 0
                            tmp_pedido_actual_reg.pagado = 0
                            Select Case commandname
                                Case "Mas"
                                    tmp_pedido_actual_reg.precio += tmp_itemconsumicion_reg.precio
                                Case "Menos"
                                    tmp_pedido_actual_reg.precio -= tmp_itemconsumicion_reg.precio
                            End Select

                            If Not actualizar_pedido(tmp_pedido_actual_reg, cadena_conexion) Then
                                Throw New Exception()
                            End If
                        Else
                            Throw New Exception()
                        End If
                    End If
                End If
            End With

            ActualizarDatos()
        End If
    End Sub

    Protected Sub PedidoGridView_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles PedidoGridView.PageIndexChanging
        Me.PedidoGridView.PageIndex = e.NewPageIndex()
        InicializarDatosPedido()

        If ActualizarGridViewPedido() Then
            Me.MsgEstadoPanel.Visible = False
        Else
            Me.MsgEstadoPanel.Visible = True
        End If

        Try
            If Me.PedidoGridView.SelectedIndex <> -1 Then
                If Me.PedidoGridView.SelectedIndex Mod 2 = 0 Then
                    Me.PedidoGridView.Rows(Me.PedidoGridView.SelectedIndex).RowState = DataControlRowState.Normal
                Else
                    Me.PedidoGridView.Rows(Me.PedidoGridView.SelectedIndex).RowState = DataControlRowState.Alternate
                End If
            End If

        Catch ex As Exception

        End Try
    End Sub

    Protected Sub PedidoGridView_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles PedidoGridView.RowCommand
        Dim ret_ok As Boolean = True
        Dim fila As Integer = -1
        Dim marca As Boolean = False

        Try
            If e.CommandName.Equals("Mas") OrElse e.CommandName.Equals("Menos") Then
                AddDelItemConsumicion(e.CommandName, e.CommandArgument)
            End If

        Catch ex As Exception
            MsgErrorPanel.Visible = True
            MsgErrorLbl.Text = "Ha habido un problema al actualizar a su pedido"
            MsgErrorLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub PedidoGridView_RowDeleting(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewDeleteEventArgs) Handles PedidoGridView.RowDeleting
        Dim ret_ok As Boolean = False

        ret_ok = EliminarConsumicion(e.RowIndex)

        If ret_ok Then
            ret_ok = ActualizarPrecioPedido(e.RowIndex)
        End If

        If ret_ok Then
            Select Case ActualizarGridViewPedido()
                Case Ret_Vacio
                    MsgEstadoLbl.Text = "No hay consumiciones añadidas al pedido"
                    MsgEstadoPanel.Visible = True
                    MsgEstadoLbl.CssClass = "gris-oscuro"
                Case Ret_Error
                    ret_ok = False
            End Select
            ActualizarDatosPedido()
        Else
            MsgErrorLbl.Text = "Error al eliminar la consumici&oacute;n, consulte con un empleado por favor"
            MsgErrorPanel.Visible = True
        End If
    End Sub

    Protected Sub AddAlPedidoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddAlPedidoButton.Click
        Response.Redirect("AddProductosPedido.aspx")
    End Sub


    Protected Sub EliminarTodosButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EliminarTodosButton.Click
        For i = 0 To Me.PedidoGridView.Rows.Count - 1
            EliminarConsumicion(i)
            ActualizarPrecioPedido(i)
        Next
        ActualizarDatos()
    End Sub

    Protected Sub PagarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles PagarButton.Click
        Response.Redirect("Pagar.aspx")
    End Sub

    Protected Sub ConfirmarPedidoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ConfirmarPedidoButton.Click
        Dim tmp_pedido_reg As pedido_reg
        Dim tmp_usuario_clave As usuario_clave
        Dim tmp_cliente_clave As cliente_clave

        Try
            tmp_usuario_clave.id = Session.Item("IdUsuario")
            tmp_cliente_clave.id = get_cliente_FKUsuario(tmp_usuario_clave, cadena_conexion).id
            tmp_pedido_reg = get_pedido_actual(tmp_cliente_clave, cadena_conexion)

            If Not es_error_pedido(tmp_pedido_reg) Then
                tmp_pedido_reg.confirmado = 1
                If actualizar_pedido(tmp_pedido_reg, cadena_conexion) Then
                    ActualizarConfirmarPedido()
                Else
                    Throw New Exception()
                End If
            Else
                Throw New Exception()
            End If
        Catch ex As Exception
            MsgErrorLbl.Text = "Error al confirmar el pedido. Vuelva a intentarlo o consulte con un empleado. Disculpe las molestias."
            MsgErrorPanel.Visible = True
        End Try
    End Sub

    Protected Sub DetallesPedidoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DetallesPedidoButton.Click
        Dim id_get As Integer = -1

        Try
            id_get = pedido_actual_clave.id
            Response.Redirect("../cliente/DetallesPedido.aspx?id=" & id_get & "&nav=" & Trim(Me.CaminoLbl.Text))
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub Timer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer.Tick
        InicializarDatos()
        If pedido_actual_clave.id <> -1 AndAlso existe_pedido(pedido_actual_clave, cadena_conexion) AndAlso get_pedido(pedido_actual_clave, cadena_conexion).activo = 1 Then
            ActualizarDatos()
        Else
            LimpiarGridView()
        End If
    End Sub
End Class
