﻿Imports accesoBDeRestaurante.pedido_bd
Imports accesoBDeRestaurante.cliente_bd
Imports variables_globales
Imports accesoBDeRestaurante.usuario_bd
Imports AjaxControlToolkit
Imports accesoBDeRestaurante.mesa_bd
Imports accesoBDeRestaurante.reserva_bd


Partial Class cliente_Pagar
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            If Not IsPostBack Then
                EstadoDatos()
            End If
        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoLbl.Text = "Error al mostrar los datos"
        End Try
    End Sub

    Protected Sub EstadoDatos()
        Me.MsgEstadoPanel.Visible = False
        Me.ModoPagoPanel.Visible = True
        Me.AceptarModoPagoButton.Visible = True
        Me.EfectivoPanel.Visible = False
        Me.TarjetaPanel.Visible = False
    End Sub

    Protected Function ValidarDatos(ByVal titular As String, ByVal tarjeta As String, ByVal caducidad As String) As Boolean
        Dim ret_ok As Boolean = True
        Dim f_caducidad As Date

        Try
            ' Compruebo que la fecha de caducidad de la tarjeta es mayor o igual a la fecha actual
            f_caducidad = CDate(caducidad)

            If f_caducidad >= Today Then
                ' Compruebo que el número de tarjeta es válido
                ret_ok = ValidarNoTarjeta(tarjeta)
            Else
                ret_ok = False
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function ValidarNoTarjeta(ByVal tarj As String) As Boolean
        Dim ret_ok As Boolean = True

        Try
            Dim CardType As CreditCard.CreditCardTypes = CreditCard.Validate(tarj)

            If CardType = CreditCard.CreditCardTypes.Invalid Then
                ret_ok = False
            Else
                ret_ok = True
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Sub AceptarModoPagoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AceptarModoPagoButton.Click
        Dim tmp_pedido_reg As pedido_reg
        Dim tmp_cliente_clave As cliente_clave
        Dim tmp_usuario_clave As usuario_clave

        Try
            Me.MsgEstadoPanel.Visible = False

            If Me.EfectivoRadioButton.Checked Then
                ' Pongo el pedido en estado de "solicitar cuenta" e "inactivo"
                tmp_usuario_clave.id = Session.Item("IdUsuario")
                tmp_cliente_clave.id = get_cliente_FKUsuario(tmp_usuario_clave, cadena_conexion).id
                tmp_pedido_reg = get_pedido_actual(tmp_cliente_clave, cadena_conexion)
                tmp_pedido_reg.pagado = 2
                tmp_pedido_reg.activo = 1
                If (actualizar_pedido(tmp_pedido_reg, cadena_conexion)) Then
                    ' Muestro el panel de pago en efectivo y escondo el resto
                    Me.ModoPagoPanel.Visible = False
                    Me.EfectivoPanel.Visible = True
                    Me.TarjetaPanel.Visible = False
                Else
                    MsgEstadoPanel.Visible = True
                    MsgEstadoLbl.CssClass = "rojo"
                    MsgEstadoLbl.Text = "Ha habido un problema al tramitar su pedido. Vuelva a intentarlo y si el error persiste consulte a un empleado.  Disculpe las molestias."
                End If
            Else
                Me.ModoPagoPanel.Visible = False
                Me.EfectivoPanel.Visible = False
                Me.TarjetaPanel.Visible = True
            End If
        Catch ex As Exception
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            MsgEstadoLbl.Text = "Ha habido un problema al tramitar su pedido. Vuelva a intentarlo y si el error persiste consulte a un empleado. Disculpe las molestias."
        End Try
    End Sub

    Protected Sub VolverButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles VolverButton.Click
        Me.MsgEstadoPanel.Visible = False
        Me.ModoPagoPanel.Visible = True
        Me.TarjetaPanel.Visible = False
        Me.EfectivoPanel.Visible = False
    End Sub

    Protected Sub ConfirmarPagoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ConfirmarPagoButton.Click
        Dim nom_titular As String
        Dim num_tarjeta As String
        Dim fecha_caducidad As String
        Dim tmp_pedido_reg As pedido_reg
        Dim tmp_usuario_clave As usuario_clave
        Dim tmp_cliente_clave As cliente_clave
        Dim tmp_mesa_clave As mesa_clave
        Dim tmp_mesa_reg As mesa_reg
        Dim tmp_reserva_reg As reserva_reg
        Dim seguir As Boolean = True

        Try
            Me.MsgEstadoPanel.Visible = False

            nom_titular = Trim(Me.TitularTxt.Text)
            num_tarjeta = Trim(Me.NoTarjetaTxt.Text)
            fecha_caducidad = Trim(Me.FechaCaducidadTxt.Text)

            If ValidarDatos(nom_titular, num_tarjeta, fecha_caducidad) Then
                ' Pongo el pedido en estado "pagado" e "inactivo"
                tmp_usuario_clave.id = Session.Item("IdUsuario")
                tmp_cliente_clave.id = get_cliente_FKUsuario(tmp_usuario_clave, cadena_conexion).id
                tmp_pedido_reg = get_pedido_actual(tmp_cliente_clave, cadena_conexion)
                tmp_pedido_reg.pagado = 1
                tmp_pedido_reg.activo = 0
                If (actualizar_pedido(tmp_pedido_reg, cadena_conexion)) Then
                    ' Libero la mesa
                    tmp_mesa_clave.id = tmp_pedido_reg.FK_mesa
                    tmp_mesa_reg = get_mesa(tmp_mesa_clave, cadena_conexion)
                    If Not (es_error_mesa(tmp_mesa_reg)) Then
                        tmp_mesa_reg.libre = 1
                        tmp_mesa_reg.comensales = 0
                        If (actualizar_mesa(tmp_mesa_reg, cadena_conexion)) Then
                            ' Si había una reserva la marco como finalizada
                            If (existe_reserva_mesa_iniciada(tmp_mesa_clave, tmp_pedido_reg.fecha, cadena_conexion)) Then
                                tmp_reserva_reg = get_reserva_iniciada(tmp_mesa_clave, tmp_pedido_reg.fecha, cadena_conexion)
                                tmp_reserva_reg.finalizada = 1
                                If Not (actualizar_reserva(tmp_reserva_reg, cadena_conexion)) Then
                                    seguir = False
                                End If
                            End If
                            If (seguir) Then
                                Me.TarjetaPanel.Visible = False
                                MsgEstadoPanel.Visible = True
                                MsgEstadoLbl.CssClass = "gris-oscuro"
                                MsgEstadoLbl.Text = "La operaci&oacute;n se ha realizado con &eacute;xito. Muchas gracias."
                                MsgEstadoImage.ImageUrl = icono_ok
                            Else
                                Throw New Exception()
                            End If
                        Else
                            Throw New Exception()
                        End If
                    Else
                        Throw New Exception()
                    End If
                Else
                    Throw New Exception()
                End If
            Else
                Throw New Exception()
            End If
        Catch ex As Exception
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            MsgEstadoLbl.Text = "Error al confirmar el pago. Vuelva a intentarlo y si el error persiste consulte a un empleado. Disculpe las molestias."
        End Try
    End Sub

    Protected Sub EfectivoRadioButton_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles EfectivoRadioButton.CheckedChanged, TarjetaRadioButton.CheckedChanged
        Me.MsgEstadoPanel.Visible = False
        Me.DataBind()
    End Sub

    Protected Sub FechaCaducidadTxt_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles FechaCaducidadTxt.TextChanged, NoTarjetaTxt.TextChanged, FechaCaducidadTxt.TextChanged
        Me.MsgEstadoPanel.Visible = False
        Me.DataBind()
    End Sub

End Class
