﻿Imports AjaxControlToolkit
Imports accesoBDeRestaurante.mesa_bd
Imports variables_globales
Imports accesoBDeRestaurante.camarero_bd
Imports accesoBDeRestaurante.reserva_bd
Imports accesoBDeRestaurante.pedido_bd
Imports accesoBDeRestaurante.usuario_bd
Imports accesoBDeRestaurante.cliente_bd

Partial Class clienteweb_NuevaReserva
    Inherits System.Web.UI.Page

    Protected Shared num_mesa_seleccionada As Integer = -1
    Protected Shared index_mesa_seleccionada As Integer = -1
    Protected Shared dia_hora As Date
    Protected Shared lista_horas() As String = {"13:00", "14:00", "15:00", "21:00", "22:00", "23:00"}

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            If Not IsPostBack Then
                InicializarDatos()
                EstadoDatos(False)
                ActualizarDatos()
            End If
        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoLbl.Text = "Error al mostrar los datos"
        End Try
    End Sub

    Protected Sub InicializarDatos()
        Dim tmp_fecha As Date
        Dim tmp_hora As String()
        Dim fec_ultimo_horario_reserva As Date
        Dim ultimo_horario_reserva As String()

        Me.MaxPersonasTxt.Text = ""

        ' Si la hora actual es mayor que el ultimo horario de reserva mostramos el dia siguiente
        ultimo_horario_reserva = ObtenerHoraFecha(lista_horas.ElementAt(lista_horas.Length - 1))
        fec_ultimo_horario_reserva = New Date(Date.Now.Year, Date.Now.Month, Date.Now.Day, ultimo_horario_reserva(0), ultimo_horario_reserva(1), 0)
        If (Date.Now.CompareTo(fec_ultimo_horario_reserva) > 0) Then
            Me.DiaTxt.Text = Date.Now.AddDays(1).ToShortDateString
            tmp_hora = ObtenerHoraFecha("00:00")
        Else
            Me.DiaTxt.Text = Date.Now.ToShortDateString
            tmp_hora = ObtenerHoraFecha(Date.Now.ToShortTimeString)
        End If

        ' Recupero fecha y hora seleccionadas
        tmp_fecha = CDate(Me.DiaTxt.Text)
        dia_hora = New Date(tmp_fecha.Year, tmp_fecha.Month, tmp_fecha.Day, tmp_hora(0), tmp_hora(1), 0)
        CargarHorarios()
        Me.HoraComboBox.SelectedIndex = 0
        tmp_hora = ObtenerHoraFecha(Me.HoraComboBox.SelectedValue)
        dia_hora = New Date(tmp_fecha.Year, tmp_fecha.Month, tmp_fecha.Day, tmp_hora(0), tmp_hora(1), 0)
        num_mesa_seleccionada = -1
        Me.MsgEstadoLbl.Text = ""
        Me.MsgEstadoPanel.Visible = False
    End Sub

    ' Funcion que obtiene hora y minutos a partir de un String "hh:mm"
    Protected Function ObtenerHoraFecha(ByVal hora As String) As String()
        Dim tmp_hora As String()
        tmp_hora = Trim(hora).Split(":")
        Return tmp_hora
    End Function

    Protected Sub InicializarDatosSinFecha()
        Dim tmp_hora As String()

        Me.MaxPersonasTxt.Text = ""
        num_mesa_seleccionada = -1
        Me.MsgEstadoLbl.Text = ""
        Me.MsgEstadoPanel.Visible = False
        tmp_hora = ObtenerHoraFecha(Me.HoraComboBox.SelectedValue)
        dia_hora = CDate(Me.DiaTxt.Text).AddHours(tmp_hora(0)).AddMinutes(tmp_hora(1))
    End Sub

    Protected Sub InicializarDatosSinFechaHora()
        Me.MaxPersonasTxt.Text = ""
        num_mesa_seleccionada = -1
        Me.MsgEstadoLbl.Text = ""
        Me.MsgEstadoPanel.Visible = False
    End Sub

    Protected Sub EstadoDatos(ByVal est As Boolean)
        Me.BotonesPanel.Visible = est
        Me.ReservarMesaButton.Visible = est
    End Sub

    Protected Sub ActualizarDatos()
        Dim ret_ok As Boolean = True
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand

        Try
            comando = get_todas_mesas_str(cadena_conexion)

            MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
            MyDataSet.Clear()
            MyDataAdapter.Fill(MyDataSet)

            If MyDataSet.Tables(0).Rows.Count = 0 Then
                Me.MsgEstadoLbl.Text = "No hay mesas disponibles"
                Me.MsgEstadoLbl.CssClass = "gris-muy-oscuro"
                Me.MsgEstadoPanel.Visible = True
            Else
                Me.MesasRepeater.DataSource = MyDataSet.Tables(0)
                Me.MesasRepeater.DataBind()
            End If
        Catch ex As Exception
            Me.MsgEstadoLbl.Text = "Ha habido un problema al actualizar los datos. Vuelva a intentarlo o consulte con el administrador.<br />Disculpe las molestias."
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub PintarMesas()
        Dim mesa_clave As mesa_clave

        For Each mesa In Me.MesasRepeater.Items

            mesa_clave.id = CInt(CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).CommandArgument)

            ' Si la fecha no es la actual sólo comprobamos reservas, ya que no tiene sentido en la aplicación
            ' que una mesa esté ocupada ahora mañana.
            If Not dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then
                If existe_reserva_mesa(mesa_clave, dia_hora, cadena_conexion) Then
                    CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).CssClass = "boton-mesa-reservada"
                Else
                    CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                End If
            Else
                ' Si la fecha es la actual comprobamos reservas y ocupación en el momento.
                If existe_reserva_mesa(mesa_clave, dia_hora, cadena_conexion) Then
                    CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).CssClass = "boton-mesa-reservada"
                Else
                    If esta_ocupada(mesa_clave, cadena_conexion) Then
                        CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).CssClass = "boton-mesa-ocupada"
                    Else
                        CType(CType(mesa, RepeaterItem).FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                    End If
                End If
            End If
        Next
    End Sub

    Protected Sub CambiarFecha(ByVal hora As Boolean)
        If hora Then
            InicializarDatosSinFecha()
        Else
            InicializarDatosSinFechaHora()
        End If

        ActualizarDatos()
        EstadoDatos(False)
    End Sub

    Protected Sub CargarHorarios()
        Dim hora_ahora As TimeSpan
        Dim hora_tmp As TimeSpan

        HoraComboBox.Items.Clear()

        ' Si el dia es mayor al de hoy muestro todos los horarios, sino solo las horas posteriores a la actual
        If dia_hora.Date.CompareTo(Date.Now.Date) > 0 Then
            For i As Integer = 0 To lista_horas.Length - 1
                Me.HoraComboBox.Items.Add(New ListItem(lista_horas(i)))
            Next
        Else
            ' Recojo la hora actual
            hora_ahora = Date.Now.TimeOfDay

            ' Muestro solo las horas posteriores a la actual
            For i As Integer = 0 To lista_horas.Length - 1
                hora_tmp = TimeSpan.Parse((CDate(lista_horas(i))).ToShortTimeString)
                If hora_tmp.CompareTo(hora_ahora) > 0 Then
                    Me.HoraComboBox.Items.Add(New ListItem(hora_tmp.ToString))
                End If
            Next
        End If
    End Sub

    Protected Sub MesasRepeater_ItemCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.RepeaterCommandEventArgs) Handles MesasRepeater.ItemCommand
        Dim mesa_clave As mesa_clave
        Dim mesa_clave_ant As mesa_clave

        Try

            ' Borramos el posible mensaje de estado
            Me.MsgEstadoLbl.Text = ""
            Me.MsgEstadoPanel.Visible = False

            ' Si la mesa que habia seleccionada es la que hemos pulsado...
            If num_mesa_seleccionada = e.CommandArgument Then

                ' Deseleccionamos la mesa 
                mesa_clave.id = num_mesa_seleccionada
                num_mesa_seleccionada = -1
                index_mesa_seleccionada = -1

                If existe_reserva_mesa(mesa_clave, dia_hora, cadena_conexion) Then
                    CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-reservada"
                ElseIf dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then
                    If esta_ocupada(mesa_clave, cadena_conexion) Then
                        CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-ocupada"
                    Else
                        CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                    End If
                Else
                    CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                End If

                Me.MaxPersonasTxt.Text = ""

                ' Deshabilito los botones de acción sobre una mesa concreta
                EstadoDatos(False)
            Else
                ' Si habia una mesa antes seleccionada la deseleccionamos
                If (num_mesa_seleccionada <> Nothing And num_mesa_seleccionada <> -1) Then
                    mesa_clave_ant.id = num_mesa_seleccionada
                    If existe_reserva_mesa(mesa_clave_ant, dia_hora, cadena_conexion) Then
                        CType(Me.MesasRepeater.Items.Item(index_mesa_seleccionada).FindControl("Button"), Button).CssClass = "boton-mesa-reservada"
                    ElseIf dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then
                        If esta_ocupada(mesa_clave_ant, cadena_conexion) Then
                            CType(Me.MesasRepeater.Items.Item(index_mesa_seleccionada).FindControl("Button"), Button).CssClass = "boton-mesa-ocupada"
                        Else
                            CType(Me.MesasRepeater.Items.Item(index_mesa_seleccionada).FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                        End If
                    Else
                        CType(Me.MesasRepeater.Items.Item(index_mesa_seleccionada).FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                    End If
                End If

                ' Seleccionamos la mesa pulsada
                num_mesa_seleccionada = e.CommandArgument
                index_mesa_seleccionada = e.Item.ItemIndex
                mesa_clave.id = num_mesa_seleccionada

                If existe_reserva_mesa(mesa_clave, dia_hora, cadena_conexion) Then
                    CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-reservada-sel"
                ElseIf dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then
                    If esta_ocupada(mesa_clave, cadena_conexion) Then
                        CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-ocupada-sel"
                    Else
                        CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-libre-sel"
                        ' Habilito los botones de acción sobre la mesa siempre que no esté ocupada ni reservada
                        EstadoDatos(True)
                    End If
                Else
                    CType(Me.MesasRepeater.Items.Item(e.Item.ItemIndex).FindControl("Button"), Button).CssClass = "boton-mesa-libre-sel"
                    ' Habilito los botones de acción sobre la mesa siempre que no esté ocupada ni reservada
                    EstadoDatos(True)
                End If

                Dim tmp_mesa_clave As mesa_clave
                tmp_mesa_clave.id = num_mesa_seleccionada
                Me.MaxPersonasTxt.Text = get_mesa(tmp_mesa_clave, cadena_conexion).max_personas

            End If

        Catch ex As Exception
            ex.StackTrace.ToString()
        End Try
    End Sub

    Protected Sub MesasRepeater_ItemDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.RepeaterItemEventArgs) Handles MesasRepeater.ItemDataBound
        Dim mesa_clave As mesa_clave

        Try
            mesa_clave.id = CType(e.Item.FindControl("Button"), Button).CommandArgument

            ' Si la fecha no es la actual sólo comprobamos reservas, ya que no tiene sentido en la aplicación
            ' que una mesa esté ocupada ahora mañana.
            If Not dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then

                If existe_reserva_mesa(mesa_clave, dia_hora, cadena_conexion) Then
                    CType(e.Item.FindControl("Button"), Button).CssClass = "boton-mesa-reservada"
                    CType(e.Item.FindControl("Button"), Button).Enabled = False
                Else
                    CType(e.Item.FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                    CType(e.Item.FindControl("Button"), Button).Enabled = True
                End If

            Else
                ' Si la fecha es la actual comprobamos reservas y ocupación en el momento.
                If existe_reserva_mesa(mesa_clave, dia_hora, cadena_conexion) Then
                    CType(e.Item.FindControl("Button"), Button).CssClass = "boton-mesa-reservada"
                    CType(e.Item.FindControl("Button"), Button).Enabled = False
                ElseIf dia_hora.ToShortDateString.Equals(Today.ToShortDateString) Then
                    If esta_ocupada(mesa_clave, cadena_conexion) Then
                        CType(e.Item.FindControl("Button"), Button).CssClass = "boton-mesa-ocupada"
                        CType(e.Item.FindControl("Button"), Button).Enabled = False
                    Else
                        CType(e.Item.FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                        CType(e.Item.FindControl("Button"), Button).Enabled = True
                    End If
                Else
                    CType(e.Item.FindControl("Button"), Button).CssClass = "boton-mesa-libre"
                    CType(e.Item.FindControl("Button"), Button).Enabled = True
                End If
            End If

        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoLbl.Text = "Error al mostrar los datos"
        End Try

    End Sub

    Protected Sub Calendar1_DayRender(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DayRenderEventArgs) Handles Calendar1.DayRender
        Dim ultimo_horario_reserva As String()
        Dim fec_ultimo_horario_reserva As Date

        ' No permito seleccionar los dias pasados a hoy ni el dia de hoy si ya no se puede reservar a ninguna hora
        ultimo_horario_reserva = ObtenerHoraFecha(lista_horas.ElementAt(lista_horas.Length - 1))
        fec_ultimo_horario_reserva = New Date(Date.Now.Year, Date.Now.Month, Date.Now.Day, ultimo_horario_reserva(0), ultimo_horario_reserva(1), 0)

        If e.Day.Date.CompareTo(Today) < 0 Or ((e.Day.Date.Equals(Date.Now.Date)) And (Date.Now.CompareTo(fec_ultimo_horario_reserva) > 0)) Then
            e.Cell.Font.Strikeout = True
            e.Day.IsSelectable = False
        End If
    End Sub

    Protected Sub Calendar1_SelectionChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Calendar1.SelectionChanged
        Dim pce As PopupControlExtender
        Dim tmp_fecha As Date
        Dim tmp_hora As String()

        ' Recupero fecha y hora seleccionadas
        tmp_fecha = CDate(CType(sender, Calendar).SelectedDate.ToShortDateString)
        If (tmp_fecha.CompareTo(Date.Now.Date) > 0) Then
            dia_hora = New Date(tmp_fecha.Year, tmp_fecha.Month, tmp_fecha.Day, 0, 0, 0)
        Else
            dia_hora = New Date(tmp_fecha.Year, tmp_fecha.Month, tmp_fecha.Day, Date.Now.Hour, Date.Now.Minute, 0)
        End If

        ' Cargo los horarios de reserva
        CargarHorarios()

        tmp_hora = ObtenerHoraFecha(Me.HoraComboBox.SelectedValue)
        dia_hora = New Date(tmp_fecha.Year, tmp_fecha.Month, tmp_fecha.Day, tmp_hora(0), tmp_hora(1), 0)

        CambiarFecha(False)

        pce = AjaxControlToolkit.PopupControlExtender.GetProxyForCurrentPopup(Page)
        pce.Commit(CType(sender, Calendar).SelectedDate.ToShortDateString)
    End Sub

    Protected Sub OkReservarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles OkReservarButton.Click
        Dim tmp_reserva_reg As New reserva_reg
        Dim tmp_usuario_clave As usuario_clave

        Try
            ' Recupero fecha y hora de la reserva
            tmp_reserva_reg.fecha = dia_hora

            If (dia_hora.CompareTo(Date.Now) > 0) Then
                ' Recupero el cliente que ha iniciado sesión 
                tmp_usuario_clave.id = Session.Item("IdUsuario")
                tmp_reserva_reg.FK_cliente = get_cliente_FKUsuario(tmp_usuario_clave, cadena_conexion).id
                tmp_reserva_reg.FK_mesa = num_mesa_seleccionada
                tmp_reserva_reg.finalizada = 0
                ' Guardo la nueva reserva
                If insertar_reserva(tmp_reserva_reg, cadena_conexion) Then
                    InicializarDatosSinFecha()
                    ActualizarDatos()
                    PintarMesas()
                    num_mesa_seleccionada = -1
                    EstadoDatos(False)
                Else
                    Throw New Exception()
                End If
            Else
                Me.MsgEstadoLbl.Text = "Atenci&oacute;n. El d&iacute;a y hora de la reserva ya ha pasado."
                Me.MsgEstadoPanel.Visible = True
                Me.MsgEstadoLbl.CssClass = "rojo"
            End If
        Catch ex As Exception
            Me.MsgEstadoLbl.Text = "Ha habido un problema al realizar la reserva. Vuelva a intentarlo o consulte con el administrador.<br />Disculpe las molestias."
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub CancelReservarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelReservarButton.Click
        PintarMesas()
        num_mesa_seleccionada = -1
        EstadoDatos(False)
    End Sub

    Protected Sub HoraComboBox_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles HoraComboBox.SelectedIndexChanged
        Try
            CambiarFecha(True)
        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoLbl.Text = "Error al cambiar el turno"
        End Try
    End Sub

End Class
