﻿Imports variables_globales
Imports accesoBDeRestaurante.cliente_bd
Imports accesoBDeRestaurante.usuario_bd
Imports accesoBDeRestaurante.reserva_bd

Partial Class clienteweb_Reservas
    Inherits System.Web.UI.Page


    Protected Const Ret_Vacio As Integer = -1
    Protected Const Ret_Error As Integer = 0
    Protected Const Ret_Correcto As Integer = 1
    Protected Const Ret_NoPedido As Integer = -2

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Try
            If Not IsPostBack Then
                InicializarDatos()
                ActualizarDatos()
            End If
        Catch ex As Exception
            Me.MsgEstadoLbl.Text = "Ha habido un problema al mostral las reservas, vuelva a intentarlo o consulte con un empleado. <br /> Disculpe las molestias"
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub

    Protected Sub InicializarDatos()
        Me.ReservasNoCreadasLbl.Visible = True
        Me.MsgEstadoPanel.Visible = False
    End Sub

    Protected Sub ActualizarDatos()
        Dim ret_ok As Boolean = True

        Select Case ActualizarGridViewReservas()
            Case Ret_Vacio
                Me.NoHayReservasPanel.Visible = True
            Case Ret_Error
                Me.NoHayReservasPanel.Visible = False
                ret_ok = False
            Case Ret_Correcto
                Me.NoHayReservasPanel.Visible = False
        End Select

        If ret_ok = Ret_Error Then
            Throw New Exception()
        End If
    End Sub

    Protected Function ActualizarGridViewReservas() As Integer
        Dim ret_ok As Integer

        ret_ok = LlenarGridViewReservas()
        Me.ReservasGridView.DataBind()

        Return ret_ok
    End Function

    Protected Function LlenarGridViewReservas() As Integer
        Dim ret_ok As Integer = Ret_Correcto
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand
        Dim tmp_usuario_clave As usuario_clave
        Dim tmp_cliente_clave As cliente_clave

        Try
            ' Recupero el cliente que ha iniciado sesión 
            tmp_usuario_clave.id = Session.Item("IdUsuario")
            tmp_cliente_clave.id = get_cliente_FKUsuario(tmp_usuario_clave, cadena_conexion).id

            ' Recupero el historial de pedidos del cliente
            comando = get_reservas_str(tmp_cliente_clave, cadena_conexion)
            MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
            MyDataSet.Clear()
            MyDataAdapter.Fill(MyDataSet)

            If MyDataSet.Tables(0).Rows.Count = 0 Then
                ret_ok = Ret_Vacio
            Else
                Me.ReservasGridView.DataSource = MyDataSet.Tables(0)
            End If

        Catch ex As Exception
            ret_ok = Ret_Error
        End Try

        Return ret_ok
    End Function

    Protected Function EliminarReserva(ByVal index As Integer) As Boolean
        Dim tmp_reserva_clave As reserva_clave
        Dim ret_ok As Boolean = True

        Try
            tmp_reserva_clave.id = CInt(Me.ReservasGridView.Rows(index).Cells(0).Text)
            If existe_reserva(tmp_reserva_clave, cadena_conexion) Then
                If Not eliminar_reserva(tmp_reserva_clave, cadena_conexion) Then
                    ret_ok = False
                End If
            Else
                ret_ok = False
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function



    Protected Sub NuevaReservaButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NuevaReservaButton.Click
        Try
            Response.Redirect("NuevaReserva.aspx")
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub ReservasGridView_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles ReservasGridView.RowCommand
        Try
            If e.CommandName.Equals("Eliminar") Then
                If Not EliminarReserva(e.CommandArgument) Then
                    Throw New Exception()
                End If
                ActualizarDatos()
            End If
        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.Text = "Ha habido un problema al cancelar su reserva, puede que no se halla cancelado, actualice y si sigue activa vuelva a intentarlo."
            Me.MsgEstadoLbl.CssClass = "rojo"
        End Try
    End Sub
End Class
