﻿Imports accesoBDeRestaurante.camarero_bd
Imports variables_globales

Partial Class gerente_DetallesEmpleado
    Inherits System.Web.UI.Page

    Protected Shared empleado As Integer
    Protected Shared op As String
    Protected Shared camino As String
    Protected Const sin_foto As String = "../img/sinfoto.gif"
    Const Error_EM As String = "Ha habido un problema al mostrar los datos del empleado"

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            ' Carga de los datos sólo una vez, cuando la página carga
            If Not IsPostBack Then
                ' Recupero los parametros
                op = Trim(Request.Params("op"))
                Try
                    empleado = Request.Params("empleado")
                Catch ex As Exception
                    empleado = -1
                End Try
                If op.CompareTo("") = 0 Then
                    Me.GestionarEmpleadoLbl.Text = "Gestionar"
                Else
                    Me.GestionarEmpleadoLbl.Text = op
                End If
                camino = Trim(Request.Params("nav"))
                Me.CaminoLbl.Text = camino & ">Detalles empleado"

                InicializarDatos()

                Select Case op
                    Case "Nuevo"
                        EstadoDatos(False, False)
                        Me.FotoImage.ImageUrl = sin_foto
                        Me.CaminoLbl.Text = camino
                    Case "Modificar"
                        EstadoDatos(True, False)
                        If Not MostrarDatos() Then
                            Throw New Exception()
                        End If
                    Case "Detalles"
                        EstadoDatos(True, True)
                        If Not MostrarDatos() Then
                            Throw New Exception()
                        End If
                End Select
            End If
        Catch ex As Exception
            Me.MsgEstadoLbl.Text = Error_EM
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "marron"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub

    Public Sub InicializarDatos()
        Me.NombreTxt.Text = ""
        Me.Apellido1Txt.Text = ""
        Me.Apellido2Txt.Text = ""
        Me.FotoImage.DescriptionUrl = "Seleccionar Imagen"
        Me.MsgEstadoPanel.Visible = False
    End Sub

    Private Sub EstadoDatos(ByVal valor As Boolean, ByVal modo_ro As Boolean)
        Me.IdTxt.Enabled = False
        Me.IdLbl.Visible = valor
        Me.IdTxt.Visible = valor
        Me.LimpiarButton.Visible = Not valor

        If (modo_ro) Then
            Me.NombreTxt.Enabled = False
            Me.Apellido1Txt.Enabled = False
            Me.Apellido2Txt.Enabled = False
            Me.GuardarButton.Visible = False
            Me.FotoLbl.Visible = False
            Me.FotoFileUpload.Visible = False
            Me.CancelarButton.Text = "Volver"
        End If
    End Sub

    Private Function MostrarDatos() As Boolean
        Dim tmp_camarero_clave As New camarero_clave
        Dim tmp_camarero_reg As New camarero_reg
        Dim ret_ok As Boolean = True

        Try
            If (empleado <> -1) Then
                tmp_camarero_clave.id = empleado
                tmp_camarero_reg = get_camarero(tmp_camarero_clave, cadena_conexion)

                If Not es_error_camarero(tmp_camarero_reg) Then
                    Me.IdTxt.Text = tmp_camarero_reg.id
                    Me.NombreTxt.Text = tmp_camarero_reg.nombre
                    Me.Apellido1Txt.Text = tmp_camarero_reg.apellido1
                    Me.Apellido2Txt.Text = tmp_camarero_reg.apellido2
                    If (Trim(tmp_camarero_reg.foto).Equals("")) Then
                        Me.FotoImage.ImageUrl = "../img/sinfoto.gif"
                    Else
                        Me.FotoImage.ImageUrl = tmp_camarero_reg.foto
                    End If
                Else
                    ret_ok = False
                End If
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function GuardarDatos() As Boolean
        Dim tmp_camarero_clave As camarero_clave
        Dim tmp_camarero_reg As camarero_reg
        Dim ret_ok As Boolean = True

        Try
            ' Recupero los datos y actualizo o inserto un registro
            tmp_camarero_reg.nombre = Trim(Me.NombreTxt.Text)
            tmp_camarero_reg.apellido1 = Trim(Me.Apellido1Txt.Text)
            tmp_camarero_reg.apellido2 = Trim(Me.Apellido2Txt.Text)
            If (Not (Me.FotoFileUpload.FileName Is Nothing) And Not (Me.FotoFileUpload.FileName.Equals(""))) Then
                Me.FotoFileUpload.SaveAs(Server.MapPath("..\\img") & "\\" & Me.FotoFileUpload.FileName)
                tmp_camarero_reg.foto = "../img" & "/" & Me.FotoFileUpload.FileName
            End If

            Select Case op
                Case "Nuevo"
                    tmp_camarero_clave = insertar_camarero(tmp_camarero_reg, cadena_conexion)
                    tmp_camarero_reg.id = tmp_camarero_clave.id

                    If es_error_camarero(tmp_camarero_reg) Then
                        ret_ok = False
                    End If

                Case "Modificar"
                    ' Obtengo el empleado a modificar
                    tmp_camarero_reg.id = empleado
                    If es_error_camarero(tmp_camarero_reg) Then
                        ret_ok = False
                    Else
                        ret_ok = actualizar_camarero(tmp_camarero_reg, cadena_conexion)
                    End If
            End Select

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Protected Sub GuardarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GuardarButton.Click
        Dim ret_ok As Boolean = True

        ret_ok = GuardarDatos()

        ' Muestro un mensaje de estado
        If ret_ok Then
            Me.MsgEstadoLbl.Text = "Empleado guardado correctamente"
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "verde"
            Me.MsgEstadoImage.ImageUrl = icono_ok
        Else
            Me.MsgEstadoLbl.Text = "Ha habido un problema al guardar el empleado"
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "marron"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End If
    End Sub

    Protected Sub CancelarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelarButton.Click
        Response.Redirect("Empleados.aspx")
    End Sub

    Protected Sub LimpiarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles LimpiarButton.Click
        InicializarDatos()
    End Sub


End Class
