﻿Imports accesoBDeRestaurante.producto_bd
Imports accesoBDeRestaurante.tipoproducto_bd
Imports accesoBDeRestaurante.itemconsumicion_bd
Imports variables_globales
Imports accesoBDeRestaurante.menu_bd
Imports accesoBDeRestaurante.productosmenu_bd

Partial Class gerente_DetallesMenu
    Inherits System.Web.UI.Page

    Protected Shared menu As Integer
    Protected Shared op As String
    Protected Shared camino As String
    Protected Shared lista_productos_orig As New List(Of String)
    Const Error_EM As String = "Ha habido un problema al mostrar los detalles del men&uacute;"

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim itemconsumicion As New itemconsumicion_clave

        Try
            ' Carga de los datos sólo una vez, cuando la página carga
            If Not IsPostBack Then
                ' Recupero los parametros
                op = Trim(Request.Params("op"))
                Try
                    itemconsumicion.id = Request.Params("menu")
                Catch ex As Exception
                    itemconsumicion.id = -1
                End Try

                If op.CompareTo("") = 0 Then
                    Me.GestionarMenuLbl.Text = "Gestionar"
                Else
                    Me.GestionarMenuLbl.Text = op
                End If

                camino = Trim(Request.Params("nav"))


                ' Obtengo el menu a partir del itemconsumicion
                menu = get_menu_FKItemConsumicion(itemconsumicion, cadena_conexion).id

                InicializarDatos()

                Me.CaminoLbl.Text = camino & ">Detalles Men&uacute;"
                Select Case op
                    Case "Nuevo"
                        EstadoDatos(False, False)
                        Me.CaminoLbl.Text = camino
                    Case "Modificar"
                        EstadoDatos(True, False)
                        If Not MostrarDatos() Then
                            Throw New Exception()
                        End If
                    Case "Detalles"
                        EstadoDatos(True, True)
                        If Not MostrarDatos() Then
                            Throw New Exception()
                        End If
                End Select

                If Not ActualizarDatos() Then
                    Throw New Exception()
                End If
            End If
        Catch ex As Exception
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.Text = Error_EM
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub

    Public Sub InicializarDatos()
        Me.NombreTxt.Text = ""
        Me.DescripcionTxt.Text = ""
        Me.PrecioTxt.Text = "0"
        Me.CantidadTxt.Text = "1"
        Me.MsgEstadoPanel.Visible = False
        Me.TiposProductoComboBox.AutoPostBack = True
        Me.ProductosMenuListBox.Items.Clear()
        Me.LlenarListBoxProductos()
    End Sub

    Private Sub EstadoDatos(ByVal valor As Boolean, ByVal modo_ro As Boolean)
        Me.IdTxt.Enabled = False
        Me.IdLbl.Visible = valor
        Me.IdTxt.Visible = valor
        Me.LimpiarButton.Visible = Not valor

        If (modo_ro) Then
            Me.NombreTxt.Enabled = False
            Me.DescripcionTxt.Enabled = False
            Me.PrecioTxt.Enabled = False
            Me.TiposProductoComboBox.Enabled = False
            Me.AddButton.Enabled = False
            Me.DelButton.Enabled = False
            Me.GuardarButton.Visible = False
            Me.CancelarButton.Text = "Volver"
            Me.CantidadLbl.Visible = False
            Me.CantidadTxt.Visible = False
        End If
    End Sub

    Private Function MostrarDatos() As Boolean
        Dim tmp_itemconsumicion_clave As New itemconsumicion_clave
        Dim tmp_itemconsumicion_reg As New itemconsumicion_reg
        Dim tmp_menu_clave As menu_clave
        Dim ret_ok As Boolean = True

        Try
            If (menu <> -1) Then
                tmp_menu_clave.id = menu
                tmp_itemconsumicion_clave.id = get_menu(tmp_menu_clave, cadena_conexion).FK_itemconsumicion
                tmp_itemconsumicion_reg = get_itemconsumicion(tmp_itemconsumicion_clave, cadena_conexion)

                If Not es_error_itemconsumicion(tmp_itemconsumicion_reg) Then
                    Me.IdTxt.Text = tmp_itemconsumicion_reg.id
                    Me.NombreTxt.Text = tmp_itemconsumicion_reg.nombre
                    Me.DescripcionTxt.Text = tmp_itemconsumicion_reg.descripcion
                    Me.PrecioTxt.Text = tmp_itemconsumicion_reg.precio
                Else
                    ret_ok = False
                End If
            End If

            If ret_ok Then
                ActualizarDatos()
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function GuardarDatos() As Boolean
        Dim tmp_itemconsumicion_clave As itemconsumicion_clave
        Dim tmp_itemconsumicion_reg As itemconsumicion_reg
        Dim ret_ok As Boolean = True
        Dim value_items As List(Of String)
        Dim value_items_orig As List(Of String)
        Dim value_items_insertar As List(Of String)
        Dim value_items_eliminar As List(Of String)
        Dim tmp_producto_clave As producto_clave
        Dim tmp_productosmenu_clave As productosmenu_clave
        Dim tmp_productosmenu_reg As productosmenu_reg
        Dim tmp_menu_clave As New menu_clave
        Dim tmp_menu_reg As menu_reg

        Try
            ' Recupero los datos y actualizo o inserto un registro
            tmp_itemconsumicion_reg.nombre = Trim(Me.NombreTxt.Text)
            tmp_itemconsumicion_reg.descripcion = Trim(Me.DescripcionTxt.Text)
            Try
                tmp_itemconsumicion_reg.precio = PrecioTxt.Text
            Catch ex As Exception
                tmp_itemconsumicion_reg.precio = 0
            End Try

            tmp_itemconsumicion_reg.tipo = "M"

            Select Case op
                Case "Nuevo"
                    tmp_itemconsumicion_clave.id = insertar_itemconsumicion(tmp_itemconsumicion_reg, cadena_conexion).id
                    tmp_menu_reg.FK_itemconsumicion = tmp_itemconsumicion_clave.id

                    If tmp_menu_reg.FK_itemconsumicion = -1 Then
                        ret_ok = False
                    Else
                        tmp_menu_clave = insertar_menu(tmp_menu_reg, cadena_conexion)
                        If tmp_menu_clave.id = -1 Then
                            eliminar_itemconsumicion(tmp_itemconsumicion_clave, cadena_conexion)
                            ret_ok = False
                        End If
                    End If
                Case "Modificar"
                    ' Obtengo el itemconsumicion a modificar a partir del menu
                    tmp_menu_clave.id = menu
                    tmp_itemconsumicion_reg.id = get_menu(tmp_menu_clave, cadena_conexion).FK_itemconsumicion
                    If es_error_itemconsumicion(tmp_itemconsumicion_reg) Then
                        ret_ok = False
                    Else
                        ret_ok = actualizar_itemconsumicion(tmp_itemconsumicion_reg, cadena_conexion)
                    End If
            End Select

            If ret_ok Then

                ' Obtengo los id de los productos del listbox que son del menu
                ' que estamos modificando
                value_items = GetCantidadValueItems(Me.ProductosMenuListBox.Items)

                ' Hago lo mismo para obtener los id originales (los que estan en la bd)
                value_items_orig = lista_productos_orig

                ' Obtengo los productos que se han añadido o quitado del menu
                value_items_insertar = value_items.Except(value_items_orig.AsEnumerable).ToList 'Nuevos
                value_items_eliminar = value_items_orig.Except(value_items.AsEnumerable).ToList 'Quitados

                ' Quito del menú los productos que ya no pertenecen a el
                For Each cantidad_id In value_items_eliminar
                    tmp_itemconsumicion_clave.id = cantidad_id.Split("x").GetValue(1)
                    tmp_producto_clave.id = get_producto_FKItemConsumicion(tmp_itemconsumicion_clave, cadena_conexion).id
                    tmp_productosmenu_reg.FK_menu = tmp_menu_clave.id
                    tmp_productosmenu_reg.FK_producto = tmp_producto_clave.id
                    If existe_productosmenu(tmp_productosmenu_reg, cadena_conexion) Then
                        tmp_productosmenu_reg = get_productosmenu_FKMenu_FKProducto(tmp_productosmenu_reg, cadena_conexion)
                        tmp_productosmenu_clave.id = tmp_productosmenu_reg.id
                        ret_ok = eliminar_productosmenu(tmp_productosmenu_clave, cadena_conexion)
                    End If
                Next

                ' Añado al menu los nuevos productos
                For Each cantidad_id In value_items_insertar
                    tmp_itemconsumicion_clave.id = cantidad_id.Split("x").GetValue(1)
                    tmp_producto_clave.id = get_producto_FKItemConsumicion(tmp_itemconsumicion_clave, cadena_conexion).id

                    tmp_productosmenu_reg.FK_menu = tmp_menu_clave.id
                    tmp_productosmenu_reg.FK_producto = tmp_producto_clave.id
                    tmp_productosmenu_reg.cantidad = cantidad_id.Split("x").GetValue(0)
                    If Not existe_productosmenu(tmp_productosmenu_reg, cadena_conexion) Then
                        ret_ok = insertar_productosmenu(tmp_productosmenu_reg, cadena_conexion)
                    End If
                Next

            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok

    End Function

    Protected Function LlenarComboBox() As Boolean
        Dim ret_ok As Boolean = True
        Dim tmp_tiposproducto_reg As New List(Of tipoproducto_reg)
        Dim item As New ListItem

        Try
            ' Limpio el listbox
            Me.TiposProductoComboBox.Items.Clear()

            ' Recuperacion de los tipos de producto que hay
            tmp_tiposproducto_reg = get_todos_tipoproducto(cadena_conexion)

            If Not tmp_tiposproducto_reg Is Nothing Then
                ' Se rellena la tabla.
                For i = 0 To tmp_tiposproducto_reg.Count - 1
                    item = New ListItem(tmp_tiposproducto_reg(i).nombre, tmp_tiposproducto_reg(i).id)
                    Me.TiposProductoComboBox.Items.Add(item)
                Next i
            Else
                ret_ok = False
            End If

            Me.TiposProductoComboBox.Items.Add(New ListItem("Otros", -1))

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function LlenarListBoxProductos() As Boolean
        Dim ret_ok As Boolean = True
        Dim lista_productos As New List(Of itemconsumicion_reg)
        Dim tmp_itemconsumicion_clave As New itemconsumicion_clave
        Dim tmp_tipoproducto_clave As tipoproducto_clave
        Dim item As New ListItem

        Try
            ' Limpio el listbox
            Me.ProductosListBox.Items.Clear()

            ' Recuperacion de todos los productos que son del tipo de producto seleccionado
            tmp_itemconsumicion_clave.id = menu
            tmp_tipoproducto_clave.id = Me.TiposProductoComboBox.SelectedValue
            If tmp_tipoproducto_clave.id <> -1 Then
                lista_productos = get_itemconsumiciones_tipo(tmp_tipoproducto_clave, False, cadena_conexion)
            Else
                lista_productos = get_itemconsumiciones_tipo(tmp_tipoproducto_clave, True, cadena_conexion)
            End If


            If Not lista_productos Is Nothing Then
                If lista_productos.Count <> 0 Then
                    ' Se rellena la tabla.
                    For i = 0 To lista_productos.Count - 1
                        If Not ExisteItemConsumicionMenu(lista_productos(i).id) Then
                            item = New ListItem(lista_productos(i).nombre, lista_productos(i).id)
                            Me.ProductosListBox.Items.Add(item)
                        End If
                    Next i
                End If
            Else
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function ExisteItemConsumicionMenu(ByVal itemconsumicion As Integer) As Boolean

        For Each item In Me.ProductosMenuListBox.Items
            If itemconsumicion = CType(item, ListItem).Value Then
                Return True
            End If
        Next

        Return False
    End Function

    Protected Function LlenarListBoxProductosDeMenu() As Boolean
        Dim ret_ok As Boolean = True
        Dim lista_productosmenu As New List(Of productosmenu_reg)
        Dim tmp_menu_clave As New menu_clave
        Dim item As New ListItem
        Dim tmp_itemconsumicion_reg As itemconsumicion_reg
        Dim tmp_itemconsumicion_clave As itemconsumicion_clave
        Dim tmp_producto_clave As producto_clave

        Try
            ' Limpio el listbox
            Me.ProductosMenuListBox.Items.Clear()

            ' Limpio la lista de productos del menu
            lista_productos_orig.Clear()

            ' Recuperacion de los productos de un menu determinado
            tmp_menu_clave.id = menu
            lista_productosmenu = get_productosmenu_FKMenu(tmp_menu_clave, cadena_conexion)

            If Not lista_productosmenu Is Nothing Then
                If lista_productosmenu.Count <> 0 Then
                    ' Se rellena la tabla.
                    For i = 0 To lista_productosmenu.Count - 1
                        tmp_producto_clave.id = lista_productosmenu(i).FK_producto
                        tmp_itemconsumicion_clave.id = get_producto(tmp_producto_clave, cadena_conexion).FK_itemconsumicion
                        tmp_itemconsumicion_reg = get_itemconsumicion(tmp_itemconsumicion_clave, cadena_conexion)
                        lista_productos_orig.Add(lista_productosmenu(i).cantidad & " x " & tmp_itemconsumicion_reg.id)
                        item = New ListItem(lista_productosmenu(i).cantidad & " x " & tmp_itemconsumicion_reg.nombre, tmp_itemconsumicion_reg.id)
                        Me.ProductosMenuListBox.Items.Add(item)
                    Next i
                End If
            Else
                ret_ok = False
            End If

        Catch ex As Exception
            ret_ok = True
        End Try

        Return ret_ok
    End Function

    Protected Function ActualizarDatos() As Boolean
        Dim ret_ok As Boolean

        Try
            ret_ok = LlenarComboBox()
            Me.TiposProductoComboBox.DataBind()

            If ret_ok Then
                If op.CompareTo("Nuevo") <> 0 Then
                    ret_ok = LlenarListBoxProductosDeMenu()
                Else
                    Me.ProductosMenuListBox.Items.Clear()
                End If
                Me.ProductosMenuListBox.DataBind()

                If ret_ok Then
                    ret_ok = LlenarListBoxProductos()
                    Me.ProductosListBox.DataBind()
                End If
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function ActualizarListBoxProductos() As Boolean
        Dim ret_ok As Boolean = True

        Try
            ret_ok = LlenarListBoxProductos()
            Me.ProductosListBox.DataBind()
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function GetItemsSeleccionados(ByVal ListBox As ListBox) As List(Of ListItem)
        Dim i As Integer
        Dim lista As New List(Of ListItem)

        For i = 0 To ListBox.Items.Count - 1
            If ListBox.Items(i).Selected Then
                lista.Add(ListBox.Items(i))
            End If
        Next i

        Return lista
    End Function

    Protected Function GetCantidadValueItems(ByVal lista_items As ListItemCollection) As List(Of String)
        Dim value_items As New List(Of String)
        Dim cantidad As Integer = -1

        For Each item In lista_items
            cantidad = (CType(item, ListItem)).Text.Split("x").GetValue(0)
            value_items.Add(cantidad & " x " & (CType(item, ListItem)).Value)
        Next

        Return value_items
    End Function

    Protected Function GetIdProductos(ByVal lista As List(Of itemconsumicion_reg)) As List(Of Integer)
        Dim id_productos_orig As New List(Of Integer)

        For Each item In lista
            id_productos_orig.Add(item.id)
        Next

        Return id_productos_orig
    End Function

    Protected Sub TiposProductoComboBox_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TiposProductoComboBox.SelectedIndexChanged
        If ActualizarListBoxProductos() Then
            Me.MsgEstadoPanel.Visible = False
        Else
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.Text = Error_EM
            Me.MsgEstadoImage.ImageUrl = icono_error
        End If
    End Sub

    Protected Sub GuardarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GuardarButton.Click
        Dim ret_ok As Boolean = True

        ret_ok = GuardarDatos()

        ' Muestro un mensaje de estado
        If ret_ok Then
            Me.MsgEstadoLbl.Text = "Men&uacute; guardado correctamente"
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "verde"
            Me.MsgEstadoImage.ImageUrl = icono_ok
        Else
            Me.MsgEstadoLbl.Text = "Ha habido un problema al guardar el men&uacute;"
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "marron"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End If
    End Sub

    Protected Sub CancelarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelarButton.Click
        Response.Redirect("Menus.aspx")
    End Sub

    Protected Sub AddButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddButton.Click
        Dim lista As New List(Of ListItem)

        ' Elimino el mensaje de estado ( si lo hubiera ) 
        Me.MsgEstadoPanel.Visible = False

        ' Obtengo los productos seleccionados
        lista = GetItemsSeleccionados(Me.ProductosListBox)

        ' Los borro de la lista de productos
        For Each item In lista
            Me.ProductosListBox.Items.Remove(item)
        Next

        ' Los añado a la lista de productos que tienen como tipo de producto el administrado
        For Each item In lista
            Me.ProductosMenuListBox.Items.Add(New ListItem(Me.CantidadTxt.Text & " x " & item.Text, item.Value))
        Next
        Me.ProductosMenuListBox.DataBind()
    End Sub

    Protected Sub DelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DelButton.Click
        Dim lista As New List(Of ListItem)
        Dim tmp_itemconsumicion_clave As itemconsumicion_clave

        ' Elimino el mensaje de estado ( si lo hubiera ) 
        Me.MsgEstadoPanel.Visible = False

        ' Obtengo los productos seleccionados
        lista = GetItemsSeleccionados(Me.ProductosMenuListBox)

        ' Los borro de la lista de productos que son del tipo administrado
        For Each item In lista
            Me.ProductosMenuListBox.Items.Remove(item)
        Next

        ' Los añado a la lista de productos general si son de la categoria de productos que se esta mostrando
        For Each item In lista
            tmp_itemconsumicion_clave.id = item.Value
            If get_producto_FKItemConsumicion(tmp_itemconsumicion_clave, cadena_conexion).FK_tipoproducto = Me.TiposProductoComboBox.SelectedValue Then
                Me.ProductosListBox.Items.Add(New ListItem(item.Text.Split("x").GetValue(1), item.Value))
            End If
        Next

        Me.ProductosListBox.DataBind()
    End Sub

    Protected Sub LimpiarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles LimpiarButton.Click
        InicializarDatos()
    End Sub

End Class
