﻿Imports accesoBDeRestaurante.producto_bd
Imports accesoBDeRestaurante.tipoproducto_bd
Imports accesoBDeRestaurante.itemconsumicion_bd
Imports variables_globales

Partial Class gerente_DetallesProducto
    Inherits System.Web.UI.Page

    Shared itemconsumicion As Integer
    Shared op As String
    Protected Shared camino As String
    Shared lista_productos_orig As List(Of itemconsumicion_reg)


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ret_ok As Boolean = True

        ' Carga de los datos sólo una vez, cuando la página carga
        If Not IsPostBack Then

            ' Recupero los parametros
            op = Trim(Request.Params("op"))
            Try
                itemconsumicion = Request.Params("itemconsumicion")
            Catch ex As Exception
                itemconsumicion = -1
            End Try

            camino = Trim(Request.Params("nav"))

            If op.CompareTo("") = 0 Then
                Me.DetallesProductoLbl.Text = "Gestionar"
            Else
                Me.DetallesProductoLbl.Text = op
            End If

            InicializarDatos()

            If ActualizarDatos() Then
                Me.MsgEstadoPanel.Visible = False
            Else
                Me.MsgEstadoPanel.Visible = True
                Me.MsgEstadoLbl.Text = "Error al mostrar los tipos de producto"
                Me.MsgEstadoImage.ImageUrl = icono_error
            End If

            Me.CaminoLbl.Text = camino & ">Detalles Producto"
            Select Case op
                Case "Nuevo"
                    EstadoDatos(False, False)
                    Me.CaminoLbl.Text = camino
                Case "Modificar"
                    EstadoDatos(True, False)
                    ret_ok = MostrarDatos()
                Case "Detalles"
                    EstadoDatos(True, True)
                    ret_ok = MostrarDatos()
            End Select

            If Not ret_ok Then
                Me.MsgEstadoLbl.Text = "Error al mostrar los datos"
                Me.MsgEstadoPanel.Visible = True
                Me.MsgEstadoImage.ImageUrl = icono_error
            End If
        End If
    End Sub

    Private Sub InicializarDatos()
        Me.NombreTxt.Text = ""
        Me.DescripcionTxt.Text = ""
        Me.PrecioTxt.Text = 0
        Try
            Me.TiposProductoComboBox.SelectedIndex = 0
        Catch ex As Exception
            Me.TiposProductoComboBox.SelectedIndex = -1
        End Try
        Me.MsgEstadoPanel.Visible = False
    End Sub

    Private Sub EstadoDatos(ByVal valor As Boolean, ByVal modo_ro As Boolean)
        Me.IdTxt.Enabled = False
        Me.IdLbl.Visible = valor
        Me.IdTxt.Visible = valor
        Me.LimpiarButton.Visible = Not valor

        If (modo_ro) Then
            Me.NombreTxt.Enabled = False
            Me.DescripcionTxt.Enabled = False
            Me.TiposProductoComboBox.Enabled = False
            Me.PrecioTxt.Enabled = False
            Me.GuardarButton.Visible = False
            Me.CancelarButton.Text = "Volver"
        End If
    End Sub

    Protected Function LlenarComboBox() As Boolean
        Dim ret_ok As Boolean = True
        Dim tmp_tiposproducto_reg As New List(Of tipoproducto_reg)
        Dim item As New ListItem

        ' Limpio el listbox
        Me.TiposProductoComboBox.Items.Clear()

        ' Recuperacion de los tipos de producto que hay
        tmp_tiposproducto_reg = get_todos_tipoproducto(cadena_conexion)

        If Not tmp_tiposproducto_reg Is Nothing Then
            ' Se rellena la tabla.
            For i = 0 To tmp_tiposproducto_reg.Count - 1
                item = New ListItem(tmp_tiposproducto_reg(i).nombre, tmp_tiposproducto_reg(i).id)
                Me.TiposProductoComboBox.Items.Add(item)
            Next i
        Else
            ret_ok = False
        End If

        Me.TiposProductoComboBox.Items.Add(New ListItem("Otros", -1))

        Return ret_ok
    End Function

    Protected Function ActualizarDatos() As Boolean
        Dim ret_ok As Boolean

        ret_ok = LlenarComboBox()
        Me.TiposProductoComboBox.DataBind()

        Return ret_ok
    End Function

    Private Function MostrarDatos() As Boolean
        Dim tmp_itemconsumicion_clave As New itemconsumicion_clave
        Dim tmp_itemconsumicion_reg As New itemconsumicion_reg
        Dim tmp_producto_reg As New producto_reg
        Dim ret_ok As Boolean = True

        Try
            If (itemconsumicion <> -1) Then
                tmp_itemconsumicion_clave.id = itemconsumicion
                tmp_itemconsumicion_reg = get_itemconsumicion(tmp_itemconsumicion_clave, cadena_conexion)

                If Not es_error_itemconsumicion(tmp_itemconsumicion_reg) Then
                    Me.IdTxt.Text = tmp_itemconsumicion_reg.id
                    Me.TiposProductoComboBox.Text = tmp_itemconsumicion_reg.tipo
                    Me.NombreTxt.Text = tmp_itemconsumicion_reg.nombre
                    Me.DescripcionTxt.Text = tmp_itemconsumicion_reg.descripcion
                    Me.PrecioTxt.Text = tmp_itemconsumicion_reg.precio
                    tmp_producto_reg = get_producto_FKItemConsumicion(tmp_itemconsumicion_clave, cadena_conexion)
                    Me.TiposProductoComboBox.SelectedValue = tmp_producto_reg.FK_tipoproducto
                Else
                    ret_ok = False
                End If
            Else
                ret_ok = False
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function GuardarDatos() As Boolean
        Dim tmp_itemconsumicion_reg As itemconsumicion_reg
        Dim ret_ok As Boolean = True

        Try
            ' Recupero los datos
            tmp_itemconsumicion_reg.nombre = Trim(Me.NombreTxt.Text)
            tmp_itemconsumicion_reg.tipo = "P"
            tmp_itemconsumicion_reg.descripcion = Trim(Me.DescripcionTxt.Text)
            Try
                tmp_itemconsumicion_reg.precio = CDec(Double.Parse(Me.PrecioTxt.Text))
            Catch ex As Exception
                tmp_itemconsumicion_reg.precio = 0
            End Try

            ' Actualizo o inserto un registro
            Select Case op
                Case "Nuevo"
                    ret_ok = NuevoProducto(tmp_itemconsumicion_reg)
                Case "Modificar"
                    ret_ok = ModificarProducto(tmp_itemconsumicion_reg)
                Case Else
                    ret_ok = False
            End Select
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function NuevoProducto(ByVal tmp_itemconsumicion_reg As itemconsumicion_reg) As Boolean
        Dim ret_ok As Boolean = True
        Dim tmp_producto_reg As producto_reg

        Try
            tmp_producto_reg.FK_tipoproducto = Me.TiposProductoComboBox.SelectedValue
            tmp_producto_reg.FK_itemconsumicion = insertar_itemconsumicion(tmp_itemconsumicion_reg, cadena_conexion).id

            If tmp_producto_reg.id <> -1 Then
                ret_ok = insertar_producto(tmp_producto_reg, cadena_conexion)
            Else
                ret_ok = False
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function ModificarProducto(ByVal tmp_itemconsumicion_reg As itemconsumicion_reg) As Boolean
        Dim ret_ok As Boolean = True
        Dim tmp_producto_reg As producto_reg
        Dim tmp_itemconsumicion_clave As itemconsumicion_clave

        Try
            tmp_itemconsumicion_reg.id = itemconsumicion
            ret_ok = actualizar_itemconsumicion(tmp_itemconsumicion_reg, cadena_conexion)
            If ret_ok Then
                tmp_itemconsumicion_clave.id = tmp_itemconsumicion_reg.id
                tmp_producto_reg = get_producto_FKItemConsumicion(tmp_itemconsumicion_clave, cadena_conexion)
                tmp_producto_reg.FK_tipoproducto = Me.TiposProductoComboBox.SelectedValue
                ret_ok = actualizar_producto(tmp_producto_reg, cadena_conexion)
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function


    Protected Sub GuardarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GuardarButton.Click
        Dim ret_ok As Boolean

        ret_ok = GuardarDatos()

        ' Muestro un mensaje de estado
        Me.MsgEstadoPanel.Visible = True

        If ret_ok Then

            Me.MsgEstadoLbl.Text = "Producto guardado correctamente"
            Me.MsgEstadoLbl.CssClass = "verde"
            Me.MsgEstadoImage.ImageUrl = icono_ok
        Else
            Me.MsgEstadoLbl.Text = "Ha habido un problema al guardar el producto"
            Me.MsgEstadoLbl.CssClass = "marron"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End If
    End Sub

    Protected Sub CancelarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelarButton.Click
        Response.Redirect("Productos.aspx")
    End Sub

    Protected Sub LimpiarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles LimpiarButton.Click
        InicializarDatos()
    End Sub
End Class
