﻿Imports accesoBDeRestaurante.producto_bd
Imports accesoBDeRestaurante.tipoproducto_bd
Imports accesoBDeRestaurante.itemconsumicion_bd
Imports variables_globales

Partial Class gerente_DetallesTiposProducto
    Inherits System.Web.UI.Page

    Protected Shared tipo As String
    Protected Shared op As String
    Protected Shared camino As String
    Protected Shared lista_productos_orig As List(Of itemconsumicion_reg)


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' Carga de los datos sólo una vez, cuando la página carga
        If Not IsPostBack Then

            ' Recupero los parametros
            op = Trim(Request.Params("op"))
            tipo = Trim(Request.Params("tipo"))
            camino = Trim(Request.Params("nav"))

            If op.CompareTo("") = 0 Then
                Me.GestionarTipoProductoLbl.Text = "Gestionar"
            Else
                Me.GestionarTipoProductoLbl.Text = op
            End If

            InicializarDatos()

            Me.CaminoLbl.Text = camino & ">Detalles Producto"
            Select Case op
                Case "Nuevo"
                    EstadoDatos(False, False)
                    Me.CaminoLbl.Text = camino
                Case "Modificar"
                    EstadoDatos(True, False)
                    MostrarDatos()
                Case "Detalles"
                    EstadoDatos(True, True)
                    MostrarDatos()
            End Select
        End If
    End Sub

    Public Sub InicializarDatos()
        Me.NombreTxt.Text = ""
        Me.MsgEstadoPanel.Visible = False
    End Sub

    Private Sub EstadoDatos(ByVal valor As Boolean, ByVal modo_ro As Boolean)
        Me.IdTxt.Enabled = False
        Me.IdLbl.Visible = valor
        Me.IdTxt.Visible = valor
        Me.ElegirProductosPanel.Visible = valor
        Me.LimpiarButton.Visible = Not valor

        If (modo_ro) Then
            Me.NombreTxt.Enabled = False
            Me.AddButton.Enabled = False
            Me.DelButton.Enabled = False
            Me.GuardarButton.Visible = False
            Me.CancelarButton.Text = "Volver"
        End If
    End Sub

    Private Sub MostrarDatos()
        Dim tmp_tipoproducto_clave As New tipoproducto_clave
        Dim tmp_tipoproducto_reg As New tipoproducto_reg

        If (tipo <> "") Then
            tmp_tipoproducto_clave.id = tipo
            tmp_tipoproducto_reg = get_tipoproducto(tmp_tipoproducto_clave, cadena_conexion)

            If Not es_error_tipoproducto(tmp_tipoproducto_reg) Then
                Me.IdTxt.Text = tmp_tipoproducto_reg.id
                Me.NombreTxt.Text = tmp_tipoproducto_reg.nombre
            End If
        End If

        ActualizarDatos()
    End Sub

    Protected Function LlenarListBoxProductos() As Boolean
        Dim ret_ok As Boolean = True
        Dim lista_productos As New List(Of itemconsumicion_reg)
        Dim tmp_tipoproducto_clave As New tipoproducto_clave
        Dim item As New ListItem

        ' Limpio el listbox
        Me.ProductosListBox.Items.Clear()

        ' Recuperacion de todos los productos que no son del tipo en que estamos administrando
        tmp_tipoproducto_clave.id = tipo
        lista_productos = get_itemconsumiciones_dif_tipo(tmp_tipoproducto_clave, cadena_conexion)

        If Not lista_productos Is Nothing Then
            If lista_productos.Count <> 0 Then
                ' Se rellena la tabla.
                For i = 0 To lista_productos.Count - 1
                    item = New ListItem(lista_productos(i).nombre, lista_productos(i).id)
                    Me.ProductosListBox.Items.Add(item)
                Next i
            Else
                ret_ok = False
            End If
        Else
            ret_ok = False
        End If

        Return ret_ok
    End Function

    Protected Function LlenarListBoxProductosDeTipo() As Boolean
        Dim ret_ok As Boolean = True
        Dim lista_productos As New List(Of itemconsumicion_reg)
        Dim tmp_tipoproducto_clave As New tipoproducto_clave
        Dim item As New ListItem

        ' Limpio el listbox
        Me.ProductosTipoListBox.Items.Clear()

        ' Recuperacion de los productos de un tipo determinado
        tmp_tipoproducto_clave.id = tipo
        lista_productos = get_itemconsumiciones_tipo(tmp_tipoproducto_clave, False, cadena_conexion)
        lista_productos_orig = lista_productos

        If Not lista_productos Is Nothing Then
            If lista_productos.Count <> 0 Then
                ' Se rellena la tabla.
                For i = 0 To lista_productos.Count - 1
                    item = New ListItem(lista_productos(i).nombre, lista_productos(i).id)
                    Me.ProductosTipoListBox.Items.Add(item)
                Next i
            Else
                ret_ok = False
            End If
        Else
            ret_ok = False
        End If

        Return ret_ok
    End Function

    Protected Function ActualizarDatos() As Boolean
        Dim ret_ok As Boolean
        Dim ret_ok2 As Boolean

        ret_ok = LlenarListBoxProductos()
        ret_ok2 = LlenarListBoxProductosDeTipo()
        Me.ProductosListBox.DataBind()
        Me.ProductosTipoListBox.DataBind()

        Return (ret_ok AndAlso ret_ok2)
    End Function

    Protected Function GetItemsSeleccionados(ByVal ListBox As ListBox) As List(Of ListItem)
        Dim i As Integer
        Dim lista As New List(Of ListItem)

        For i = 0 To ListBox.Items.Count - 1
            If ListBox.Items(i).Selected Then
                lista.Add(ListBox.Items(i))
            End If
        Next i

        Return lista
    End Function

    Protected Function GetValueItems(ByVal lista_items As ListItemCollection) As List(Of Integer)
        Dim value_items As New List(Of Integer)

        For Each item In lista_items
            value_items.Add((CType(item, ListItem)).Value)
        Next

        Return value_items
    End Function

    Protected Function GetIdProductos(ByVal lista As List(Of itemconsumicion_reg)) As List(Of Integer)
        Dim id_productos_orig As New List(Of Integer)

        For Each item In lista
            id_productos_orig.Add(item.id)
        Next

        Return id_productos_orig
    End Function

    Protected Function ModificarTipoProducto(ByVal tmp_tipo_producto_reg As tipoproducto_reg) As Boolean
        Dim value_items As List(Of Integer)
        Dim value_items_orig As List(Of Integer)
        Dim dif_value_items As List(Of Integer)
        Dim ret_ok As Boolean = True
        Dim tmp_producto_reg As producto_reg
        Dim tmp_itemconsumicion_clave As itemconsumicion_clave

        tmp_tipo_producto_reg.id = tipo

        ' Obtengo los id de los productos del listbox que son del tipo de producto 
        ' que estamos modificando
        value_items = GetValueItems(Me.ProductosTipoListBox.Items)

        ' Hago lo mismo para obtener los id originales (los que estan en la bd)
        value_items_orig = GetIdProductos(lista_productos_orig)

        ' Obtengo los productos que han cambiado de tipo 
        dif_value_items = value_items.Except(value_items_orig.AsEnumerable).ToList
        dif_value_items.AddRange(value_items_orig.Except(value_items.AsEnumerable).ToList)

        ' A los productos nuevos les asigno el tipo actual y a los que ya no son del tipo actual
        ' les asigno tipo nulo
        For Each producto In dif_value_items
            tmp_itemconsumicion_clave.id = producto
            tmp_producto_reg = get_producto_FKItemConsumicion(tmp_itemconsumicion_clave, cadena_conexion)

            If value_items.Contains(producto) Then
                tmp_producto_reg.FK_tipoproducto = tipo
            Else
                tmp_producto_reg.FK_tipoproducto = -1
            End If

            ret_ok = actualizar_producto(tmp_producto_reg, cadena_conexion)
        Next

        If ret_ok Then
            ret_ok = actualizar_tipoproducto(tmp_tipo_producto_reg, cadena_conexion)
        End If

        Return ret_ok
    End Function

    Protected Sub GuardarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GuardarButton.Click
        Dim tmp_tipo_producto_reg As tipoproducto_reg
        Dim ret_ok As Boolean

        ' Recupero los datos y actualizo o inserto un registro
        tmp_tipo_producto_reg.nombre = Trim(Me.NombreTxt.Text)

        Select Case op
            Case "Nuevo"
                ret_ok = insertar_tipoproducto(tmp_tipo_producto_reg, cadena_conexion)
            Case "Modificar"
                ret_ok = ModificarTipoProducto(tmp_tipo_producto_reg)
        End Select

        ' Muestro un mensaje de estado
        If ret_ok Then
            Me.MsgEstadoLbl.Text = "Tipo de producto guardado correctamente"
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "verde"
            Me.MsgEstadoImage.ImageUrl = icono_ok
        Else
            Me.MsgEstadoLbl.Text = "Ha habido un problema al guardar el tipo de producto"
            Me.MsgEstadoPanel.Visible = True
            Me.MsgEstadoLbl.CssClass = "marron"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End If
    End Sub

    Protected Sub CancelarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelarButton.Click
        Response.Redirect("TiposProducto.aspx")
    End Sub

    Protected Sub AddButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddButton.Click
        Dim lista As New List(Of ListItem)

        ' Elimino el mensaje de estado ( si lo hubiera ) 
        Me.MsgEstadoLbl.Text = ""

        ' Obtengo los productos seleccionados
        lista = GetItemsSeleccionados(Me.ProductosListBox)
        ' Los borro de la lista de productos
        For Each item In lista
            Me.ProductosListBox.Items.Remove(item)
        Next
        ' Los añado a la lista de productos que tienen como tipo de producto el administrado
        Me.ProductosTipoListBox.Items.AddRange(lista.ToArray)
        Me.ProductosTipoListBox.DataBind()
    End Sub

    Protected Sub DelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DelButton.Click
        Dim lista As New List(Of ListItem)

        ' Elimino el mensaje de estado ( si lo hubiera ) 
        Me.MsgEstadoLbl.Text = ""

        ' Obtengo los productos seleccionados
        lista = GetItemsSeleccionados(Me.ProductosTipoListBox)

        ' Los borro de la lista de productos que son del tipo administrado
        For Each item In lista
            Me.ProductosTipoListBox.Items.Remove(item)
        Next

        ' Los añado a la lista de productos general
        Me.ProductosListBox.Items.AddRange(lista.ToArray)
        Me.ProductosListBox.DataBind()
    End Sub

    Protected Sub LimpiarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles LimpiarButton.Click
        InicializarDatos()
    End Sub
End Class
