﻿Imports accesoBDeRestaurante.camarero_bd
Imports variables_globales

Partial Class gerente_Empleados
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Carga de los datos sólo una vez, cuando la página carga
        If Not IsPostBack Then

            InicializarDatos()

            If ActualizarDatos() Then
                Me.MsgEstadoLbl.Visible = False
            Else
                Me.MsgEstadoLbl.Visible = True
            End If

        End If
    End Sub

    Protected Sub InicializarDatos()
        Me.MsgEstadoLbl.Text = "No hay empleados disponibles"
        Me.EmpleadosGridView.AutoGenerateColumns = False
        Me.MsgEstadoErrorPanel.Visible = False
    End Sub

    Protected Function ActualizarDatos() As Boolean
        Dim ret_ok As Boolean

        ret_ok = LlenarGridView()
        Me.EmpleadosGridView.DataBind()

        Return ret_ok
    End Function

    Protected Function LlenarGridView() As Boolean
        Dim ret_ok As Boolean = True
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand

        Try

            ' Recupero los empleados y los cargo en la rejilla
            comando = get_todos_camareros_strsql(cadena_conexion)

            MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
            MyDataSet.Clear()
            MyDataAdapter.Fill(MyDataSet)
            If MyDataSet.Tables(0).Rows.Count = 0 Then
                ret_ok = False
            Else
                Me.EmpleadosGridView.DataSource = MyDataSet.Tables(0)
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function EliminarFilas() As Boolean
        Dim tmp_camarero_clave As camarero_clave
        Dim lista_id_camareros As New List(Of Integer)
        Dim ret_ok As Boolean = True

        Try
            ' Recupero las filas seleccionadas
            For Each row As GridViewRow In Me.EmpleadosGridView.Rows
                Dim ch As CheckBox = CType(row.FindControl("SelectCheck"), CheckBox)
                If ch.Checked Then
                    tmp_camarero_clave.id = CInt(row.Cells(1).Text)
                    lista_id_camareros.Add(tmp_camarero_clave.id)
                End If
            Next

            If Not eliminar_varios_camareros(lista_id_camareros, cadena_conexion) Then
                Throw New Exception()
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function ObtenerPrimeraFilaSeleccionada() As Integer
        Dim result As Integer

        For Each row As GridViewRow In Me.EmpleadosGridView.Rows
            Dim ch As CheckBox = CType(row.FindControl("SelectCheck"), CheckBox)
            If ch.Checked Then
                result = CInt(row.Cells(1).Text)
                Return result
            End If
        Next

        Return -1
    End Function

    Protected Sub EmpleadosGridView_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles EmpleadosGridView.PageIndexChanging
        Me.EmpleadosGridView.PageIndex = e.NewPageIndex()
        InicializarDatos()
        If ActualizarDatos() Then
            Me.MsgEstadoLbl.Visible = False
        Else
            Me.MsgEstadoLbl.Visible = True
        End If

    End Sub

    Protected Sub NuevoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NuevoButton.Click
        Response.Redirect("DetallesEmpleado.aspx?op=Nuevo&nav=" & Trim(Me.CaminoLbl.Text))
    End Sub

    Protected Sub ModificarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ModificarButton.Click
        Dim camarero As Integer

        Try
            camarero = ObtenerPrimeraFilaSeleccionada()
            If (camarero <> -1) Then
                Response.Redirect("DetallesEmpleado.aspx?op=Modificar&empleado=" & camarero & "&nav=" & Trim(Me.CaminoLbl.Text))
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Me.MsgEstadoErrorPanel.Visible = True
            Me.MsgEstadoErrorLbl.Text = "Debe seleccionar un empleado para modificarlo."
        End Try
    End Sub

    Protected Sub EliminarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EliminarButton.Click
        If Not EliminarFilas() Then
            Me.MsgEstadoErrorPanel.Visible = True
            Me.MsgEstadoErrorLbl.Text = "Puede que no se haya eliminado correctamente alg&uacute;n empleado.<br />Seleccione uno y compruebe que no tiene pedidos asignados."
        Else
            Me.MsgEstadoErrorPanel.Visible = False
        End If
        If ActualizarDatos() Then
            Me.MsgEstadoLbl.Visible = False
        Else
            Me.MsgEstadoLbl.Visible = True
        End If
    End Sub

    Protected Sub DetallesButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DetallesButton.Click
        Dim camarero As Integer

        Try
            camarero = ObtenerPrimeraFilaSeleccionada()
            If (camarero <> -1) Then
                Response.Redirect("DetallesEmpleado.aspx?op=Detalles&empleado=" & camarero & "&nav=" & Trim(Me.CaminoLbl.Text))
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Me.MsgEstadoErrorPanel.Visible = True
            Me.MsgEstadoErrorLbl.Text = "Debe seleccionar un empleado para mostrar los detalles."
        End Try
    End Sub
End Class
