﻿Imports accesoBDeRestaurante.menu_bd
Imports variables_globales
Imports accesoBDeRestaurante.itemconsumicion_bd

Partial Class gerente_Menus
    Inherits System.Web.UI.Page

    Const Error_ND As String = "No hay men&uacute;s disponibles"
    Const Error_EE As String = "Se ha producido un error al intentar eliminar el men&uacute;"


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ret_ok As Boolean = True
        ' Carga de los datos sólo una vez, cuando la página carga
        If Not IsPostBack Then

            If ActualizarDatos() Then
                Me.MsgEstadoLbl.Visible = False
            Else
                Me.MsgEstadoLbl.Visible = True
                Me.MsgEstadoLbl.Text = Error_ND
            End If

        End If
    End Sub

    Protected Function ActualizarDatos() As Boolean
        Dim ret_ok As Boolean

        ret_ok = LlenarListBox()

        If ret_ok Then
            Me.MenusListBox.DataBind()
        End If

        Return ret_ok
    End Function

    Protected Function LlenarListBox() As Boolean
        Dim ret_ok As Boolean = True
        Dim lista_menus As New List(Of menu_reg)
        Dim tmp_itemconsumicion_clave As New itemconsumicion_clave
        Dim tmp_itemconsumicion_reg As New itemconsumicion_reg
        Dim item As New ListItem

        ' Limpio el listbox
        Me.MenusListBox.Items.Clear()

        ' Recuperacion de los menus que hay
        lista_menus = get_todos_menu(cadena_conexion)

        If Not lista_menus Is Nothing Then
            ' Se rellena la tabla.
            For i = 0 To lista_menus.Count - 1
                tmp_itemconsumicion_clave.id = lista_menus(i).FK_itemconsumicion
                If (tmp_itemconsumicion_clave.id <> -1) Then
                    tmp_itemconsumicion_reg = get_itemconsumicion(tmp_itemconsumicion_clave, cadena_conexion)
                    item = New ListItem(tmp_itemconsumicion_reg.nombre, tmp_itemconsumicion_reg.id)
                    Me.MenusListBox.Items.Add(item)
                End If
            Next i
        Else
            ret_ok = False
        End If

        Return ret_ok
    End Function

    Protected Function GetItemsValueSeleccionados() As List(Of Integer)
        Dim i As Integer
        Dim lista As New List(Of Integer)

        For i = 0 To Me.MenusListBox.Items.Count - 1
            If Me.MenusListBox.Items(i).Selected Then
                lista.Add(Me.MenusListBox.Items(i).Value)
            End If
        Next i

        Return lista
    End Function

    Protected Sub NuevoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NuevoButton.Click
        Response.Redirect("DetallesMenu.aspx?op=Nuevo&nav=" & Trim(Me.CaminoLbl.Text))
    End Sub

    Protected Sub EliminarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EliminarButton.Click
        Dim lista_items_sel As List(Of Integer)

        lista_items_sel = GetItemsValueSeleccionados()

        If (lista_items_sel.Count > 0) Then

            ' Elimino los menus seleccionados
            If eliminar_varios_itemsconsumicion(lista_items_sel, cadena_conexion) Then
                If Not ActualizarDatos() Then
                    Me.MsgEstadoLbl.Visible = True
                    Me.MsgEstadoLbl.Text = Error_ND
                End If
            Else
                Me.MsgEstadoErrorPanel.Visible = True
                Me.MsgEstadoErrorLbl.Text = Error_EE
            End If

        End If

    End Sub

    Protected Sub ModificarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ModificarButton.Click
        Dim tipo As Integer

        Try
            tipo = Me.MenusListBox.SelectedItem.Value
            Response.Redirect("DetallesMenu.aspx?op=Modificar&menu=" & tipo & "&nav=" & Trim(Me.CaminoLbl.Text))
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub DetallesButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DetallesButton.Click
        Dim tipo As Integer

        Try
            tipo = Me.MenusListBox.SelectedItem.Value
            Response.Redirect("DetallesMenu.aspx?op=Detalles&menu=" & tipo & "&nav=" & Trim(Me.CaminoLbl.Text))
        Catch ex As Exception

        End Try
    End Sub
End Class
