﻿Imports accesoBDeRestaurante.tipoproducto_bd
Imports variables_globales
Imports accesoBDeRestaurante.producto_bd
Imports accesoBDeRestaurante.itemconsumicion_bd

Partial Class gerente_Productos
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Carga de los datos sólo una vez, cuando la página carga
        If Not IsPostBack Then

            InicializarDatos()

            If ActualizarDatos() Then
                Me.MsgEstadoLbl.Visible = False
            Else
                Me.MsgEstadoLbl.Visible = True
            End If

        End If
    End Sub

    Protected Sub InicializarDatos()
        Me.MsgEstadoLbl.Text = "No hay productos disponibles para esa categor&iacute;a"
        Me.TiposProductoComboBox.AutoPostBack = True
        Me.ProductosGridView.AutoGenerateColumns = False
        Me.MsgEstadoErrorPanel.Visible = False
    End Sub

    Protected Function ActualizarDatos() As Boolean
        Dim ret_ok As Boolean

        ret_ok = LlenarComboBox()
        Me.TiposProductoComboBox.DataBind()
        If ret_ok Then
            ret_ok = ActualizarGridView()
        End If

        Return ret_ok
    End Function

    Protected Function ActualizarGridView() As Boolean
        Dim ret_ok As Boolean

        ret_ok = LlenarGridView()
        Me.ProductosGridView.DataBind()

        Return ret_ok
    End Function

    Protected Function LlenarComboBox() As Boolean
        Dim ret_ok As Boolean = True
        Dim tmp_tiposproducto_reg As New List(Of tipoproducto_reg)
        Dim item As New ListItem

        ' Limpio el listbox
        Me.TiposProductoComboBox.Items.Clear()

        ' Recuperacion de los tipos de producto que hay
        tmp_tiposproducto_reg = get_todos_tipoproducto(cadena_conexion)

        If Not tmp_tiposproducto_reg Is Nothing Then
            ' Se rellena la tabla.
            For i = 0 To tmp_tiposproducto_reg.Count - 1
                item = New ListItem(tmp_tiposproducto_reg(i).nombre, tmp_tiposproducto_reg(i).id)
                Me.TiposProductoComboBox.Items.Add(item)
            Next i
        Else
            ret_ok = False
        End If

        Me.TiposProductoComboBox.Items.Add(New ListItem("Otros", -1))

        Return ret_ok
    End Function

    Protected Function LlenarGridView() As Boolean
        Dim ret_ok As Boolean = True
        Dim tmp_producto_reg As New List(Of producto_reg)
        Dim MyDataAdapter As MySql.Data.MySqlClient.MySqlDataAdapter
        Dim MyDataSet As New Data.DataSet
        Dim comando As MySql.Data.MySqlClient.MySqlCommand
        Dim tmp_tipoproducto_clave As tipoproducto_clave

        Try
            ' Obtengo el tipo de producto seleccionado en el combobox
            tmp_tipoproducto_clave.id = Me.TiposProductoComboBox.SelectedValue

            ' Recupero los productos que son de ese tipo y los cargo en la rejilla
            comando = get_itemconsumiciones_tipo_strsql(tmp_tipoproducto_clave, cadena_conexion)

            MyDataAdapter = New MySql.Data.MySqlClient.MySqlDataAdapter(comando)
            MyDataSet.Clear()
            MyDataAdapter.Fill(MyDataSet)
            If MyDataSet.Tables(0).Rows.Count = 0 Then
                ret_ok = False
            Else
                Me.ProductosGridView.DataSource = MyDataSet.Tables(0)
            End If
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Function ObtenerPrimeraFilaSeleccionada() As Integer
        Dim result As Integer

        For Each row As GridViewRow In Me.ProductosGridView.Rows
            Dim ch As CheckBox = CType(row.FindControl("SelectCheck"), CheckBox)
            If ch.Checked Then
                result = CInt(row.Cells(1).Text)
                Return result
            End If
        Next

        Return -1
    End Function

    Protected Function EliminarFilas() As Boolean
        Dim tmp_itemconsumicion_clave As itemconsumicion_clave
        Dim lista_id_itemconsumicion As New List(Of Integer)
        Dim ret_ok As Boolean = True
        Dim selected_indices_tmp As New List(Of Integer)

        Try
            ' Recupero las filas seleccionadas
            For Each row As GridViewRow In Me.ProductosGridView.Rows
                Dim ch As CheckBox = CType(row.FindControl("SelectCheck"), CheckBox)
                If ch.Checked Then
                    tmp_itemconsumicion_clave.id = CInt(row.Cells(1).Text)
                    lista_id_itemconsumicion.Add(tmp_itemconsumicion_clave.id)
                End If
            Next

            If Not eliminar_varios_itemsconsumicion(lista_id_itemconsumicion, cadena_conexion) Then
                Throw New Exception()
            End If

        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Sub TiposProductoComboBox_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TiposProductoComboBox.SelectedIndexChanged
        InicializarDatos()
        If ActualizarGridView() Then
            Me.MsgEstadoLbl.Visible = False
        Else
            Me.MsgEstadoLbl.Visible = True
        End If
    End Sub

    Protected Sub ProductosGridView_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles ProductosGridView.PageIndexChanging
        Me.ProductosGridView.PageIndex = e.NewPageIndex()
        InicializarDatos()
        If ActualizarDatos() Then
            Me.MsgEstadoLbl.Visible = False
        Else
            Me.MsgEstadoLbl.Visible = True
        End If
    End Sub

    Protected Sub NuevoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NuevoButton.Click
        Response.Redirect("DetallesProducto.aspx?op=Nuevo&nav=" & Trim(Me.CaminoLbl.Text))
    End Sub

    Protected Sub ModificarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ModificarButton.Click
        Dim itemconsumicion As Integer

        Try
            itemconsumicion = ObtenerPrimeraFilaSeleccionada()
            If (itemconsumicion <> -1) Then
                Response.Redirect("DetallesProducto.aspx?op=Modificar&itemconsumicion=" & itemconsumicion & "&nav=" & Trim(Me.CaminoLbl.Text))
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Me.MsgEstadoErrorPanel.Visible = True
            Me.MsgEstadoErrorLbl.Text = "Debe seleccionar un producto para modificarlo."
        End Try
    End Sub

    Protected Sub EliminarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EliminarButton.Click
        If Not EliminarFilas() Then
            Me.MsgEstadoErrorPanel.Visible = True
            Me.MsgEstadoErrorLbl.Text = "Puede que no se haya eliminado correctamente alg&uacute;n producto, revise que no esté asignado a ningún pedido."
        End If
        If ActualizarGridView() Then
            Me.MsgEstadoLbl.Visible = False
        Else
            Me.MsgEstadoLbl.Visible = True
        End If
    End Sub

    Protected Sub DetallesButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DetallesButton.Click
        Dim itemconsumicion As Integer

        Try
            itemconsumicion = ObtenerPrimeraFilaSeleccionada()
            If (itemconsumicion <> -1) Then
                Response.Redirect("DetallesProducto.aspx?op=Detalles&itemconsumicion=" & itemconsumicion & "&nav=" & Me.CaminoLbl.Text)
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Me.MsgEstadoErrorPanel.Visible = True
            Me.MsgEstadoErrorLbl.Text = "Debe seleccionar un producto para ver sus detalles."
        End Try
    End Sub
End Class
