﻿Imports System.Data
Imports accesoBDeRestaurante.tipoproducto_bd
Imports accesoBDeRestaurante.producto_bd
Imports accesoBDeRestaurante.itemconsumicion_bd
Imports variables_globales

Partial Class gerente_TiposProducto
    Inherits System.Web.UI.Page

    Const Error_ND As String = "No hay tipos de producto disponibles"
    Const Error_EE As String = "Se ha producido un error al intentar eliminar el tipo de producto"


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ret_ok As Boolean = True
        ' Carga de los datos sólo una vez, cuando la página carga
        If Not IsPostBack Then

            If ActualizarDatos() Then
                Me.MsgEstadoLbl.Visible = False
            Else
                Me.MsgEstadoLbl.Visible = True
                Me.MsgEstadoLbl.Text = Error_ND
            End If

        End If
    End Sub

    Protected Function ActualizarDatos() As Boolean
        Dim ret_ok As Boolean

        ret_ok = LlenarListBox()

        If ret_ok Then
            Me.TiposProductoListBox.DataBind()
        End If

        Return ret_ok
    End Function

    Protected Function LlenarListBox() As Boolean
        Dim ret_ok As Boolean = True
        Dim tmp_tiposproducto_reg As New List(Of tipoproducto_reg)
        Dim item As New ListItem

        ' Limpio el listbox
        Me.TiposProductoListBox.Items.Clear()

        ' Recuperacion de los tipos de producto que hay
        tmp_tiposproducto_reg = get_todos_tipoproducto(cadena_conexion)

        If Not tmp_tiposproducto_reg Is Nothing Then
            ' Se rellena la tabla.
            For i = 0 To tmp_tiposproducto_reg.Count - 1
                item = New ListItem(tmp_tiposproducto_reg(i).nombre, tmp_tiposproducto_reg(i).id)
                Me.TiposProductoListBox.Items.Add(item)
            Next i
        Else
            ret_ok = False
        End If

        Return ret_ok
    End Function

    Protected Function GetItemsValueSeleccionados() As List(Of Integer)
        Dim i As Integer
        Dim lista As New List(Of Integer)

        For i = 0 To Me.TiposProductoListBox.Items.Count - 1
            If Me.TiposProductoListBox.Items(i).Selected Then
                lista.Add(Me.TiposProductoListBox.Items(i).Value)
            End If
        Next i

        Return lista
    End Function

    Protected Function CambiarFKProductoANull(ByVal lista As List(Of Integer)) As Boolean
        Dim ret_ok As Boolean = True
        Dim tmp_tipoproducto_clave As tipoproducto_clave

        ' Actualizo la referencia al tipo de producto a NULL atodos los productos que sean de uno de los 
        ' tipos de producto a eliminar 
        Try
            For Each item In lista
                tmp_tipoproducto_clave.id = item

                For Each producto In get_productos_tipo(tmp_tipoproducto_clave, cadena_conexion)
                    producto.FK_tipoproducto = -1
                    ret_ok = actualizar_producto(producto, cadena_conexion)
                Next
            Next
        Catch ex As Exception
            ret_ok = False
        End Try

        Return ret_ok
    End Function

    Protected Sub NuevoButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NuevoButton.Click
        Response.Redirect("DetallesTiposProducto.aspx?op=Nuevo&nav=" & Trim(Me.CaminoLbl.Text))
    End Sub

    Protected Sub EliminarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EliminarButton.Click
        Dim lista_items_sel As List(Of Integer)

        lista_items_sel = GetItemsValueSeleccionados()

        If (lista_items_sel.Count > 0) Then

            ' Actualizo la clave ajena de cada producto que sea de uno de los tipos de producto eliminados a NULL
            If CambiarFKProductoANull(lista_items_sel) Then

                ' Elimino los tipos de producto seleccionados
                If eliminar_varios_tipoproducto(lista_items_sel, cadena_conexion) Then
                    If Not ActualizarDatos() Then
                        Me.MsgEstadoLbl.Visible = True
                        Me.MsgEstadoLbl.Text = Error_ND
                    End If
                Else
                    Me.MsgEstadoLbl.Visible = True
                    Me.MsgEstadoLbl.Text = Error_EE
                End If

            End If

        End If
    End Sub

    Protected Sub ModificarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ModificarButton.Click
        Dim tipo As Integer

        Try
            tipo = Me.TiposProductoListBox.SelectedItem.Value
            Response.Redirect("DetallesTiposProducto.aspx?op=Modificar&tipo=" & tipo & "&nav=" & Trim(Me.CaminoLbl.Text))
        Catch ex As Exception

        End Try
    End Sub

    Protected Sub DetallesButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DetallesButton.Click
        Dim tipo As Integer

        Try
            tipo = Me.TiposProductoListBox.SelectedItem.Value
            Response.Redirect("DetallesTiposProducto.aspx?op=Detalles&tipo=" & tipo & "&nav=" & Trim(Me.CaminoLbl.Text))
        Catch ex As Exception

        End Try
    End Sub
End Class
