﻿Imports accesoBDeRestaurante.comentario_bd
Imports variables_globales
Imports funciones_generales

Partial Class secciones_Contacto
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ret_ok As Boolean = True

        Try
            ' Carga de los datos sólo una vez, cuando la página carga
            If Not IsPostBack Then
                InicializarDatos()
            End If

        Catch ex As Exception
            MsgEstadoLbl.Text = "Ha habido un problema al mostrar el formulario de contacto."
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub

    Protected Sub InicializarDatos()
        Me.DesdeTxt.Text = ""
        Me.AsuntoTxt.Text = ""
        Me.ComentarioTxt.Text = ""
    End Sub

    Protected Sub EstadoDatos(ByVal est As Boolean)
        Me.ComentarioEnviadoPanel.Visible = Not est
        Me.MsgEstadoPanel.Visible = False
        Me.InformacionPanel.Visible = est
        Me.DatosComentarioPanel.Visible = est
        Me.EnviarButton.Visible = est
        Me.MsgEstadoPanel.Visible = est
    End Sub

    Protected Function ValidarDatos(ByVal d As String, ByVal a As String, ByVal c As String) As Boolean
        Dim ret_ok As Boolean = False

        If validar_email(d) Then
            If Not Trim(a).Equals("") Then
                If Not Trim(c).Equals("") Then
                    ret_ok = True
                End If
            End If
        End If

        Return ret_ok
    End Function

    Protected Sub EnviarButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles EnviarButton.Click
        Dim desde As String = ""
        Dim asunto As String = ""
        Dim comentario As String = ""
        Dim tmp_comentario_reg As New comentario_reg

        Try
            ' Recojo los datos
            desde = Trim(Me.DesdeTxt.Text)
            asunto = Trim(Me.AsuntoTxt.Text)
            comentario = Trim(Me.ComentarioTxt.Text)

            ' Valido los datos
            If ValidarDatos(desde, asunto, comentario) Then
                With tmp_comentario_reg
                    .desde = desde
                    .asunto = asunto
                    .comentario = comentario
                    .fecha = DateTime.Now
                End With

                If insertar_comentario(tmp_comentario_reg, cadena_conexion) Then
                    EstadoDatos(False)
                Else
                    Throw New Exception()
                End If
            Else
                Throw New Exception()
            End If
        Catch ex As Exception
            MsgEstadoLbl.Text = "Ha habido un problema al enviar el comentario. Revise que la direcci&oacute;n de correo es v&aacute;lida."
            MsgEstadoPanel.Visible = True
            MsgEstadoLbl.CssClass = "rojo"
            Me.MsgEstadoImage.ImageUrl = icono_error
        End Try
    End Sub
End Class
